<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>Pour d&#233;marrer - Serveur HTTP Apache Version 2.4</title>
<link href="./style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="./style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="./style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="./style/css/prettify.css" />
<script src="./style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="./images/favicon.ico" rel="shortcut icon" /></head>
<body id="manual-page"><div id="page-header">
<p class="menu"><a href="./mod/">Modules</a> | <a href="./mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="./glossary.html">Glossaire</a> | <a href="./sitemap.html">Plan du site</a></p>
<p class="apache">Serveur HTTP Apache Version 2.4</p>
<img alt="" src="./images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="./images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="./">Version 2.4</a></div><div id="page-content"><div id="preamble"><h1>Pour d&#233;marrer</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="./en/getting-started.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="./fr/getting-started.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div>

<p>Si vous ne connaissez rien au serveur HTTP Apache, ou m&#234;me au
fonctionnement d'un site web, vous vous demandez probablement par o&#249;
commencer et quelles questions poser. Ce document vous permettra de
parcourir les bases du sujet.</p>
</div>
<div id="quickview"><a href="https://www.apache.org/foundation/contributing.html" class="badge"><img src="https://www.apache.org/images/SupportApache-small.png" alt="Support Apache!" /></a><ul id="toc"><li><img alt="" src="./images/down.gif" /> <a href="#clientserver">Clients, serveurs et URLs</a></li>
<li><img alt="" src="./images/down.gif" /> <a href="#dns">Noms d'h&#244;te et DNS</a></li>
<li><img alt="" src="./images/down.gif" /> <a href="#configuration">Fichiers de configuration et directives</a></li>
<li><img alt="" src="./images/down.gif" /> <a href="#content">Contenu du site web</a></li>
<li><img alt="" src="./images/down.gif" /> <a href="#logs">Fichiers journaux et r&#233;solution des probl&#232;mes</a></li>
<li><img alt="" src="./images/down.gif" /> <a href="#other">Et maintenant, quelle est la suite des op&#233;rations ?</a></li>
</ul><h3>Voir aussi</h3><ul class="seealso"><li><a href="#comments_section">Commentaires</a></li></ul></div>
<div class="top"><a href="#page-header"><img alt="top" src="./images/up.gif" /></a></div>
<div class="section">
<h2><a name="clientserver" id="clientserver">Clients, serveurs et URLs</a></h2>


<p>
Les adresses des pages web sur la Toile se pr&#233;sentent sous forme d'URLs
- Uniform Resource Locators - qui comportent un protocole (par
  exemple <code>http</code>), un nom de serveur (par exemple
  <code>www.apache.org</code>), un chemin (par exemple
  <code>/docs/current/getting-started.html</code>), et le cas &#233;ch&#233;ant
  une cha&#238;ne de requ&#234;te (query string) (par exemple <code>?arg=value</code>)
  permettant de transmettre des informations suppl&#233;mentaires au serveur.
</p>

<p>Un client (par exemple un navigateur web) se connecte &#224; un serveur
(par exemple votre serveur HTTP Apache) avec un protocole sp&#233;cifique, et
effectue une <strong>requ&#234;te</strong> pour une ressource en sp&#233;cifiant
son chemin.</p>

<p>Un chemin peut repr&#233;senter plusieurs types de ressources sur le
serveur. Ce peut &#234;tre un fichier (comme
<code>getting-started.html</code>), un gestionnaire (comme <a href="mod/mod_status.html">server-status</a>), ou toute sorte de
programme (comme <code>index.php</code>). Nous d&#233;crirons tout ceci plus
en d&#233;tails ci-dessous dans la section <a href="#content">Contenu d'un
site web</a>.</p>

<p>
Le serveur envoie alors une <strong>r&#233;ponse</strong> comportant un code
d'&#233;tat, et &#233;ventuellement un corps de r&#233;ponse. Le code d'&#233;tat indique si
la requ&#234;te a &#233;t&#233; trait&#233;e avec succ&#232;s, ou dans la n&#233;gative quel type
d'erreur a &#233;t&#233; rencontr&#233;. Le client est alors sens&#233; savoir quoi faire de
la r&#233;ponse. Vous pouvez vous familiariser avec les diff&#233;rents codes
d'&#233;tat en consultant le <a href="http://wiki.apache.org/httpd/CommonHTTPStatusCodes">Wiki du
serveur HTTP Apache</a>.</p>

<p>Les d&#233;tails de la transaction, ainsi que les erreurs rencontr&#233;es,
sont enregistr&#233;s dans des fichiers journaux. Tout ceci est d&#233;crit en
d&#233;tails ci-dessous dans la section <a href="#logs">D&#233;bogage et fichiers
journaux</a>.</p>

</div><div class="top"><a href="#page-header"><img alt="top" src="./images/up.gif" /></a></div>
<div class="section">
<h2><a name="dns" id="dns">Noms d'h&#244;te et DNS</a></h2>


<p>Pour se connecter &#224; un serveur, le client doit tout d'abord r&#233;soudre
le nom du serveur en adresse IP, cette derni&#232;re permettant de localiser
le serveur sur Internet. Ainsi, pour que votre serveur web soit
accessible, son nom doit &#234;tre enregistr&#233; dans le DNS.</p>

<p>Si vous ne savez pas comment effectuer cet enregistrement, vous
devrez contacter votre administrateur r&#233;seau ou votre fournisseur
d'acc&#232;s &#224; Internet afin qu'il effectue cette op&#233;ration pour vous.</p>

<p>Plusieurs noms d'h&#244;te peuvent pointer vers la m&#234;me adresse IP, et
plusieurs adresses IP peuvent &#234;tre attach&#233;es au m&#234;me serveur physique.
Vous pouvez ainsi h&#233;berger plusieurs serveurs web sur le m&#234;me serveur
physique gr&#226;ce au m&#233;canisme des <a href="vhosts/">serveurs virtuels</a>.</p>

<p>Pour tester un serveur non encore accessible sur Internet, vous
pouvez renseigner son nom d'h&#244;te dans votre fichier hosts afin
d'effectuer une r&#233;solution de nom locale. Par exemple, pour tester le
serveur web <code>www.example.com</code> depuis le serveur physique qui
l'h&#233;berge, vous pouvez ajouter la ligne suivante au fichier hosts de ce
dernier : </p>

<div class="example"><p><code>
127.0.0.1 www.example.com
</code></p></div>

<p>En g&#233;n&#233;ral, le fichier hosts se trouve dans le r&#233;pertoire
<code>/etc</code> sur les syst&#232;mes de style Unix, ou
<code>C:\Windows\system32\drivers\etc</code> sous Windows.</p>

<p>Vous trouverez plus de d&#233;tails &#224; propos du fichier hosts &#224; <a href="http://en.wikipedia.org/wiki/Hosts_(file)">Wikipedia.org/wiki/Hosts_(file)</a>,
et &#224; propos du DNS &#224; <a href="http://en.wikipedia.org/wiki/Domain_Name_System">Wikipedia.org/wiki/Domain_Name_System</a>.</p>
</div><div class="top"><a href="#page-header"><img alt="top" src="./images/up.gif" /></a></div>
<div class="section">
<h2><a name="configuration" id="configuration">Fichiers de configuration et directives</a></h2>


<p>La configuration du serveur HTTP Apache s'effectue via de simples
fichiers textes. Ces fichiers peuvent se trouver dans de nombreux
endroits diff&#233;rents en fonction du mode d'installation du serveur. Vous
trouverez les positions courantes de ces fichiers dans le <a href="http://wiki.apache.org/httpd/DistrosDefaultLayout">wiki httpd</a>.
Si vous installez httpd depuis le code source, le r&#233;pertoire par d&#233;faut
des fichiers de configuration est <code>/usr/local/apache2/conf</code>.
Le nom du fichier de configuration par d&#233;faut est en g&#233;n&#233;ral
<code>httpd.conf</code>, mais peut aussi varier en fonction des
distributions tierces du serveur.</p>

<p>L'ensemble de la configuration est en g&#233;n&#233;ral divis&#233; en plusieurs
fichiers afin d'en faciliter la gestion. Ces fichiers sont inclus dans
le fichier de configuration principal via la directive <code class="directive"><a href="./mod/core.html#include">Include</a></code>. Les noms ou positions de ces fichiers
ne sont pas fig&#233;s et peuvent varier consid&#233;rablement d'une distribution
&#224; l'autre. N'h&#233;sitez pas &#224; les arranger et subdiviser selon
<strong>vos</strong> go&#251;ts et besoins, quitte &#224; en modifier
l'organisation par d&#233;faut.</p>

<p>La configuration du serveur s'effectue via des <a href="mod/quickreference.html">directives de configuration</a> que l'on
ins&#232;re dans les fichiers de configuration. Une directive se compose d'un
mot-cl&#233; suivi d'un ou plusieurs arguments qui d&#233;finissent sa valeur.</p>

<p>La r&#233;ponse &#224; la question "<em>O&#249; dois-je placer cette directive
?</em>" d&#233;pend en g&#233;n&#233;ral du niveau auquel cette directive doit &#234;tre
prise en compte. S'il s'agit du niveau global, elle doit &#234;tre plac&#233;e
dans le fichier de configuration principal, et en dehors de toute
section  <code class="directive"><a href="./mod/core.html#directory">&lt;Directory&gt;</a></code>, <code class="directive"><a href="./mod/core.html#location">&lt;Location&gt;</a></code>, <code class="directive"><a href="./mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>, ou de toute autre section. Si
par exemple elle ne doit s'appliquer qu'&#224; un r&#233;pertoire particulier,
elle doit &#234;tre plac&#233;e dans la section <code class="directive"><a href="./mod/core.html#directory">&lt;Directory&gt;</a></code> qui fait r&#233;f&#233;rence &#224; ce r&#233;pertoire.
Voir la documentation sur les <a href="sections.html">Sections de
configuration</a> pour plus de d&#233;tails.</p>

<p>En compl&#233;ment des fichiers de configuration principaux, certaines
directives peuvent &#234;tre ins&#233;r&#233;es dans des fichiers
<code>.htaccess</code> que l'on place directement dans le r&#233;pertoire
concern&#233;. Les fichiers <code>.htaccess</code> sont essentiellement
destin&#233;s aux personnes qui n'ont pas acc&#232;s aux fichiers de configuration
du serveur. Vous trouverez plus de d&#233;tails &#224; propos des fichiers
<code>.htaccess</code> dans ce <a href="howto/htaccess.html"><code>.htaccess</code>howto</a>.</p>

</div><div class="top"><a href="#page-header"><img alt="top" src="./images/up.gif" /></a></div>
<div class="section">
<h2><a name="content" id="content">Contenu du site web</a></h2>


<p>Si le contenu du site web peut se pr&#233;senter sous de nombreuses
formes, il peut en g&#233;n&#233;ral &#234;tre scind&#233; en deux formes principales : les
contenus statiques et les contenus dynamiques.</p>

<p>Les contenus statiques sont par exemple les fichiers HTML, les
images, les fichiers CSS et tout autre fichier r&#233;sidant dans le syst&#232;me
de fichiers. La directive <code class="directive"><a href="./mod/core.html#documentroot">DocumentRoot</a></code> permet de d&#233;finir la position
dans l'arborescence du site o&#249; vous devez placer ces fichiers. Cette
directive peut &#234;tre d&#233;finie au niveau global, ou au niveau de chaque
serveur virtuel. Vous pouvez consulter vos fichiers de configuration
pour v&#233;rifier la mani&#232;re dont cette directive est d&#233;finie pour votre
serveur.</p>

<p>En g&#233;n&#233;ral, et si aucun nom de fichier n'est sp&#233;cifi&#233; dans la
requ&#234;te, c'est une page de nom <code>index.html</code> qui sera
renvoy&#233;e. Par exemple, si la directive <code>DocumentRoot</code> est
d&#233;finie &#224; <code>/var/www/html</code>, et si une requ&#234;te est effectu&#233;e
pour l'adresse <code>http://www.example.com/work/</code>, c'est le
fichier <code>/var/www/html/work/index.html</code> qui sera envoy&#233; au
client par le serveur.</p>

<p>Un contenu dynamique est un contenu qui est g&#233;n&#233;r&#233; au moment du
traitement de la requ&#234;te, et qui peut diff&#233;rer d'une requ&#234;te &#224; l'autre.
Ces contenus dynamiques peuvent &#234;tre g&#233;n&#233;r&#233;s de nombreuses mani&#232;res par
l'interm&#233;diaire de <a href="handler.html">gestionnaires de contenu</a>
ou "handlers". Il est aussi possible de cr&#233;er des <a href="howto/cgi.html">programmes CGI</a> pour g&#233;n&#233;rer le contenu de
votre site.</p>

<p>Enfin, on peut utiliser des modules tiers comme mod_php pour &#233;crire
du code permettant d'effectuer de nombreuses choses. De nombreuses
applications tierces &#233;crites &#224; partir de divers langages ou outils sont
disponibles en t&#233;l&#233;chargement et peuvent &#234;tre install&#233;es sur votre
serveur HTTP Apache. Le support de ces applications d&#233;passe le sujet de
ce document, et nous vous invitons &#224; consulter le site de leur &#233;diteur
pour acc&#233;der &#224; leur documentation.</p>
</div><div class="top"><a href="#page-header"><img alt="top" src="./images/up.gif" /></a></div>
<div class="section">
<h2><a name="logs" id="logs">Fichiers journaux et r&#233;solution des probl&#232;mes</a></h2>

<p>En tant qu'administrateur d'un serveur HTTP Apache, vos sources
d'informations principales sont les fichiers journaux, et en particulier
le journal des erreurs. Toute tentative de r&#233;solution d'un probl&#232;me sans
consulter le journal des erreurs revient &#224; conduire les yeux ferm&#233;s.</p>

<p>La position dans le syst&#232;me de fichiers du journal des erreurs est
sp&#233;cifi&#233;e par la directive <code class="directive"><a href="./mod/core.html#errorlog">ErrorLog</a></code>
qui peut &#234;tre d&#233;finie au niveau global, ou au niveau de chaque serveur
virtuel. Chaque entr&#233;e du journal des erreurs vous informe sur la nature
des probl&#232;mes et le moment de leur survenue. En outre, elle vous indique
souvent comment r&#233;soudre le probl&#232;me. Chaque message d'erreur contient
un code d'erreur que vous pouvez utiliser pour effectuer une recherche
en ligne afin d'obtenir une description plus d&#233;taill&#233;e de la mani&#232;re de
r&#233;soudre le probl&#232;me. Vous pouvez aussi configurer votre journal des
erreurs de mani&#232;re &#224; ce qu'il enregistre un identifiant d'erreur que
vous pourrez ensuite utiliser pour effectuer une corr&#233;lation avec le
journal des acc&#232;s afin de d&#233;terminer quelle requ&#234;te est &#224; l'origine de
l'erreur.</p>

<p>Vous trouverez plus de d&#233;tails &#224; ce sujet dans la <a href="logs.html">Documentation sur la journalisation</a>.</p>
</div><div class="top"><a href="#page-header"><img alt="top" src="./images/up.gif" /></a></div>
<div class="section">
<h2><a name="other" id="other">Et maintenant, quelle est la suite des op&#233;rations ?</a></h2>


<p>La question des pr&#233;requis &#233;tant r&#233;gl&#233;e, il est temps de passer aux
choses s&#233;rieuses.</p>

<p>Ce document ne couvre que les notions de base. Nous esp&#233;rons qu'il
vous permettra de mettre le pied &#224; l'&#233;trier, mais il y a encore de
nombreuses choses que vous devez savoir.</p>

<ul>
<li><a href="http://httpd.apache.org/download.cgi">T&#233;l&#233;chargement</a></li>
<li><a href="install.html">Installation</a></li>
<li><a href="configuring.html">Configuration</a></li>
<li><a href="invoking.html">D&#233;marrage du serveur</a></li>
<li><a href="http://wiki.apache.org/httpd/FAQ">Foire aux questions</a></li>
</ul>

</div></div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="./en/getting-started.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="./fr/getting-started.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="./images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/getting-started.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2018 The Apache Software Foundation.<br />Autoris&#233; sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="./mod/">Modules</a> | <a href="./mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="./glossary.html">Glossaire</a> | <a href="./sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>