<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>mod_cache - Serveur HTTP Apache Version 2.4</title>
<link href="../style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="../style/css/prettify.css" />
<script src="../style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="../images/favicon.ico" rel="shortcut icon" /></head>
<body>
<div id="page-header">
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p>
<p class="apache">Serveur HTTP Apache Version 2.4</p>
<img alt="" src="../images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="../">Version 2.4</a> &gt; <a href="./">Modules</a></div>
<div id="page-content">
<div id="preamble"><h1>Module Apache mod_cache</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_cache.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_cache.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a> |
<a href="../ja/mod/mod_cache.html" hreflang="ja" rel="alternate" title="Japanese">&nbsp;ja&nbsp;</a> |
<a href="../ko/mod/mod_cache.html" hreflang="ko" rel="alternate" title="Korean">&nbsp;ko&nbsp;</a></p>
</div>
<table class="module"><tr><th><a href="module-dict.html#Description">Description:</a></th><td>Filtre de mise en cache HTTP conforme &#224; la RFC 2616</td></tr>
<tr><th><a href="module-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">Identificateur&#160;de&#160;Module:</a></th><td>cache_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">Fichier&#160;Source:</a></th><td>mod_cache.c</td></tr></table>
<h3>Sommaire</h3>

    <div class="warning">Ce module doit &#234;tre utilis&#233; avec pr&#233;cautions
    car lorsque la directive <code class="directive"><a href="#cachequickhandler">CacheQuickHandler</a></code> est d&#233;finie &#224; sa
    valeur par d&#233;faut <strong>on</strong>, les directives <code class="directive"><a href="../mod/mod_access_compat.html#allow">Allow</a></code> and <code class="directive"><a href="../mod/mod_access_compat.html#deny">Deny</a></code> sont court-circuit&#233;es. Vous
    ne devez donc pas activer la gestion rapide de la mise en cache pour
    un contenu auquel vous souhaitez limiter l'acc&#232;s en fonction du nom
    d'h&#244;te du client, de l'adresse IP ou d'une variable
    d'environnement.</div>

    <p><code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> impl&#233;mente un <strong>filtre de mise
    en cache de contenu HTTP</strong> conforme &#224; la <a href="http://www.ietf.org/rfc/rfc2616.txt">RFC 2616</a>, avec
    support de la mise en cache des r&#233;ponses dont le contenu a &#233;t&#233;
    n&#233;goci&#233; et comportant l'en-t&#234;te Vary.</p>

    <p>La mise en cache conforme &#224; la RFC 2616 fournit un m&#233;canisme
    permettant de v&#233;rifier si un contenu expir&#233; ou d&#233;pass&#233; est encore &#224;
    jour, et peut apporter un gain de performances significatif si le
    serveur original supporte les <strong>requ&#234;tes
    conditionnelles</strong> en prenant en compte l'en-t&#234;te de requ&#234;te
    HTTP <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.26">If-None-Match</a>.
    Le contenu n'est ainsi r&#233;g&#233;n&#233;r&#233; que lorsqu'il a &#233;t&#233; modifi&#233;, et non
    lorsqu'il a expir&#233;.</p>

    <p>En tant que filtre, <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> peut &#234;tre plac&#233;
    en face d'un contenu issu de tout gestionnaire, y compris
    <strong>des fichiers &#224; acc&#232;s s&#233;quentiel</strong> (servis depuis un
    disque lent mis en
    cache sur un gros disque), la sortie d'un <strong>script
    CGI</strong> ou d'un <strong>g&#233;n&#233;rateur de contenu
    dynamique</strong>, ou du contenu <strong>mandat&#233; depuis un autre
    serveur</strong>.</p>

    <p>Dans la configuration par d&#233;faut, <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code>
    place le filtre de mise en cache aussi loin que possible dans la
    pile de filtres, utilisant le <strong>gestionnaire rapide</strong>
    pour court-circuiter tout traitement par requ&#234;te lors de l'envoi du
    contenu au client. Dans ce mode op&#233;ratoire,
    <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> peut &#234;tre consid&#233;r&#233; comme un serveur
    mandataire avec cache fix&#233; en t&#234;te du serveur web, alors qu'il
    s'ex&#233;cute dans ce m&#234;me serveur web.</p>

    <p>Lorsque le gestionnaire rapide est d&#233;sactiv&#233; via la directive
    <code class="directive"><a href="#cachequickhandler">CacheQuickHandler</a></code>, il
    devient possible d'ins&#233;rer le filtre <strong>CACHE</strong> &#224; un
    point de la pile de filtres choisi par l'administrateur. Ceci permet
    de mettre en cache un contenu avant que celui-ci ne soit
    personnalis&#233; par le filtre <code class="module"><a href="../mod/mod_include.html">mod_include</a></code>, ou
    &#233;ventuellement compress&#233; par le filtre <code class="module"><a href="../mod/mod_deflate.html">mod_deflate</a></code>.</p>

    <p>Dans le mode de fonctionnement normal, <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code>
    peut &#234;tre contr&#244;l&#233; par les en-t&#234;tes <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.9">Cache-Control</a>
    et <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.32">Pragma</a>
    envoy&#233;s par un client dans une requ&#234;te, ou par un serveur dans une
    r&#233;ponse. Dans des circonstances exceptionnelles,
    <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> peut cependant &#234;tre configur&#233; pour
    outrepasser ces en-t&#234;tes et forcer un comportement sp&#233;cifique au
    site, bien qu'un tel comportement sera limit&#233; &#224; ce cache seulement,
    et n'affectera pas les op&#233;rations des autres caches qui peuvent
    s'ins&#233;rer entre le client et le serveur, et ce type de configuration
    ne doit donc &#234;tre utiliser qu'en cas de n&#233;cessit&#233; absolue.</p>

    <p>La RFC 2616 permet au cache de renvoyer des donn&#233;es p&#233;rim&#233;es
    pendant que l'entr&#233;e p&#233;rim&#233;e correspondante est mise &#224; jour depuis
    le serveur original, et <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> supporte cette
    fonctionnalit&#233; lorsque la directive <code class="directive"><a href="#cachelock">CacheLock</a></code> est configur&#233;e en
    cons&#233;quence. De telles r&#233;ponses comportent un en-t&#234;te HTTP <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.46">Warning</a>
    contenant un code de r&#233;ponse 110. La RFC 2616 permet aussi au cache
    de renvoyer des donn&#233;es p&#233;rim&#233;es lorsque la tentative de mise &#224; jour
    des donn&#233;es p&#233;rim&#233;es renvoie une erreur 500 ou sup&#233;rieure, et cette
    fonctionnalit&#233; est support&#233;e par d&#233;faut par
    <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code>. De telles r&#233;ponses comportent un en-t&#234;te HTTP <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.46">Warning</a>
    contenant un code de r&#233;ponse 111.</p>

    <p><code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> requiert les services d'un ou
    plusieurs modules de gestion de stockage. La distribution Apache de base
    inclut les modules de gestion de stockage suivants :</p>
    <dl>
    <dt><code class="module"><a href="../mod/mod_cache_disk.html">mod_cache_disk</a></code></dt>

    <dd>impl&#233;mente un gestionnaire de stockage sur disque. Les en-t&#234;tes
    et corps sont stock&#233;s s&#233;par&#233;ment sur le disque dans une structure de
    r&#233;pertoires bas&#233;e sur le condens&#233; md5 de l'URL mise en cache.
    Plusieurs r&#233;ponses &#224; contenu n&#233;goci&#233; peuvent &#234;tre stock&#233;es en m&#234;me
    temps, mais la mise en cache de contenus partiels n'est pas
    support&#233;e par ce module. L'utilitaire
    <code class="program"><a href="../programs/htcacheclean.html">htcacheclean</a></code> permet de lister et de supprimer les
    URLs mises en cache, et de maintenir le cache en de&#231;&#224; de
    certaines limites de taille et de nombre d'inodes.</dd>
    <dt><code class="module"><a href="../mod/mod_cache_socache.html">mod_cache_socache</a></code></dt>
    <dd>Impl&#233;mente un gestionnaire de stockage bas&#233; sur un cache d'objets
    partag&#233;s. Les en-t&#234;tes et corps sont stock&#233;s ensemble sous une seule
    cl&#233; bas&#233;e sur l'URL de la r&#233;ponse mise en cache. Des r&#233;ponses &#224;
    contenus multiples n&#233;goci&#233;s peuvent &#234;tre stock&#233;es simultan&#233;ment, mais
    ce module ne supporte pas la mise en cache de contenus partiels.</dd>
    </dl>

    <p>Pour de plus amples d&#233;tails, une description, et des exemples,
    reportez-vous au <a href="../caching.html">Guide de la mise en
    cache</a>.</p>
</div>
<div id="quickview"><a href="https://www.apache.org/foundation/contributing.html" class="badge"><img src="https://www.apache.org/images/SupportApache-small.png" alt="Support Apache!" /></a><h3>Sujets</h3>
<ul id="topics">
<li><img alt="" src="../images/down.gif" /> <a href="#related">Modules apparent&#233;s et directives</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sampleconf">Exemple de configuration</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#thunderingherd">Eviter une temp&#234;te de requ&#234;te</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#finecontrol">Contr&#244;le fin via le filtre CACHE</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#status">Etat du cache et journalisation</a></li>
</ul><h3 class="directives">Directives</h3>
<ul id="toc">
<li><img alt="" src="../images/down.gif" /> <a href="#cachedefaultexpire">CacheDefaultExpire</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachedetailheader">CacheDetailHeader</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachedisable">CacheDisable</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheenable">CacheEnable</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheheader">CacheHeader</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheignorecachecontrol">CacheIgnoreCacheControl</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheignoreheaders">CacheIgnoreHeaders</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheignorenolastmod">CacheIgnoreNoLastMod</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheignorequerystring">CacheIgnoreQueryString</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheignoreurlsessionidentifiers">CacheIgnoreURLSessionIdentifiers</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachekeybaseurl">CacheKeyBaseURL</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachelastmodifiedfactor">CacheLastModifiedFactor</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachelock">CacheLock</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachelockmaxage">CacheLockMaxAge</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachelockpath">CacheLockPath</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachemaxexpire">CacheMaxExpire</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cacheminexpire">CacheMinExpire</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachequickhandler">CacheQuickHandler</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachestaleonerror">CacheStaleOnError</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachestoreexpired">CacheStoreExpired</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachestorenostore">CacheStoreNoStore</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cachestoreprivate">CacheStorePrivate</a></li>
</ul>
<h3>Traitement des bugs</h3><ul class="seealso"><li><a href="https://www.apache.org/dist/httpd/CHANGES_2.4">Journal des modifications de httpd</a></li><li><a href="https://bz.apache.org/bugzilla/buglist.cgi?bug_status=__open__&amp;list_id=144532&amp;product=Apache%20httpd-2&amp;query_format=specific&amp;order=changeddate%20DESC%2Cpriority%2Cbug_severity&amp;component=mod_cache">Probl&#232;mes connus</a></li><li><a href="https://bz.apache.org/bugzilla/enter_bug.cgi?product=Apache%20httpd-2&amp;component=mod_cache">Signaler un bug</a></li></ul><h3>Voir aussi</h3>
<ul class="seealso">
<li><a href="../caching.html">Guide de la mise en
cache</a></li>
<li><a href="#comments_section">Commentaires</a></li></ul></div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="related" id="related">Modules apparent&#233;s et directives</a></h2>
    <table class="related"><tr><th>Modules Apparent&#233;s</th><th>Directives Apparent&#233;es</th></tr><tr><td><ul><li><code class="module"><a href="../mod/mod_cache_socache.html">mod_cache_socache</a></code></li></ul></td><td><ul><li><code class="directive"><a href="../mod/mod_cache_disk.html#cacheroot">CacheRoot</a></code></li><li><code class="directive"><a href="../mod/mod_cache_disk.html#cachedirlevels">CacheDirLevels</a></code></li><li><code class="directive"><a href="../mod/mod_cache_disk.html#cachedirlength">CacheDirLength</a></code></li><li><code class="directive"><a href="../mod/mod_cache_disk.html#cacheminfilesize">CacheMinFileSize</a></code></li><li><code class="directive"><a href="../mod/mod_cache_disk.html#cachemaxfilesize">CacheMaxFileSize</a></code></li><li><code class="directive"><a href="../mod/mod_cache_socache.html#cachesocache">CacheSocache</a></code></li><li><code class="directive"><a href="../mod/mod_cache_socache.html#cachesocachemaxtime">CacheSocacheMaxTime</a></code></li><li><code class="directive"><a href="../mod/mod_cache_socache.html#cachesocachemintime">CacheSocacheMinTime</a></code></li><li><code class="directive"><a href="../mod/mod_cache_socache.html#cachesocachemaxsize">CacheSocacheMaxSize</a></code></li><li><code class="directive"><a href="../mod/mod_cache_socache.html#cachesocachereadsize">CacheSocacheReadSize</a></code></li><li><code class="directive"><a href="../mod/mod_cache_socache.html#cachesocachereadtime">CacheSocacheReadTime</a></code></li></ul></td></tr></table>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="sampleconf" id="sampleconf">Exemple de configuration</a></h2>
    <div class="example"><h3>Extrait de httpd.conf</h3><pre class="prettyprint lang-config">#
# Exemple de configuration du cache
#
LoadModule cache_module modules/mod_cache.so
&lt;IfModule mod_cache.c&gt;
    LoadModule cache_disk_module modules/mod_cache_disk.so
    &lt;IfModule mod_cache_disk.c&gt;
        CacheRoot "c:/cacheroot"
        CacheEnable disk  "/"
        CacheDirLevels 5
        CacheDirLength 3
    &lt;/IfModule&gt;
    
    # Lorsqu'on sert de mandataire, on ne met pas en cache la liste
# des mises &#224; jour de s&#233;curit&#233;
    CacheDisable "http://security.update.server/update-list/"
&lt;/IfModule&gt;</pre>
</div>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="thunderingherd" id="thunderingherd">Eviter une temp&#234;te de requ&#234;te</a></h2>
  <p>Lorsqu'une entr&#233;e du cache est p&#233;rim&#233;e, <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code>
  soumet une requ&#234;te conditionnelle au processus d'arri&#232;re-plan, qui est
  cens&#233; confirmer la validit&#233; de l'entr&#233;e du cache, ou dans la n&#233;gative
  envoyer une entr&#233;e mise &#224; jour.</p>
  <p>Un court mais non n&#233;gligeable laps de temps existe entre le moment
  o&#249; l'entr&#233;e du cache est p&#233;rim&#233;e, et le moment o&#249; elle est mise &#224;
  jour. Sur un serveur fortement charg&#233;, un certain nombre de requ&#234;tes
  peut arriver pendant ce laps de temps, et provoquer une
  <strong>temp&#234;te</strong> de requ&#234;tes susceptibles de saturer le
  processus d'arri&#232;re-plan de mani&#232;re soudaine et impr&#233;dictible.</p>
  <p>Pour contenir cette temp&#234;te, on peut utiliser la directive
  <code class="directive">CacheLock</code> afin de d&#233;finir un r&#233;pertoire o&#249;
  seront cr&#233;&#233;s <strong>&#224; la vol&#233;e</strong> des verrous pour les URLs.
  Ces verrous sont utilis&#233;s comme autant d'<strong>indications</strong>
  par les autres requ&#234;tes, soit pour emp&#234;cher une tentative de mise en
  cache (un autre processus est en train de r&#233;cup&#233;rer l'entit&#233;), soit
  pour indiquer qu'une entr&#233;e p&#233;rim&#233;e est en cours de mise &#224; jour
  (pendant ce temps, c'est le contenu p&#233;rim&#233; qui sera renvoy&#233;).
  </p>
  <h3>Mise en cache initiale d'une entr&#233;e</h3>
    
    <p>Lorsqu'une entit&#233; est mise en cache pour la premi&#232;re fois, un
    verrou est cr&#233;&#233; pour cette entit&#233; jusqu'&#224; ce que la r&#233;ponse ait &#233;t&#233;
    enti&#232;rement mise en cache. Pendant la dur&#233;e de vie du verrou, le
    cache va emp&#234;cher une seconde tentative de mise en cache de la m&#234;me
    entit&#233;. Bien que cela ne suffise pas &#224; contenir la temp&#234;te de
    requ&#234;tes, toute tentative de mettre en cache la m&#234;me entit&#233;
    plusieurs fois simultan&#233;ment est stopp&#233;e.
    </p>
  
  <h3>Mise &#224; jour d'une entr&#233;e p&#233;rim&#233;e</h3>
    
    <p>Lorsqu'une entr&#233;e atteint la limite de sa dur&#233;e de vie, et
    devient par cons&#233;quent p&#233;rim&#233;e, un verrou est cr&#233;&#233; pour cette entit&#233;
    jusqu'&#224; ce que la r&#233;ponse ait &#233;t&#233; soit confirm&#233;e comme encore
    valide, soit remplac&#233;e par le processus d'arri&#232;re-plan. Pendant la
    dur&#233;e de vie du verrou, une seconde requ&#234;te entrante va provoquer le
    renvoi de la donn&#233;e p&#233;rim&#233;e, et la temp&#234;te de requ&#234;tes sera
    contenue.</p>
  
  <h3>Verrous et en-t&#234;te Cache-Control: no-cache</h3>
    
    <p>Les verrous ne sont utilis&#233;s <strong>qu'&#224; titre
    indicatif</strong> pour enjoindre le cache &#224; &#234;tre plus coop&#233;ratif
    avec les serveurs d'arri&#232;re-plan, et il est possible de passer outre
    si n&#233;cessaire. Si le client envoie une requ&#234;te contenant un en-t&#234;te
    Cache-Control imposant un nouveau t&#233;l&#233;chargement de l'entit&#233;, tout
    verrou &#233;ventuel sera ignor&#233;, la requ&#234;te du client sera honor&#233;e
    imm&#233;diatement, et l'entr&#233;e du cache mise &#224; jour.</p>

    <p>Comme m&#233;canisme de s&#233;curit&#233; suppl&#233;mentaire, la dur&#233;e de vie
    maximale des verrous est configurable. Lorsque cette limite est
    atteinte, le verrou est supprim&#233; et une autre requ&#234;te peut alors en
    cr&#233;er un nouveau. Cette dur&#233;e de vie peut &#234;tre d&#233;finie via la
    directive <code class="directive">CacheLockMaxAge</code>, et sa valeur par
    d&#233;faut est de 5 secondes.
    </p>
  
  <h3>Exemple de configuration</h3>
    
    <div class="example"><h3>Activation du verrouillage du cache</h3><pre class="prettyprint lang-config">#
# Active le verrouillage du cache
#
&lt;IfModule mod_cache.c&gt;
    CacheLock on
    CacheLockPath "/tmp/mod_cache-lock"
    CacheLockMaxAge 5
&lt;/IfModule&gt;</pre>
</div>
  
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="finecontrol" id="finecontrol">Contr&#244;le fin via le filtre CACHE</a></h2>
  <p>Dans son mode de fonctionnement par d&#233;faut, le cache s'ex&#233;cute sous
  la forme d'un gestionnaire rapide, court-circuitant la majorit&#233; des
  traitements du serveur et fournissant ainsi une mise en cache
  poss&#233;dant les plus hautes performances disponibles.</p>

  <p>Dans ce mode, le cache <strong>s'incruste</strong> devant le
  serveur, comme si un mandataire de mise en cache ind&#233;pendant RFC 2616
  &#233;tait plac&#233; devant ce dernier.</p>

  <p>Bien que que ce mode offre les meilleures performances, les
  administrateurs peuvent souhaiter, dans certaines circonstances,
  effectuer des traitements sur la requ&#234;te apr&#232;s que cette derni&#232;re ait
  &#233;t&#233; mise en cache, comme ajouter du contenu personnalis&#233; &#224; la page
  mise en cache, ou appliquer des restrictions d'autorisations au
  contenu. Pour y parvenir, l'administrateur sera alors souvent forc&#233; de
  placer des serveurs mandataires inverses ind&#233;pendants soit derri&#232;re,
  soit devant le serveur de mise en cache.</p>

  <p>Pour r&#233;soudre ce probl&#232;me, la directive <code class="directive"><a href="#cachequickhandler">CacheQuickHandler</a></code> peut &#234;tre d&#233;finie &#224;
  <strong>off</strong>, afin que le serveur traite toutes les phases
  normalement ex&#233;cut&#233;es par une requ&#234;te non mise en cache, y compris les
  phases <strong>d'authentification et d'autorisation</strong>.</p>

  <p>En outre, l'administrateur peut &#233;ventuellement sp&#233;cifier le
  <strong>point pr&#233;cis dans la cha&#238;ne de filtrage</strong> o&#249; devra
  intervenir la mise en cache en ajoutant le filtre
  <strong>CACHE</strong> &#224; la cha&#238;ne de filtrage en sortie.</p>

  <p>Par exemple, pour mettre en cache le contenu avant d'appliquer une
  compression &#224; la r&#233;ponse, placez le filtre <strong>CACHE</strong>
  avant le filtre <strong>DEFLATE</strong> comme dans l'exemple suivant
  :</p>

  <pre class="prettyprint lang-config"># Mise en cache du contenu avant la compression optionnelle
CacheQuickHandler off
AddOutputFilterByType CACHE;DEFLATE text/plain</pre>


  <p>Une autre possibilit&#233; consiste &#224; mettre en cache le contenu avant
  l'ajout de contenu personnalis&#233; via <code class="module"><a href="../mod/mod_include.html">mod_include</a></code> (ou
  tout autre filtre de traitement de contenu). Dans l'exemple suivant,
  les mod&#232;les contenant des balises comprises par
  <code class="module"><a href="../mod/mod_include.html">mod_include</a></code> sont mis en cache avant d'&#234;tre
  interpr&#233;t&#233;s :</p>

  <pre class="prettyprint lang-config"># Mise en cache du contenu avant l'intervention de mod_include et
   # mod_deflate
CacheQuickHandler off
AddOutputFilterByType CACHE;INCLUDES;DEFLATE text/html</pre>


  <p>Vous pouvez ins&#233;rer le filtre <strong>CACHE</strong> en tout point
  de la cha&#238;ne de filtrage. Dans l'exemple suivant, le contenu est mis
  en cache apr&#232;s avoir &#233;t&#233; interpr&#233;t&#233; par <code class="module"><a href="../mod/mod_include.html">mod_include</a></code>,
  mais avant d'&#234;tre trait&#233; par <code class="module"><a href="../mod/mod_deflate.html">mod_deflate</a></code> :</p>

  <pre class="prettyprint lang-config"># Mise en cache du contenu entre les interventions de mod_include et
   # mod_deflate
CacheQuickHandler off
AddOutputFilterByType INCLUDES;CACHE;DEFLATE text/html</pre>


  <div class="warning"><h3>Avertissement :</h3>Si pour une raison
  ou pour une autre, le point d'insertion du filtre
  <strong>CACHE</strong> dans la cha&#238;ne de filtrage est modifi&#233;, vous
  devez <strong>vider votre cache</strong> pour &#234;tre s&#251;r que les donn&#233;es
  servies soient &#224; jour. En effet, <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> n'est pas
  en mesure d'effectuer cette op&#233;ration &#224; votre place.</div>

</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="status" id="status">Etat du cache et journalisation</a></h2>
  <p>Lorsque <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> a d&#233;cid&#233; s'il devait ou non
  servir une entit&#233; depuis le cache, les raisons pr&#233;cises de cette
  d&#233;cision sont enregistr&#233;es dans l'environnement du sous-processus
  interne &#224; la requ&#234;te sous la cl&#233; <strong>cache-status</strong>.
  Cette information peut &#234;tre journalis&#233;e via la directive <code class="directive"><a href="../mod/mod_log_config.html#logformat">LogFormat</a></code> comme suit :</p>

  <pre class="prettyprint lang-config">LogFormat "%{cache-status}e ..."</pre>


  <p>En fonction de la d&#233;cision prise, l'information est aussi &#233;crite
  dans l'environnement du sous-processus sous une des quatre cl&#233;s
  suivantes :</p>

  <dl>
    <dt>cache-hit</dt><dd>Le contenu a &#233;t&#233; servi depuis le cache.</dd>
    <dt>cache-revalidate</dt><dd>Le contenu du cache &#233;tait p&#233;rim&#233;, a &#233;t&#233;
    mis &#224; jour avec succ&#232;s, puis servi depuis le cache.</dd>
    <dt>cache-miss</dt><dd>Le contenu n'&#233;tait pas dans le cache et a &#233;t&#233;
    servi directement depuis le serveur demand&#233;.</dd>
    <dt>cache-invalidate</dt><dd>L'entit&#233; du cache est devenue invalide
    suite &#224; une requ&#234;te d'un type autre que GET ou HEAD.</dd>
  </dl>

  <p>Il est alors possible d'envisager une journalisation conditionnelle
  du traitement des requ&#234;tes par rapport au cache comme dans l'exemple
  suivant :</p>

  <pre class="prettyprint lang-config">CustomLog "cached-requests.log" common env=cache-hit
CustomLog "uncached-requests.log" common env=cache-miss
CustomLog "revalidated-requests.log" common env=cache-revalidate
CustomLog "invalidated-requests.log" common env=cache-invalidate</pre>


  <p>Pour les concepteurs de modules, une accroche (hook) nomm&#233;e
  <var>cache_status</var> est disponible et permet aux modules de
  r&#233;pondre aux r&#233;sultats de la v&#233;rification du cache ci-dessus de mani&#232;re
  personnalis&#233;e.</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachedefaultexpire" id="cachedefaultexpire">Directive</a> <a name="CacheDefaultExpire" id="CacheDefaultExpire">CacheDefaultExpire</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La dur&#233;e par d&#233;faut de mise en cache d'un document
lorsqu'aucune date d'expiration n'a &#233;t&#233; sp&#233;cifi&#233;e.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheDefaultExpire <var>secondes</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheDefaultExpire 3600 (une heure)</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>La directive <code class="directive">CacheDefaultExpire</code> permet de
    sp&#233;cifier un temps par d&#233;faut, en secondes, pendant lequel sera
    conserv&#233; dans le cache un document qui ne poss&#232;de ni date
    d'expiration, ni date de derni&#232;re modification. La valeur de cette
    directive est &#233;cras&#233;e par la valeur de la directive
    <code class="directive">CacheMaxExpire</code> si cette derni&#232;re est
    utilis&#233;e.</p>

    <pre class="prettyprint lang-config">CacheDefaultExpire 86400</pre>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachedetailheader" id="cachedetailheader">Directive</a> <a name="CacheDetailHeader" id="CacheDetailHeader">CacheDetailHeader</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ajoute un en-t&#234;te X-Cache-Detail &#224; la r&#233;ponse.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheDetailHeader <var>on|off</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheDetailHeader off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.3.9 d'Apache</td></tr>
</table>
  <p>Lorsque la directive <code class="directive"><a href="#cachedetailheader">CacheDetailHeader</a></code> est d&#233;finie &#224; on, un
  en-t&#234;te <strong>X-Cache-Detail</strong> est ajout&#233; &#224; la r&#233;ponse et
  contient les raisons pr&#233;cises d'une d&#233;cision d'utilisation du cache
  vis &#224; vis de cette derni&#232;re.</p>

  <p>Ceci peut s'av&#233;rer utile au cours du d&#233;veloppement de services
  RESTful mis en cache pour obtenir des informations suppl&#233;mentaires &#224;
  propos des d&#233;cisions vis &#224; vis du cache &#233;crites dans les en-t&#234;tes de
  la r&#233;ponse. Il est ainsi possible de v&#233;rifier si
  <code>Cache-Control</code> et d'autres en-t&#234;tes ont &#233;t&#233; correctement
  utilis&#233;s par le service et le client.</p>

  <p>Si le gestionnaire normal est utilis&#233;, cette directive peut se
  situer dans une section <code class="directive"><a href="../mod/core.html#directory">&lt;Directory&gt;</a></code> ou <code class="directive"><a href="../mod/core.html#location">&lt;Location&gt;</a></code>. Si c'est le gestionnaire
  rapide qui est utilis&#233;, elle doit se situer dans un contexte de
  serveur principal ou de serveur virtuel, sinon elle sera ignor&#233;e.</p>

  <pre class="prettyprint lang-config"># Active l'en-t&#234;te X-Cache-Detail
CacheDetailHeader on</pre>


  <div class="example"><p><code>
    X-Cache-Detail: "conditional cache hit: entity refreshed" from localhost<br />
  </code></p></div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachedisable" id="cachedisable">Directive</a> <a name="CacheDisable" id="CacheDisable">CacheDisable</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;sactive la mise en cache des URLs
sp&#233;cifi&#233;es</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheDisable <var>cha&#238;ne-url</var> | <var>on</var></code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>La directive <code class="directive">CacheDisable</code> enjoint
    <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> de <em>ne pas</em> mettre en cache l'URL
    sp&#233;cifi&#233;e par <var>cha&#238;ne URL</var>, ainsi que les URLs de niveaux
    inf&#233;rieurs.</p>

    <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">CacheDisable "/fichiers_locaux"</pre>
</div>

    <p>Si la directive se trouve &#224; l'int&#233;rieur d'une section <code class="directive">&lt;Location&gt;</code>, le chemin doit &#234;tre sp&#233;cifi&#233; en
    dessous de la Location, et si le mot "on" est utilis&#233;, la mise en
    cache sera d&#233;sactiv&#233;e pour l'ensemble de l'arborescence concern&#233;e
    par la section Location.</p>

    <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">&lt;Location "/foo"&gt;
    CacheDisable on
&lt;/Location&gt;</pre>
</div>

    <p>Avec les versions 2.2.12 et ult&#233;rieures, on peut d&#233;finir la
    variable d'environnement <code>no-cache</code> pour une d&#233;finition
    plus fine des ressources &#224; mettre en cache.</p>

<h3>Voir aussi</h3>
<ul>
<li><a href="../env.html">Les variables d'environnement dans
Apache</a></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheenable" id="cacheenable">Directive</a> <a name="CacheEnable" id="CacheEnable">CacheEnable</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Active la mise en cache des URLs sp&#233;cifi&#233;es en utilisant le
gestionnaire de stockage pr&#233;cis&#233;</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheEnable <var>type de cache</var> [<var>cha&#238;ne
URL</var>]</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Une cha&#238;ne URL telle que '/' s'appliquait &#224; tout contenu
en mandat direct dans les versions 2.2 et ant&#233;rieures.</td></tr>
</table>
    <p>La directive <code class="directive">CacheEnable</code> enjoint
    <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code> de mettre en cache l'URL pr&#233;cis&#233;e par
    <var>cha&#238;ne URL</var>, ainsi que les URLs de niveaux inf&#233;rieurs. Le
    gestionnaire de stockage du cache est sp&#233;cifi&#233; &#224; l'aide de
    l'argument <var>type de cache</var>. La directive
    <code class="directive">CacheEnable</code> peut &#234;tre plac&#233;e &#224; l'int&#233;rieur d'une
    section <code class="directive">&lt;Location&gt;</code> ou <code class="directive">&lt;LocationMatch&gt;</code> pour indiquer que le
    contenu consid&#233;r&#233; peut &#234;tre mis en cache. Si <var>type de cache</var>
    a pour valeur <code>disk</code>, <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code>
    utilisera le gestionnaire de stockage sur disque impl&#233;ment&#233; par
    <code class="module"><a href="../mod/mod_cache_disk.html">mod_cache_disk</a></code>. Pour que <code class="module"><a href="../mod/mod_cache.html">mod_cache</a></code>
    utilise le gestionnaire de stockage bas&#233; sur le cache d'objets
    partag&#233;s impl&#233;ment&#233; par <code class="module"><a href="../mod/mod_cache_socache.html">mod_cache_socache</a></code>,
    sp&#233;cifiez <code>socache</code> comme valeur du param&#232;tre <var>type
    de cache</var>.</p>
    <p>Si les diff&#233;rentes directives <code class="directive">CacheEnable</code>
    sp&#233;cifient des URLs qui se recoupent (comme dans l'exemple
    ci-dessous), tous les gestionnaires de stockage possibles seront
    lanc&#233;s, jusqu'au premier d'entre eux qui traitera effectivement la
    requ&#234;te.
    L'ordre dans lequel les gestionnaires de stockage sont lanc&#233;s est
    d&#233;termin&#233; par l'ordre dans lequel apparaissent les directives
    <code class="directive">CacheEnable</code> dans le fichier de
    configuration. Les directives <code class="directive">CacheEnable</code>
    situ&#233;es &#224; l'int&#233;rieur de sections <code class="directive">&lt;Location&gt;</code> ou <code class="directive">&lt;LocationMatch&gt;</code> sont trait&#233;es avant les
    directives <code class="directive">CacheEnable</code> d&#233;finies au niveau
    global.</p>

    <p>En fonctionnement du type serveur mandataire direct, <var>cha&#238;ne
    URL</var> doit au moins d&#233;buter par un protocole pour lequel la mise
    en cache doit &#234;tre activ&#233;e.</p>

    <pre class="prettyprint lang-config"># Mise en cache de contenu (gestionnaire normal seulement)
CacheQuickHandler off
&lt;Location "/foo"&gt;
    CacheEnable disk
&lt;/Location&gt;

# Mise en cache via une expression rationnelle (gestionnaire normal seulement)
CacheQuickHandler off
&lt;LocationMatch "foo$"&gt;
    CacheEnable disk
&lt;/LocationMatch&gt;

# Mise en cache de tous les contenus, &#224; l'exception des URLs
# mandat&#233;es en direct (gestionnaire normal ou rapide)
CacheEnable  disk  /

# Mise en cache des URLs FTP mandat&#233;es (gestionnaire normal ou rapide)
CacheEnable  disk  ftp://

# Mise en cache des contenus mandat&#233;s en direct depuis www.example.org (gestionnaire normal ou rapide)
CacheEnable  disk  http://www.example.org/</pre>


    <p>Un nom d'h&#244;te commen&#231;ant par un caract&#232;re <strong>"*"</strong>
    correspondra &#224; tout nom d'h&#244;te se terminant par le suffixe
    consid&#233;r&#233;. Un nom d'h&#244;te commen&#231;ant par un caract&#232;re
    <strong>"."</strong> correspondra &#224; tout nom d'h&#244;te contenant le
    composant de nom de domaine qui suit ce caract&#232;re.</p>

    <pre class="prettyprint lang-config"># Correspond &#224; www.example.org et fooexample.org
CacheEnable  disk  "http://*example.org/"
# Correspond &#224; www.example.org, mais pas &#224; fooexample.org
CacheEnable  disk  "http://.example.org/"</pre>


    <p>Depuis la version 2.2.12, on peut d&#233;finir la variable
    d'environnement <code>no-cache</code> pour une d&#233;finition plus fine
    des ressources &#224; mettre en cache.</p>


<h3>Voir aussi</h3>
<ul>
<li><a href="../env.html">Les variables d'environnement dans
Apache</a></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheheader" id="cacheheader">Directive</a> <a name="CacheHeader" id="CacheHeader">CacheHeader</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ajoute un en-t&#234;te X-Cache &#224; la r&#233;ponse.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheHeader <var>on|off</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheHeader off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.3.9 d'Apache</td></tr>
</table>
  <p>Lorsque la directive <code class="directive"><a href="#cacheheader">CacheHeader</a></code> est d&#233;finie &#224; on, un
  en-t&#234;te <strong>X-Cache</strong> est ajout&#233; &#224; la r&#233;ponse et contient
  l'&#233;tat du cache pour cette derni&#232;re. Si le gestionnaire normal est
  utilis&#233;, cette directive peut se situer dans une section
  <code class="directive"><a href="../mod/core.html#directory">&lt;Directory&gt;</a></code> ou
  <code class="directive"><a href="../mod/core.html#location">&lt;Location&gt;</a></code>. Si c'est
  le gestionnaire rapide qui est utilis&#233;, elle doit se situer dans un
  contexte de serveur principal ou de serveur virtuel, sinon elle sera
  ignor&#233;e.</p>

  <dl>
    <dt><strong>HIT</strong></dt><dd>Le contenu &#233;tait &#224; jour et a &#233;t&#233;
    servi depuis le cache.</dd>
    <dt><strong>REVALIDATE</strong></dt><dd>Le contenu &#233;tait p&#233;rim&#233;, a
    &#233;t&#233; mis &#224; jour, puis a &#233;t&#233; servi depuis le cache.</dd>
    <dt><strong>MISS</strong></dt><dd>Le contenu n'a pas &#233;t&#233; servi
    depuis le cache, mais directement depuis le serveur demand&#233;.</dd>
  </dl>

  <pre class="prettyprint lang-config"># Active l'en-t&#234;te X-Cache
CacheHeader on</pre>


  <pre class="prettyprint lang-config">X-Cache: HIT from localhost</pre>

  


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheignorecachecontrol" id="cacheignorecachecontrol">Directive</a> <a name="CacheIgnoreCacheControl" id="CacheIgnoreCacheControl">CacheIgnoreCacheControl</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ignore les en-t&#234;tes de requ&#234;te enjoignant de ne pas servir
le contenu au client depuis le cache</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheIgnoreCacheControl On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheIgnoreCacheControl Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Normalement, les requ&#234;tes contenant des en-t&#234;tes tels que
    Cache-Control: no-cache ou Pragma: no-cache ne sont pas servies
    depuis le cache. La directive
    <code class="directive">CacheIgnoreCacheControl</code> permet de modifier ce
    comportement. Avec <code class="directive">CacheIgnoreCacheControl
    On</code>, le serveur tentera de servir la ressource depuis le
    cache, m&#234;me si la requ&#234;te contient un des en-t&#234;tes cit&#233;s plus haut.
    Les ressources qui requi&#232;rent une autorisation ne seront
    <em>jamais</em> mises en cache.</p>

    <pre class="prettyprint lang-config">CacheIgnoreCacheControl On</pre>


    <div class="warning"><h3>Avertissement :</h3>
       Cette directive permet de servir des ressources depuis le cache,
       m&#234;me si le client a demand&#233; &#224; ce qu'il n'en soit pas ainsi. Le
       contenu servi est ainsi susceptible d'&#234;tre p&#233;rim&#233;.
    </div>

<h3>Voir aussi</h3>
<ul>
<li><code class="directive"><a href="#cachestoreprivate">CacheStorePrivate</a></code></li>
<li><code class="directive"><a href="#cachestorenostore">CacheStoreNoStore</a></code></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheignoreheaders" id="cacheignoreheaders">Directive</a> <a name="CacheIgnoreHeaders" id="CacheIgnoreHeaders">CacheIgnoreHeaders</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ne pas stocker le(s) en-t&#234;te(s) sp&#233;cifi&#233;(s) dans le cache.
</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheIgnoreHeaders <var>en-t&#234;te</var> [<var>en-t&#234;te</var>] ...</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheIgnoreHeaders None</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>En accord avec la RFC 2616, les en-t&#234;tes HTTP hop-by-hop ne sont
    pas stock&#233;s dans le cache. Les en-t&#234;tes HTTP suivant sont des
    en-t&#234;tes hop-by-hop, et en tant que tels, ne sont en  <em>aucun</em>
    cas stock&#233;s dans le cache, quelle que soit la d&#233;finition de la
    directive <code class="directive">CacheIgnoreHeaders</code> :</p>

    <ul>
      <li><code>Connection</code></li>
      <li><code>Keep-Alive</code></li>
      <li><code>Proxy-Authenticate</code></li>
      <li><code>Proxy-Authorization</code></li>
      <li><code>TE</code></li>
      <li><code>Trailers</code></li>
      <li><code>Transfer-Encoding</code></li>
      <li><code>Upgrade</code></li>
    </ul>

    <p>La directive <code class="directive">CacheIgnoreHeaders</code> permet de
    sp&#233;cifier quels en-t&#234;tes HTTP ne doivent pas &#234;tre stock&#233;s dans le
    cache. Par exemple, il peut s'av&#233;rer pertinent dans certains cas de
    ne pas stocker les cookies dans le cache.</p>

    <p>La directive <code class="directive">CacheIgnoreHeaders</code> accepte
    une liste d'en-t&#234;tes HTTP s&#233;par&#233;s par des espaces, qui ne doivent
    pas &#234;tre stock&#233;s dans le cache. Si les en-t&#234;tes hop-by-hop sont les
    seuls &#224; ne pas devoir &#234;tre stock&#233;s dans le cache (le comportement
    compatible RFC 2616), la directive
    <code class="directive">CacheIgnoreHeaders</code> peut &#234;tre d&#233;finie &#224;
    <code>None</code>.</p>

    <div class="example"><h3>Exemple 1</h3><pre class="prettyprint lang-config">CacheIgnoreHeaders Set-Cookie</pre>
</div>

    <div class="example"><h3>Exemple 2</h3><pre class="prettyprint lang-config">CacheIgnoreHeaders None</pre>
</div>

    <div class="warning"><h3>Avertissement :</h3>
      Si des en-t&#234;tes n&#233;cessaires &#224; la bonne gestion du cache, comme
      <code>Expires</code>, ne sont pas stock&#233;s suite &#224; la d&#233;finition
      d'une directive <code class="directive">CacheIgnoreHeaders</code>, le
      comportement de mod_cache sera impr&#233;visible.
    </div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheignorenolastmod" id="cacheignorenolastmod">Directive</a> <a name="CacheIgnoreNoLastMod" id="CacheIgnoreNoLastMod">CacheIgnoreNoLastMod</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ignore le fait qu'une r&#233;ponse ne poss&#232;de pas d'en-t&#234;te Last
Modified.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheIgnoreNoLastMod On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheIgnoreNoLastMod Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Normalement, les documents qui ne poss&#232;dent pas de date de
    derni&#232;re modification ne sont pas mis en cache. Dans certaines
    circonstances, la date de derni&#232;re modification est supprim&#233;e (au
    cours des traitements li&#233;s &#224; <code class="module"><a href="../mod/mod_include.html">mod_include</a></code> par
    exemple), ou n'existe tout simplement pas. La directive
    <code class="directive">CacheIgnoreNoLastMod</code> permet de sp&#233;cifier si
    les documents ne poss&#232;dant pas de date de derni&#232;re modification
    doivent &#234;tre mis en cache, m&#234;me sans date de derni&#232;re modification.
    Si le document ne poss&#232;de ni date d'expiration, ni date de derni&#232;re
    modification, la valeur sp&#233;cifi&#233;e par la directive
    <code class="directive">CacheDefaultExpire</code> servira &#224; g&#233;n&#233;rer une date
    d'expiration.
    </p>

    <pre class="prettyprint lang-config">CacheIgnoreNoLastMod On</pre>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheignorequerystring" id="cacheignorequerystring">Directive</a> <a name="CacheIgnoreQueryString" id="CacheIgnoreQueryString">CacheIgnoreQueryString</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ignore la cha&#238;ne de param&#232;tres lors de la mise en
cache</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheIgnoreQueryString On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheIgnoreQueryString Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Normalement, les requ&#234;tes comportant une cha&#238;ne de param&#232;tres
    sont mises en cache s&#233;par&#233;ment si leurs cha&#238;nes de param&#232;tres
    diff&#232;rent.
    En accord avec la RFC 2616/13.9, cette mise en cache n'est effectu&#233;e
    s&#233;par&#233;ment que si une date d'expiration est sp&#233;cifi&#233;e. La directive
    <code class="directive">CacheIgnoreQueryString</code> permet la mise en
    cache de requ&#234;tes m&#234;me si aucune date d'expiration est sp&#233;cifi&#233;e, et
    de renvoyer une r&#233;ponse depuis la cache m&#234;me si les cha&#238;nes de
    param&#232;tres diff&#232;rent. Du point de vue du cache, la requ&#234;te est
    trait&#233;e comme si elle ne poss&#232;dait pas de cha&#238;ne de param&#232;tres
    lorsque cette directive est activ&#233;e.</p>

    <pre class="prettyprint lang-config">CacheIgnoreQueryString On</pre>



</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheignoreurlsessionidentifiers" id="cacheignoreurlsessionidentifiers">Directive</a> <a name="CacheIgnoreURLSessionIdentifiers" id="CacheIgnoreURLSessionIdentifiers">CacheIgnoreURLSessionIdentifiers</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ignore les identifiants de session d&#233;finis encod&#233;s dans
l'URL lors de la mise en cache
</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheIgnoreURLSessionIdentifiers <var>identifiant</var>
[<var>identifiant</var>] ...</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheIgnoreURLSessionIdentifiers None</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Certaines applications encodent l'identifiant de session dans
    l'URL comme dans l'exemple suivant :
    </p>
    <ul>
      <li><code>/une-application/image.gif;jsessionid=123456789</code></li>
      <li><code>/une-application/image.gif?PHPSESSIONID=12345678</code></li>
    </ul>
    <p>Ceci implique la mise en cache des ressources s&#233;par&#233;ment pour
    chaque session, ce qui n'est en g&#233;n&#233;ral pas souhait&#233;. La directive
    <code class="directive">CacheIgnoreURLSessionIdentifiers</code> permet de
    d&#233;finir une liste d'identifiants qui seront supprim&#233;s de la cl&#233;
    utilis&#233;e pour identifier une entit&#233; dans le cache, de fa&#231;on &#224; ce que
    les ressources ne soient pas stock&#233;es s&#233;par&#233;ment pour chaque
    session.
    </p>
    <p><code>CacheIgnoreURLSessionIdentifiers None</code> vide la liste
    des identifiants ignor&#233;s. Autrement, chaque identifiant sp&#233;cifi&#233; est
    ajout&#233; &#224; la liste.</p>

    <div class="example"><h3>Exemple 1</h3><pre class="prettyprint lang-config">CacheIgnoreURLSessionIdentifiers jsessionid</pre>
</div>

    <div class="example"><h3>Exemple 2</h3><pre class="prettyprint lang-config">CacheIgnoreURLSessionIdentifiers None</pre>
</div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachekeybaseurl" id="cachekeybaseurl">Directive</a> <a name="CacheKeyBaseURL" id="CacheKeyBaseURL">CacheKeyBaseURL</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Remplace l'URL de base des cl&#233;s du cache mandat&#233;es en
inverse</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheKeyBaseURL <var>URL</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheKeyBaseURL http://example.com</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.3.9 d'Apache</td></tr>
</table>
  <p>Lorsque la directive <code class="directive"><a href="#cachekeybaseurl">CacheKeyBaseURL</a></code> est utilis&#233;e, l'URL
  sp&#233;cifi&#233;e sera utilis&#233;e comme URL de base pour calculer l'URL des cl&#233;s
  du cache dans la configuration du mandataire inverse. Par d&#233;faut,
  c'est le protocole/nom d'h&#244;te/port du serveur virtuel courant qui sera
  utilis&#233; pour construire la cl&#233; de cache. Dans le cas d'un cluster de
  machines, si toutes les entr&#233;es du cache doivent poss&#233;der la m&#234;me cl&#233;,
  cette directive permet de sp&#233;cifier une nouvelle URL de base.</p>

  <pre class="prettyprint lang-config"># Remplace l'URL de base de la cl&#233; de cache.
CacheKeyBaseURL "http://www.example.com/"</pre>


  <div class="warning">Prenez garde en d&#233;finissant cette directive. Si
  deux serveurs virtuels distincts poss&#232;dent accidentellement la m&#234;me
  URL de base, les entr&#233;es en provenance d'un serveur virtuel seront
  servies par l'autre.</div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachelastmodifiedfactor" id="cachelastmodifiedfactor">Directive</a> <a name="CacheLastModifiedFactor" id="CacheLastModifiedFactor">CacheLastModifiedFactor</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Le facteur utilis&#233; pour g&#233;n&#233;rer une date d'expiration en
fonction de la date de derni&#232;re modification.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheLastModifiedFactor <var>flottant</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheLastModifiedFactor 0.1</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Si un document ne poss&#232;de pas de date d'expiration, elle peut
    &#234;tre calcul&#233;e en fonction de la date de derni&#232;re modification, si
    elle existe. La directive
    <code class="directive">CacheLastModifiedFactor</code> permet de sp&#233;cifier
    un <var>facteur</var> &#224; utiliser pour la g&#233;n&#233;ration de cette date
    d'expiration au sein de la formule suivante :

    <code>d&#233;lai-expiration = dur&#233;e-depuis-date-derni&#232;re-modification *
    <var>facteur</var>
    date-expiration = date-courante + d&#233;lai-expiration</code>

    Par exemple, si la derni&#232;re modification du document date de 10
    heures, et si <var>facteur</var> a pour valeur 0.1, le d&#233;lai
    d'expiration sera de 10*0.1 = 1 heure. Si l'heure courante est
    3:00pm, la date d'expiration calcul&#233;e sera 3:00pm + 1 heure =
    4:00pm.

    Si le d&#233;lai d'expiration est sup&#233;rieur &#224; celui sp&#233;cifi&#233; par la
    directive <code class="directive">CacheMaxExpire</code>, c'est ce dernier
    qui l'emporte.</p>

    <pre class="prettyprint lang-config">CacheLastModifiedFactor 0.5</pre>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachelock" id="cachelock">Directive</a> <a name="CacheLock" id="CacheLock">CacheLock</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Active la protection contre les temp&#234;tes de requ&#234;tes.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheLock <var>on|off</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheLock off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.2.15 d'Apache</td></tr>
</table>
  <p>La directive <code class="directive">CacheLock</code> active la protection
  contre les temp&#234;tes de requ&#234;tes pour l'espace d'adressage donn&#233;.</p>

  <p>La configuration minimale pour activer le verrouillage contre les
  temp&#234;tes de requ&#234;tes dans le r&#233;pertoire temp par d&#233;faut du syst&#232;me est
  la suivante :</p>

  <pre class="prettyprint lang-config"># Active le verrouillage du cache
CacheLock on</pre>



</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachelockmaxage" id="cachelockmaxage">Directive</a> <a name="CacheLockMaxAge" id="CacheLockMaxAge">CacheLockMaxAge</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;finit la dur&#233;e de vie maximale d'un verrou de cache.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheLockMaxAge <var>entier</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheLockMaxAge 5</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
  <p>La directive <code class="directive">CacheLockMaxAge</code> permet de
  sp&#233;cifier la dur&#233;e de vie maximale d'un verrou de cache.</p>

  <p>Un verrou plus ancien que cette valeur exprim&#233;e en secondes sera
  ignor&#233;, et la prochaine requ&#234;te entrante sera alors en mesure de
  recr&#233;er le verrou. Ce m&#233;canisme permet d'&#233;viter les mises &#224; jour trop
  longues initi&#233;es par des clients lents.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachelockpath" id="cachelockpath">Directive</a> <a name="CacheLockPath" id="CacheLockPath">CacheLockPath</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;finit le r&#233;pertoire des verrous.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheLockPath <var>r&#233;pertoire</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheLockPath /tmp/mod_cache-lock</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
  <p>La directive <code class="directive">CacheLockPath</code> permet de
  sp&#233;cifier le r&#233;pertoire dans lequel les verrous sont cr&#233;&#233;s. Par
  d&#233;faut, c'est le r&#233;pertoire temporaire du syst&#232;me qui est utilis&#233;. Les
  verrous sont des fichiers vides qui n'existent que pour les URLs
  p&#233;rim&#233;es en cours de mise &#224; jour, et consomment donc bien moins de
  ressources que le traditionnel cache sur disque.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachemaxexpire" id="cachemaxexpire">Directive</a> <a name="CacheMaxExpire" id="CacheMaxExpire">CacheMaxExpire</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La dur&#233;e maximale en secondes de mise en cache d'un
document</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheMaxExpire <var>secondes</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheMaxExpire 86400 (une journ&#233;e)</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>La directive <code class="directive">CacheMaxExpire</code> permet de
    sp&#233;cifier le nombre maximum de secondes pendant lequel les documents
    HTTP suceptibles d'&#234;tre mis en cache seront conserv&#233;s sans v&#233;rifier
    leur contenu sur le serveur d'origine. Ce nombre de secondes
    correspond donc &#224; la dur&#233;e maximale pendant laquelle un document ne
    sera pas &#224; jour. L'utilisation de cette valeur maximale est forc&#233;e,
    m&#234;me si le document poss&#232;de une date d'expiration.</p>

    <pre class="prettyprint lang-config">CacheMaxExpire 604800</pre>

    

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cacheminexpire" id="cacheminexpire">Directive</a> <a name="CacheMinExpire" id="CacheMinExpire">CacheMinExpire</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La dur&#233;e minimale en secondes de mise en cache d'un
document</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheMinExpire <var>secondes</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheMinExpire 0</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>La directive <code class="directive">CacheMaxExpire</code> permet de
    sp&#233;cifier le nombre maximum de secondes pendant lequel les documents
    HTTP suceptibles d'&#234;tre mis en cache seront conserv&#233;s sans v&#233;rifier
    leur contenu sur le serveur d'origine. Elle n'est prise en compte
    que dans le cas o&#249; le document ne poss&#232;de aucune date d'expiration
    valide.</p>

    <pre class="prettyprint lang-config">CacheMinExpire 3600</pre>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachequickhandler" id="cachequickhandler">Directive</a> <a name="CacheQuickHandler" id="CacheQuickHandler">CacheQuickHandler</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ex&#233;cute le cache &#224; partir d'un gestionnaire rapide.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheQuickHandler <var>on|off</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheQuickHandler on</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.3.3 du serveur HTTP
  Apache</td></tr>
</table>
    <p>La directive <code class="directive"><a href="#cachequickhandler">CacheQuickHandler</a></code> permet de contr&#244;ler
    la phase au cours de laquelle la mise en cache est effectu&#233;e.</p>

    <p>Avec la configuration par d&#233;faut, le cache agit au cours de la
    phase du gestionnaire rapide. Cette phase court-circuite la majorit&#233;
    des traitements du serveur, et constitue le mode d'op&#233;ration le plus
    performant pour un serveur typique. Le cache
    <strong>s'incruste</strong> devant le serveur, et la majorit&#233; des
    traitements du serveur est court-circuit&#233;e.</p>

    <p>Lorsque cette directive est d&#233;finie &#224; off, le cache agit comme un
    gestionnaire normal, et est concern&#233; par toutes les phases de
    traitement d'une requ&#234;te. Bien que ce mode soit moins performant que
    le mode par d&#233;faut, il permet d'utiliser le cache dans les cas o&#249; un
    traitement complet de la requ&#234;te est n&#233;cessaire, comme par exemple
    lorsque le contenu est soumis &#224; autorisation.</p>

    <pre class="prettyprint lang-config"># Ex&#233;cute le cache comme un gestionnaire normal
CacheQuickHandler off</pre>


    <p>Lorsque le gestionnaire rapide est d&#233;sactiv&#233;, l'administrateur a
    aussi la possibilit&#233; de choisir avec pr&#233;cision le point de la cha&#238;ne
    de filtrage o&#249; la mise en cache sera effectu&#233;e, en utilisant le
    filtre <strong>CACHE</strong>.</p>

    <pre class="prettyprint lang-config"># Mise en cache du contenu avant l'intervention de mod_include et
     # mod_deflate
CacheQuickHandler off
AddOutputFilterByType CACHE;INCLUDES;DEFLATE text/html</pre>


    <p>Si le filtre CACHE est sp&#233;cifi&#233; plusieurs fois, c'est la derni&#232;re
    instance qui sera prise en compte.</p>

  
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachestaleonerror" id="cachestaleonerror">Directive</a> <a name="CacheStaleOnError" id="CacheStaleOnError">CacheStaleOnError</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Sert du contenu non &#224; jour &#224; la place de r&#233;ponses 5xx.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheStaleOnError <var>on|off</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheStaleOnError on</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.3.9 d'Apache</td></tr>
</table>
  <p>Lorsque la directive <code class="directive"><a href="#cachestaleonerror">CacheStaleOnError</a></code> est d&#233;finie &#224; on, et
  si des donn&#233;es non mises &#224; jour sont disponibles dans le cache, ce
  dernier renverra ces donn&#233;es, plut&#244;t qu'une &#233;ventuelle r&#233;ponse 5xx en
  provenance du serveur d'arri&#232;re-plan. Alors que l'en-t&#234;te
  Cache-Control envoy&#233; par les clients sera respect&#233;, et que les clients
  recevront donc dans ce cas la r&#233;ponse 5xx brute &#224; leur requ&#234;te, cette
  r&#233;ponse 5xx renvoy&#233;e au client n'invalidera pas le contenu dans le
  cache.  </p>

  <pre class="prettyprint lang-config"># Sert des donn&#233;es non mises &#224; jour en cas d'erreur.
CacheStaleOnError on</pre>



</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachestoreexpired" id="cachestoreexpired">Directive</a> <a name="CacheStoreExpired" id="CacheStoreExpired">CacheStoreExpired</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Tente de mettre en cache les r&#233;ponses que le serveur
consid&#232;re comme arriv&#233;es &#224; expiration</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheStoreExpired On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheStoreExpired Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Depuis la version 2.2.4, les r&#233;ponses qui sont arriv&#233;es &#224;
    expiration ne sont pas stock&#233;es dans le cache. La directive
    <code class="directive">CacheStoreExpired</code> permet de modifier ce
    comportement. Avec <code class="directive">CacheStoreExpired</code> On, le
    serveur tente de mettre en cache la ressource si elle est p&#233;rim&#233;e.
    Les requ&#234;tes suivantes vont d&#233;clencher une requ&#234;te si-modifi&#233;-depuis
    de la part du serveur d'origine, et la r&#233;ponse sera renvoy&#233;e &#224;
    partir du cache si la ressource d'arri&#232;re-plan n'a pas &#233;t&#233; modifi&#233;e.</p>

    <pre class="prettyprint lang-config">CacheStoreExpired On</pre>

    

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachestorenostore" id="cachestorenostore">Directive</a> <a name="CacheStoreNoStore" id="CacheStoreNoStore">CacheStoreNoStore</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Tente de mettre en cache les requ&#234;tes ou r&#233;ponses dont
l'ent&#234;te Cache-Control: a pour valeur no-store.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheStoreNoStore On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheStoreNoStore Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Normalement, les requ&#234;tes ou r&#233;ponses dont l'en-t&#234;te
    Cache-Control: a pour valeur no-store ne sont pas stock&#233;es dans le
    cache. La directive <code class="directive">CacheStoreNoStore</code> permet
    de modifier ce comportement. Si
    <code class="directive">CacheStoreNoStore</code> est d&#233;finie &#224; On, le
    serveur tente de mettre la ressource en cache m&#234;me si elle contient
    des en-t&#234;tes ayant pour valeur no-store. Les ressources
    n&#233;cessitant une autorisation ne sont <em>jamais</em> mises en
    cache.</p>

    
    <pre class="prettyprint lang-config">CacheStoreNoStore On</pre>

    

    <div class="warning"><h3>Avertissement :</h3>
       Selon la RFC 2616, la valeur d'en-t&#234;te no-store est cens&#233;e
       "pr&#233;venir la suppression ou la r&#233;tention par inadvertance
       d'informations sensibles (par exemple, sur des bandes de
       sauvegarde)". Autrement dit, l'activation de la directive
       <code class="directive">CacheStoreNoCache</code> pourrait provoquer le
       stockage d'informations sensibles dans le cache. Vous avez donc
       &#233;t&#233; pr&#233;venus.
    </div>

<h3>Voir aussi</h3>
<ul>
<li><code class="directive"><a href="#cacheignorecachecontrol">CacheIgnoreCacheControl</a></code></li>
<li><code class="directive"><a href="#cachestoreprivate">CacheStorePrivate</a></code></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="cachestoreprivate" id="cachestoreprivate">Directive</a> <a name="CacheStorePrivate" id="CacheStorePrivate">CacheStorePrivate</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Tente de mettre en cache des r&#233;ponses que le serveur a
marqu&#233;es comme priv&#233;es</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>CacheStorePrivate On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>CacheStorePrivate Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_cache</td></tr>
</table>
    <p>Normalement, les r&#233;ponse comportant un en-t&#234;te Cache-Control:
    dont la valeur est private ne seront pas stock&#233;es dans le cache. La
    directive <code class="directive">CacheStorePrivate</code> permet de
    modifier ce comportement. Si
    <code class="directive">CacheStorePrivate</code> est d&#233;finie &#224; On, le
    serveur tentera de mettre la ressource en cache, m&#234;me si elle
    contient des en-t&#234;tes ayant pour valeur private. Les ressources
    n&#233;cessitant une autorisation ne sont <em>jamais</em> mises en
    cache.</p>

    
    <pre class="prettyprint lang-config">CacheStorePrivate On</pre>

    

    <div class="warning"><h3>Avertissement :</h3>
       Cette directive autorise la mise en cache m&#234;me si le serveur
       indique que la ressource ne doit pas &#234;tre mise en cache. Elle
       n'est de ce fait appropri&#233;e que dans le cas d'un cache
       'priv&#233;'.
    </div>

<h3>Voir aussi</h3>
<ul>
<li><code class="directive"><a href="#cacheignorecachecontrol">CacheIgnoreCacheControl</a></code></li>
<li><code class="directive"><a href="#cachestorenostore">CacheStoreNoStore</a></code></li>
</ul>
</div>
</div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_cache.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_cache.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a> |
<a href="../ja/mod/mod_cache.html" hreflang="ja" rel="alternate" title="Japanese">&nbsp;ja&nbsp;</a> |
<a href="../ko/mod/mod_cache.html" hreflang="ko" rel="alternate" title="Korean">&nbsp;ko&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="../images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/mod/mod_cache.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2018 The Apache Software Foundation.<br />Autoris&#233; sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>