<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>mod_http2 - Serveur HTTP Apache Version 2.4</title>
<link href="../style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="../style/css/prettify.css" />
<script src="../style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="../images/favicon.ico" rel="shortcut icon" /></head>
<body>
<div id="page-header">
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p>
<p class="apache">Serveur HTTP Apache Version 2.4</p>
<img alt="" src="../images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="../">Version 2.4</a> &gt; <a href="./">Modules</a></div>
<div id="page-content">
<div id="preamble"><h1>Module Apache mod_http2</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_http2.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_http2.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div>
<table class="module"><tr><th><a href="module-dict.html#Description">Description:</a></th><td>Support de la couche transport HTTP/2</td></tr>
<tr><th><a href="module-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">Identificateur&#160;de&#160;Module:</a></th><td>http2_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">Fichier&#160;Source:</a></th><td>mod_http2.c</td></tr>
<tr><th><a href="module-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.17 du serveur
    HTTP Apache</td></tr></table>
<h3>Sommaire</h3>

	<p>Ce module ajoute le support de HTTP/2 (<a href="https://tools.ietf.org/html/rfc7540">RFC 7540</a>) au serveur HTTP
	Apache.</p>
        
        <p>Il s'appuie sur la biblioth&#232;que <a href="http://nghttp2.org/">libnghttp2</a> pour impl&#233;menter le
	moteur de base http/2.</p>
        
        <p>Pour mettre en oeuvre les fonctionnalit&#233;s d&#233;crites dans ce
	document, vous devez activer HTTP/2 en utilisant la directive
	<code class="directive"><a href="../mod/core.html#protocols">Protocols</a></code>. HTTP/2 <a href="https://http2.github.io/faq/#does-http2-require-encryption">n'imposant
	pas</a> de chiffrement, deux protocoles sont disponibles :
	<code>h2</code> (HTTP/2 avec TLS) at <code>h2c</code> (HTTP/2 avec TCP).</p>

	<p>Voici deux types de configuration courant :</p>

	<div class="note"><h3>HTTP/2 dans un contexte de serveur virtuel (TLS seulement)</h3>
        <pre class="prettyprint lang-config">Protocols h2 http/1.1</pre>

	<p>Permet une n&#233;gociation HTTP/2 (h2) via TLS ALPN au sein d'un
	<code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>
	s&#233;curis&#233;. La v&#233;rification du pr&#233;ambule HTTP/2 (mode direct, voir
	<code class="directive"><a href="#h2direct">H2Direct</a></code>) est d&#233;sactiv&#233;e par
	d&#233;faut pour <code>h2</code>.</p>
        </div>
 
        <div class="note"><h3>HTTP/2 dans un contexte de serveur (TLS et texte pur)</h3>
	<pre class="prettyprint lang-config">Protocols h2 h2c http/1.1</pre>

	<p>Permet une n&#233;gociation HTTP/2 (h2) via TLS ALPN au sein d'un
	<code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>
	s&#233;curis&#233;. Permet aussi une n&#233;gociation HTTP/2 en texte pur (h2c) en
	effectuant une mise &#224; jour depuis une connexion initiale HTTP/1.1 ou via
	une v&#233;rification du pr&#233;ambule HTTP/2 (mode direct, voir
	<code class="directive"><a href="#h2direct">H2Direct</a></code>).</p>
        </div>
 
        <p>Si vous avez besoin d'informations suppl&#233;mentaires &#224; propos du
	protocole, veuillez vous reporter &#224; la <a href="https://http2.github.io/faq">HTTP/2 FAQ</a>.</p>
	

    </div>
<div id="quickview"><a href="https://www.apache.org/foundation/contributing.html" class="badge"><img src="https://www.apache.org/images/SupportApache-small.png" alt="Support Apache!" /></a><h3>Sujets</h3>
<ul id="topics">
<li><img alt="" src="../images/down.gif" /> <a href="#how-it-works">Comment &#231;a marche ?</a></li>
</ul><h3 class="directives">Directives</h3>
<ul id="toc">
<li><img alt="" src="../images/down.gif" /> <a href="#h2copyfiles">H2CopyFiles</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2direct">H2Direct</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2earlyhints">H2EarlyHints</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2maxsessionstreams">H2MaxSessionStreams</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2maxworkeridleseconds">H2MaxWorkerIdleSeconds</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2maxworkers">H2MaxWorkers</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2minworkers">H2MinWorkers</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2moderntlsonly">H2ModernTLSOnly</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2push">H2Push</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2pushdiarysize">H2PushDiarySize</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2pushpriority">H2PushPriority</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2pushresource">H2PushResource</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2serializeheaders">H2SerializeHeaders</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2streammaxmemsize">H2StreamMaxMemSize</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2tlscooldownsecs">H2TLSCoolDownSecs</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2tlswarmupsize">H2TLSWarmUpSize</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2upgrade">H2Upgrade</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#h2windowsize">H2WindowSize</a></li>
</ul>
<h3>Traitement des bugs</h3><ul class="seealso"><li><a href="https://www.apache.org/dist/httpd/CHANGES_2.4">Journal des modifications de httpd</a></li><li><a href="https://bz.apache.org/bugzilla/buglist.cgi?bug_status=__open__&amp;list_id=144532&amp;product=Apache%20httpd-2&amp;query_format=specific&amp;order=changeddate%20DESC%2Cpriority%2Cbug_severity&amp;component=mod_http2">Probl&#232;mes connus</a></li><li><a href="https://bz.apache.org/bugzilla/enter_bug.cgi?product=Apache%20httpd-2&amp;component=mod_http2">Signaler un bug</a></li></ul><h3>Voir aussi</h3>
<ul class="seealso">
<li><a href="#comments_section">Commentaires</a></li></ul></div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="how-it-works" id="how-it-works">Comment &#231;a marche ?</a></h2>
    
    <h3><a name="dimensioning" id="dimensioning">Quantification des ressources
    suppl&#233;mentaires n&#233;cessaires &#224; HTTP/2</a></h3>
        <p>
            Activer HTTP/2 sur votre serveur Apache a un impact sur la
	    consommation de ressources, et si votre site est tr&#232;s actif, il est
	    conseill&#233; d'en prendre s&#233;rieusement en compte les implications.
        </p>
        <p>
            HTTP/2 attribue &#224; chaque requ&#234;te qu'il re&#231;oit son propre <em>thread
	    de travail</em> pour son traitement, la collecte des r&#233;sultats et
	    l'envoie de ces derniers au client. Pour y parvenir, il lui faut
	    lancer des threads suppl&#233;mentaires, et ceci constituera le premier
	    effet notable de l'activation de HTTP/2.
        </p>
        <p>
	    Dans l'impl&#233;mentation actuelle, ces threads de travail font partie
	    d'un jeu de threads distinct de celui des threads de travail du MPM
	    avec lequel vous &#234;tes famili&#233;. Il s'agit simplement du mode de
	    fonctionnement actuel, et il n'en sera pas obligatoirement toujours
	    ainsi (il est cependant probable que la situation restera inchang&#233;e
	    avec la version 2.4.x). De par ce mode de fonctionnement, les
	    threads de travail HTTP/2, ou plus simplement H2 ne seront pas
	    affich&#233;s par <code class="module"><a href="../mod/mod_status.html">mod_status</a></code>. De m&#234;me, ils ne seront pas
	    pris en compte par les directives du style <code class="directive"><a href="../mod/mpm_common.html#threadsperchild">ThreadsPerChild</a></code>. Par contre, ils
	    utilisent par d&#233;faut la valeur de <code class="directive"><a href="../mod/mpm_common.html#threadsperchild">ThreadsPerChild</a></code> si vous n'avez pas
	    sp&#233;cifi&#233; d'autres valeurs via <code class="directive"><a href="#h2minworkers">H2MinWorkers</a></code> et <code class="directive"><a href="#h2maxworkers">H2MaxWorkers</a></code>.
        </p>
        <p>
            Autre changement &#224; surveiller : la consommation de m&#233;moire. En
	    effet, comme HTTP/2 conserve plus d'informations sur le serveur pour
	    g&#233;rer toutes les requ&#234;tes en cours, leurs priorit&#233;s et
	    interd&#233;pendances, il aura toujours besoin de plus de m&#233;moire que
	    pour un traitement en HTTP/1.1. Trois directives permettent de
	    limiter l'empreinte m&#233;moire d'une connexion HTTP/2 : <code class="directive"><a href="#h2maxsessionstreams">H2MaxSessionStreams</a></code>, <code class="directive"><a href="#h2windowsize">H2WindowSize</a></code> et <code class="directive"><a href="#h2streammaxmemsize">H2StreamMaxMemSize</a></code>.
        </p>
        <p>
            La directive <code class="directive"><a href="#h2maxsessionstreams">H2MaxSessionStreams</a></code> permet de limiter
	    le nombre de requ&#234;tes simultan&#233;es qu'un client peut envoyer sur une
	    connexion HTTP/2. La valeur que vous allez d&#233;finir d&#233;pend de votre
	    site. La valeur par d&#233;faut qui est de 100 est largement suffisante,
	    et &#224; moins que vous ne soyez un peu juste en m&#233;moire, je vous
	    conseille de ne pas la modifier. La plupart des requ&#234;tes qu'envoie
	    un client sont des requ&#234;tes de type GET sans corps qui n'utilisent
	    que tr&#232;s peu de m&#233;moire en attendant le d&#233;marrage du traitement.
	    
        </p>
        <p>
            La directive <code class="directive"><a href="#h2windowsize">H2WindowSize</a></code>
	    permet de d&#233;finir la taille maximale que peut avoir le corps d'une
	    requ&#234;te que le client envoie avant d'attendre que le serveur
	    en demande d'avantage. En d'autres termes, il s'agit de la quantit&#233;
	    de donn&#233;es que le serveur peut stocker dans son tampon, valable pour
	    une requ&#234;te.
        </p>
        <p>
	    En outre, la directive <code class="directive"><a href="#h2streammaxmemsize">H2StreamMaxMemSize</a></code> permet de d&#233;finir
	    la quantit&#233; de donn&#233;es de la r&#233;ponse qui doit &#234;tre mise en tampon.
	    Chaque requ&#234;te &#233;tant prise en charge par un thread H2Worker et
	    produisant des donn&#233;es que le serveur tente de transmettre au client
	    via une connexion HTTP/2, si le client n'est pas en mesure de lire
	    ces donn&#233;es assez rapidement, la connexion les mettra en tampon et
	    interrompra l'ex&#233;cution du thread H2Worker correspondant.
        </p>
        
    
    
    <h3><a name="misdirected" id="misdirected">Serveurs virtuels et requ&#234;tes mal
    redirig&#233;es</a></h3>
        <p>
            De nombreux site utilisent le m&#234;me certificat TLS pour plusieurs
	    serveurs virtuels. Ce certificat r&#233;f&#233;rence un nom de serveur
	    g&#233;n&#233;rique comme '*.example.org' ou plusieurs noms de serveur
	    diff&#233;rents. Les navigateurs qui utilisent HTTP/2 d&#233;tectent ce
	    comportement et r&#233;utilisent une connexion d&#233;j&#224; ouverte pour ces
	    serveurs.
        </p>
        <p>
            Ceci am&#233;liore consid&#233;rablement les performances, mais il y a un prix
	    &#224; payer : il faut accorder un soin tout particulier &#224; la
	    configuration de tels serveurs virtuels. Le probl&#232;me r&#233;side dans le
	    fait que plusieurs requ&#234;tes pour plusieurs serveurs virtuels vont se
	    partager la m&#234;me connexion TLS, et ceci emp&#234;che toute ren&#233;gociation
	    car le standard HTTP/2 l'interdit.
        </p>
        <p>
            Ainsi, lorsque plusieurs de vos serveurs virtuels utilisent le m&#234;me
	    certificat et si vous souhaitez utiliser HTTP/2 pour y acc&#233;der, vous
	    devez vous assurer que tous vos serveurs virtuels poss&#232;dent
	    exactement la m&#234;me configuration SSL. En particulier, ils doivent
	    utiliser les m&#234;mes protocole, algorithme de chiffrement et
	    configuration pour la v&#233;rification du client.
        </p>
        <p>
	    Dans le cas contraire, Apache httpd le d&#233;tectera et renverra au
	    client un code de r&#233;ponse sp&#233;cial, 421 Misdirected Request.
        </p>
    

    <h3><a name="envvars" id="envvars">Variables d'environnement</a></h3>
        
        <p>Ce module peut &#234;tre configur&#233; pour fournir des informations en
	rapport avec HTTP/2 sous la forme de variables d'environnement
	suppl&#233;mentaires dans l'espace de nommage SSI et CGI, ainsi que dans les
	configurations personnalis&#233;es de le journalisation (voir
	<code>%{VAR_NAME}e</code>).
        </p>
        
        <table class="bordered">
            
            <tr>
                <th><a name="table3">Nom variable :</a></th>
                <th>Type :</th>
                <th>Description :</th>
            </tr>
            <tr><td><code>HTTPe</code></td><td>drapeau</td><td>HTTP/2 est utilis&#233;.</td></tr>
            <tr><td><code>H2PUSH</code></td><td>drapeau</td><td>La
	    fonctionnalit&#233; HTTP/2 Server Push est activ&#233;e pour cette requ&#234;te et
	    support&#233;e par le client.</td></tr>
	    <tr><td><code>H2_PUSH</code></td><td>drapeau</td><td>autre nom pour <code>H2PUSH</code></td></tr>
            <tr><td><code>H2_PUSHED</code></td><td>cha&#238;ne</td><td>vide ou
	    <code>PUSHED</code> pour une requ&#234;te push&#233;e par le serveur.</td></tr>
            <tr><td><code>H2_PUSHED_ON</code></td><td>nombre</td><td>num&#233;ro du
	    flux HTTP/2 qui a d&#233;clench&#233; le push de cette requ&#234;te.</td></tr>
            <tr><td><code>H2_STREAM_ID</code></td><td>nombre</td><td>num&#233;ro du
	    flux HTTP/2 de cette requ&#234;te.</td></tr>
            <tr><td><code>H2_STREAM_TAG</code></td><td>cha&#238;ne</td><td>identifiant
	    de flux unique du processus HTTP/2 compos&#233; de l'identifiant de la
	    connexion et de l'identifiant du flux s&#233;par&#233;s par <code>-</code>.</td></tr>
        </table>
    

    </div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2copyfiles" id="h2copyfiles">Directive</a> <a name="H2CopyFiles" id="H2CopyFiles">H2CopyFiles</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Contr&#244;le la gestion des fichiers dans les r&#233;ponses</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2CopyFiles on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2CopyFiles off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.24 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir la mani&#232;re de g&#233;rer les
		contenus de fichiers dans les r&#233;ponses. Lorsqu'elle est &#224; <code>off</code>
		(sa valeur par d&#233;faut), les descripteurs de fichiers sont
		transmis par le processus de traitement de la requ&#234;te vers la
		connexion principale en utilisant le syst&#232;me habituel de mise en
		r&#233;serve d'Apache pour g&#233;rer le dur&#233;e de vie du fichier.
            </p>
            <p>
                Lorsqu'elle est &#224; <code>on</code>, le contenu du fichier est
		recopier pendant le traitement de la requ&#234;te et ces donn&#233;es
		mises en tampon sont transmises vers la connexion principale, ce
		qui s'av&#232;re avantageux lorsqu'un module tiers injecte dans la
		r&#233;ponse des fichiers poss&#233;dant des dur&#233;es de vie diff&#233;rentes. 
            </p>
            <p>
                Un exemple de ces modules tiers : <code>mod_wsgi</code> qui peut
		injecter des descripteurs de fichiers dans la r&#233;ponse. Ces
		fichiers sont ferm&#233;s lorsque Python estime que le traitement est
		termin&#233;, alors que <code class="module"><a href="../mod/mod_http2.html">mod_http2</a></code> est probablement
		encore loin d'en avoir fini avec eux.
            </p>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2direct" id="h2direct">Directive</a> <a name="H2Direct" id="H2Direct">H2Direct</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Activation du protocole H2 Direct</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2Direct on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2Direct on pour h2c, off pour le protocole h2</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet d'activer/d&#233;sactiver
		l'utilisation du mode HTTP/2 Direct. Elle doit &#234;tre
		situ&#233;e dans une section <code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code> afin d'activer la
		communication directe HTTP/2 pour le serveur virtuel
		consid&#233;r&#233;. 
            </p>
            <p>
                La notion de communication directe signifie que si les
		premiers octets re&#231;us par le serveur correspondent &#224; un
		en-t&#234;te HTTP/2, le protocole HTTP/2 est utilis&#233; sans
		n&#233;gociation suppl&#233;mentaire. Ce mode est d&#233;fini pour
		les transmissions en clair (h2c) dans la RFC 7540. Son
		utilisation avec les connexions TLS n'est pas
		officiellement support&#233;e.
            </p>
            <p>
                Lorsque le protocole h2 ou h2c n'est pas activ&#233; via la
		directive <code class="directive"><a href="../mod/core.html#protocols">Protocols</a></code>, la recherche d'un en-t&#234;te HTTP/2 n'est
		jamais effectu&#233;e au sein d'une connexion. La directive
		<code class="directive">H2Direct</code> ne produit alors aucun effet. Ceci est
		important pour les connexions qui utilisent un protocole
		pour lequel une lecture initiale peut entra&#238;ner un
		blocage d&#233;finitif comme NNTP.
            </p>
            <p>
                Pour un client qui sait qu'un serveur supporte h2c, la
		communication directe HTTP/2 dispense le client d'une
		mise &#224; jour HTTP/1.1, ce qui entra&#238;ne une am&#233;lioration
		des performances et &#233;vite les restrictions sur les corps
		de requ&#234;te suite &#224; une mise &#224; jour.
            </p>
            <p>
                Cette directive rend aussi h2c plus attractif pour les
		communications de serveur &#224; serveur lorsque la connexion
		est sure ou peut &#234;tre s&#233;curis&#233;e d'une mani&#232;re ou d'une
		autre.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2Direct on</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2earlyhints" id="h2earlyhints">Directive</a> <a name="H2EarlyHints" id="H2EarlyHints">H2EarlyHints</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Contr&#244;le l'envoi de codes d'&#233;tat 103</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2EarlyHints on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2EarlyHints off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.24 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir si les r&#233;ponses interm&#233;diaires
		contenant un code d'&#233;tat HTTP 103 doivent &#234;tre envoy&#233;es au
		client ou non. Par d&#233;faut ce n'est actuellement pas le cas car
		certains clients ont encore des probl&#232;mes avec les r&#233;ponses
		interm&#233;diaires inattendues.
            </p>
            <p>
                Lorsque cette directive est d&#233;finie &#224; <code>on</code>, les
		ressources PUSH&#233;es d&#233;finie par la directive
		<code>H2PushResource</code> d&#233;clenchent une r&#233;ponse
		interm&#233;diaire 103 avant la r&#233;ponse finale. Cette r&#233;ponse 103
		comporte des en-t&#234;tes <code>Link</code> qui provoquent le
		<code>pr&#233;chargement</code> des ressources consid&#233;r&#233;es. 
            </p>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2maxsessionstreams" id="h2maxsessionstreams">Directive</a> <a name="H2MaxSessionStreams" id="H2MaxSessionStreams">H2MaxSessionStreams</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Nombre maximal de flux actifs par session HTTP/2.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2MaxSessionStreams <em>n</em></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2MaxSessionStreams 100</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir le nombre maximal de flux
		actifs par session (connexion) HTTP/2 accept&#233; par le serveur.
		Selon la RFC 7540, un flux est consid&#233;r&#233; comme actif s'il n'est
		ni <code>en attente</code> ni <code>ferm&#233;</code>.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2MaxSessionStreams 20</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2maxworkeridleseconds" id="h2maxworkeridleseconds">Directive</a> <a name="H2MaxWorkerIdleSeconds" id="H2MaxWorkerIdleSeconds">H2MaxWorkerIdleSeconds</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Nombre maximal de secondes pendant lequel une unit&#233; de
	traitement h2 pourra rester inactive sans &#234;tre arr&#234;t&#233;e.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2MaxWorkerIdleSeconds <em>n</em></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2MaxWorkerIdleSeconds 600</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir le nombre maximal de secondes
		pendant lequel une unit&#233; de traitement h2 pourra rester inactive
		avant de s'arr&#234;ter elle-m&#234;me. Cet arr&#234;t ne peut cependant se
		produire que si le nombre d'unit&#233;s de traitement h2 d&#233;passe
		<code class="directive"><a href="#h2minworkers">H2MinWorkers</a></code>.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2MaxWorkerIdleSeconds 20</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2maxworkers" id="h2maxworkers">Directive</a> <a name="H2MaxWorkers" id="H2MaxWorkers">H2MaxWorkers</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Nombre maximal de threads &#224; utiliser pour chaque processus
	enfant.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2MaxWorkers <em>n</em></code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir le nombre maximal de threads &#224;
		lancer pour le traitement HTTP/2 de chaque processus enfant. Si
		cette directive n'est pas d&#233;finie, <code class="module"><a href="../mod/mod_http2.html">mod_http2</a></code>
		choisira une valeur appropri&#233;e en fonction du module <code>mpm</code>
		utilis&#233;.
		
		This directive sets the maximum number of worker threads to spawn
                per child process for HTTP/2 processing. If this directive is not used,
                <code>mod_http2</code> will chose a value suitable for the <code>mpm</code>
                module loaded.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2MaxWorkers 20</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2minworkers" id="h2minworkers">Directive</a> <a name="H2MinWorkers" id="H2MinWorkers">H2MinWorkers</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Nombre minimal de threads &#224; utiliser pour chaque processus
	enfant.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2MinWorkers <em>n</em></code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir le nombre minimal de threads &#224;
		lancer pour le traitement HTTP/2 de chaque processus enfant. Si
		cette directive n'est pas d&#233;finie, <code class="module"><a href="../mod/mod_http2.html">mod_http2</a></code>
		choisira une valeur appropri&#233;e en fonction du module <code>mpm</code>
		utilis&#233;.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2MinWorkers 10</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2moderntlsonly" id="h2moderntlsonly">Directive</a> <a name="H2ModernTLSOnly" id="H2ModernTLSOnly">H2ModernTLSOnly</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Impose les connexions HTTP/2 en mode "TLS moderne"
	seulement</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2ModernTLSOnly on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2ModernTLSOnly on</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.18 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir si les v&#233;rifications de
		s&#233;curit&#233; sur les connexions HTTP/2 doivent &#234;tre exclusivement en
		mode TLS (https:). Elle peut &#234;tre plac&#233;e au niveau du serveur
		principal ou dans une section <code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>. 
            </p>
            <p>
                Les v&#233;rifications de s&#233;curit&#233; n&#233;cessitent TLSv1.2 au minimum et
		l'absence de tout algorithme de chiffrement list&#233; dans la RFC
		7540, Appendix A. Ces v&#233;rifications seront &#233;tendues lorsque de
		nouveaux pr&#233;requis en mati&#232;re de s&#233;curit&#233; seront mis en place.
            </p>
            <p>
                Le nom provient des d&#233;finitions Mozilla <a href="https://wiki.mozilla.org/Security/Server_Side_TLS">Security/Server
		Side TLS</a> o&#249; il est question de "modern compatibility".
		Mozilla Firefox et d'autres navigateurs imposent la "modern
		compatibility" pour les connexions HTTP/2. Comme toute chose en
		mati&#232;re de s&#233;curit&#233; op&#233;rationnelle, c'est une cible mouvante
		susceptible d'&#233;voluer dans le futur.
            </p>
            <p>
                Un des buts de ces v&#233;rifications dans <code class="module"><a href="../mod/mod_http2.html">mod_http2</a></code> tend &#224; imposer
		ce niveau de s&#233;curit&#233; pour toutes les connexions, et non
		seulement celles en provenance des navigateurs web. Un autre but
		est l'interdiction d'utiliser HTTP/2 en tant que protocole dans
		les n&#233;gociations si les pr&#233;requis ne sont pas respect&#233;s.
            </p>
            <p>
                En fin de compte, la s&#233;curit&#233; de la connexion TLS est d&#233;termin&#233;e
		par les directives de configuration du serveur pour <code class="module"><a href="../mod/mod_ssl.html">mod_ssl</a></code>.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2ModernTLSOnly off</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2push" id="h2push">Directive</a> <a name="H2Push" id="H2Push">H2Push</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Activation/d&#233;sactivation du server push H2</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2Push on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2Push on</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.18 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet d'activer/d&#233;sactiver
		l'utilisation de la fonctionnalit&#233; server push du
		protocole HTTP/2. 
            </p>
            <p>
                Lorsqu'un client demande une ressource particuli&#232;re, le
		protocole HTTP/2 permet au serveur de lui fournir des
		ressources suppl&#233;mentaires. Ceci s'av&#232;re utile lorsque
		ces ressources sont reli&#233;es entre elles, ce qui peut
		laisser supposer que le client va probablement les
		demander dans un d&#233;lai plus ou moins long. Le m&#233;canisme
		de pushing permet alors au client d'&#233;conomiser le temps
		qu'il lui aurait fallu pour demander ces ressources
		suppl&#233;mentaires lui-m&#234;me. Par contre, fournir au client
		des ressources dont il n'a pas besoin ou qu'il poss&#232;de
		d&#233;j&#224; constitue une perte de bande passante.
            </p>
            <p>
                Les server pushes sont d&#233;tect&#233;s en inspectant les
		en-t&#234;tes <code>Link</code> des r&#233;ponses (voir
		https://tools.ietf.org/html/rfc5988 pour la
		sp&#233;cification). Lorsqu'un lien sp&#233;cifi&#233; de cette mani&#232;re
		poss&#232;de l'attribut <code>rel=preload</code>, il est
		consid&#233;r&#233; comme devant faire l'objet d'un push.
            </p>
            <p> 
                Les en-t&#234;tes link des r&#233;ponses sont soit d&#233;finis par
		l'application, soit configur&#233;s via
		<code class="module"><a href="../mod/mod_headers.html">mod_headers</a></code> comme suit :
            </p>
            <div class="example"><h3>Exemple de configuration d'en-t&#234;te link via mod_headers</h3><pre class="prettyprint lang-config">&lt;Location /index.html&gt;
    Header add Link "&lt;/css/site.css&gt;;rel=preload"
    Header add Link "&lt;/images/logo.jpg&gt;;rel=preload"
&lt;/Location&gt;</pre>
</div>
            <p>
                Comme le montre l'exemple, il est possible d'ajouter
		autant d'en-t&#234;tes link que l'on souhaite &#224; une r&#233;ponse, ce qui d&#233;clenchera
		autant de pushes. Cette fonctionnalit&#233; doit donc &#234;tre
		utilis&#233;e avec prudence car le module ne v&#233;rifie pas si
		une ressource n'a pas d&#233;j&#224; &#233;t&#233; "push&#233;e" vers un client.
            </p>
            <p> 
                Les server pushes HTTP/2 sont activ&#233;s par d&#233;faut. Cette
		directive permet de d&#233;sactiver cette fonctionnalit&#233; pour
		le serveur virtuel ou non consid&#233;r&#233;.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2Push off</pre>
</div>
            <p>
                Enfin, il est important de savoir que les pushes ne se
		produisent que si le client en manifeste le d&#233;sir ; la
		plupart des navigateurs le font, mais certains, comme
		Safari 9, ne le font pas. En outre, les pushes ne se produisent que
		pour les ressources de la m&#234;me <em>autorit&#233;</em> que celle de la
		r&#233;ponse originale.
            </p>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2pushdiarysize" id="h2pushdiarysize">Directive</a> <a name="H2PushDiarySize" id="H2PushDiarySize">H2PushDiarySize</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Taille du journal des Pushes H2</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2PushDiarySize n</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2PushDiarySize 256</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.19 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir le nombre maximum de pushes
		qui seront enregistr&#233;s pour une connexion HTTP/2. Elle peut &#234;tre
		plac&#233;e dans une section <code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code> afin de d&#233;finir le nombre
		de pushes pour le serveur virtuel consid&#233;r&#233;. 
            </p>
            <p>
                Le journal des pushes enregistre un condens&#233; (sous la forme d'un
		nombre de 64 bits) des ressources pr&#233;charg&#233;es (leurs URLs) afin
		d'&#233;viter les duplications de pushes pour une m&#234;me connexion.
		Cependant, ces donn&#233;es ne sont pas conserv&#233;es, et les clients
		qui ouvrent une nouvelle connexion se verront &#224; nouveau affecter les
		m&#234;mes pushes. A ce titre, une &#233;tude est en cours pour permettre
		au client de supprimer le condens&#233; des ressources qu'il poss&#232;de
		d&#233;j&#224;, et par l&#224;-m&#234;me de r&#233;initialiser le journal des pushes &#224;
		chaque nouvelle connexion.
            </p>
            <p>
                Si la taille maximale est atteinte, les nouvelles entr&#233;es
		remplacent les plus anciennes. Une entr&#233;e du journal n&#233;cessitant
		8 octets, un journal de 256 entr&#233;es consomme 2 Ko de m&#233;moire.
            </p>
            <p>
                Si cette directive est d&#233;finie &#224; 0, le journal des pushes est
		d&#233;sactiv&#233;.
            </p>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2pushpriority" id="h2pushpriority">Directive</a> <a name="H2PushPriority" id="H2PushPriority">H2PushPriority</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Priorit&#233; des pushes H2</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2PushPriority mime-type [after|before|interleaved] [weight]</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2PushPriority * After 16</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.18 du serveur HTTP
	Apache. N&#233;cessite la biblioth&#232;que nghttp2 version 1.5.0 ou sup&#233;rieure.</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir une gestion de priorit&#233; des
		pushes en fonction du type de contenu de la r&#233;ponse. Elle est en
		g&#233;n&#233;ral d&#233;finie au niveau du serveur principal, mais peut aussi
		l'&#234;tre au niveau d'un serveur virtuel. 
            </p>
            <p>
                Les pushes HTTP/2 sont toujours li&#233;s &#224; une requ&#234;te client.
		Chaque paire requ&#234;te/r&#233;ponse de cette sorte, ou <em>flux</em>,
		poss&#232;de une d&#233;pendance et un poids qui d&#233;finissent la
		<em>priorit&#233;</em> du flux. 
            </p>
            <p>
                Lorsqu'un flux <em>d&#233;pend</em> d'un autre, disons X d&#233;pend de Y,
		alors Y re&#231;oit toute la bande passante avant que X n'en re&#231;oive
		ne serait-ce qu'une partie. Notez que cela ne signifie en rien
		que Y bloque X ; en effet, si Y n'a aucune donn&#233;e &#224; envoyer,
		toute la bande passante qui lui est allou&#233;e peut &#234;tre utilis&#233;e
		par X.
            </p>
            <p>
                Lorsque plusieurs flux d&#233;pendent d'un m&#234;me autre flux, disons X1
		et X2 d&#233;pendent tous deux de Y, le <em>poids</em> d&#233;termine la
		bande passante allou&#233;e. Ainsi, si X1 et X2 poss&#232;dent le m&#234;me
		poids, ils recevront tous deux la moiti&#233; de la bande passante
		disponible. Si le poids de X1 est &#233;gal au double de celui de X2,
		X1 recevra une bande passante double de celle de X2.
		
            </p>
            <p> 
                En fin de compte, tout flux d&#233;pend du flux <em>racine</em> qui
		re&#231;oit toute la bande passante disponible mais n'envoie jamais
		de donn&#233;es. Cette bande passante est ainsi r&#233;partie entre les flux
		enfants selon leur poids. Ces derniers l'utilisent alors pour
		envoyer leurs donn&#233;es ou pour la r&#233;partir entre leurs propres
		flux enfants, et ainsi de suite. Si aucun des flux enfants n'a
		de donn&#233;es &#224; envoyer, la bande passante est attribu&#233;e &#224; d'autres
		flux selon les m&#234;mes r&#232;gles.
            </p>
            <p> 
                Ce syst&#232;me de priorit&#233;s a &#233;t&#233; con&#231;u de fa&#231;on a toujours pouvoir
		utiliser la bande passante disponible tout en d&#233;finissant des
		priorit&#233;s et en attribuant des poids aux diff&#233;rents flux. Ainsi,
		tous les flux sont en g&#233;n&#233;ral initialis&#233;s par le client qui
		lui-m&#234;me d&#233;finit les priorit&#233;s.
            </p>
            <p>
                Seul le fait de savoir qu'un flux implique un PUSH permet au
		serveur de d&#233;cider quelle est la priorit&#233; <em>initiale</em> d'un
		tel flux. Dans les exemples ci-dessous, X est le flux client. Il
		d&#233;pend de Y et le serveur d&#233;cide de "PUSHer" les flux P1 et P2
		sur X.
            </p>
            <p>
                La r&#232;gle de priorit&#233; par d&#233;faut est :
            </p>
            <div class="example"><h3>R&#232;gle de priorit&#233; par d&#233;faut</h3><pre class="prettyprint lang-config">H2PushPriority * After 16</pre>
</div>
            <p>
                Elle peut se traduire par "Envoyer un flux PUSH avec tout type
		de contenu et d&#233;pendant du flux client avec le poids 16". P1 et
		P2 seront alors envoy&#233;s apr&#232;s X, et comme leurs poids sont
		identiques, il se verront allouer la m&#234;me quantit&#233; de bande
		passante.
            </p>
            <div class="example"><h3>R&#232;gle de priorit&#233; entrelac&#233;e</h3><pre class="prettyprint lang-config">H2PushPriority text/css Interleaved 256</pre>
</div>
            <p>
                Ce qui peut se traduire par "Envoyer toute ressource CSS dans la
		m&#234;me d&#233;pendance et avec le m&#234;me poids que le flux client". Si le
		type de contenu de P1 est "text/css", il d&#233;pendra de Y (comme X)
		et son poids effectif sera calcul&#233; selon la formule : <code>P1ew
		= Xw * (P1w / 256)</code>. Si P1w est de 256, Le poids effectif
		de P1 sera le m&#234;me que celui de X. Si X et P1 ont des donn&#233;es &#224;
		envoyer, il se verront allouer la m&#234;me quantit&#233; de bande
		passante.
            </p>
            <p>
                Avec un Pw de 512, un flux entrelac&#233; et PUSH&#233; aura un poids
		double de celui de X. Avec un poids de 128, son poids ne sera
		que la moiti&#233; de celui de X. Notez que les poids effectifs sont
		toujours plafonn&#233;s &#224; 256.
		
            </p>
            <div class="example"><h3>R&#232;gle de priorit&#233; Before</h3><pre class="prettyprint lang-config">H2PushPriority application/json Before</pre>
</div>
            <p>
                Dans cet exemple, tout flux PUSH&#233; dont le contenu est de type
		'application/json' sera envoy&#233; <em>avant</em> X, ce qui rend P1
		d&#233;pendant de Y et X d&#233;pendant de P1. Ainsi, X sera mis en
		attente aussi longtemps que P1 aura des donn&#233;es &#224; envoyer. Le
		poids effectif est h&#233;rit&#233; du flux client, et l'attribution d'un
		poids sp&#233;cifique n'est pas autoris&#233;e.
            </p>
            <p>
                Vous devez garder &#224; l'esprit que les sp&#233;cifications en mati&#232;re
		de priorit&#233;s sont limit&#233;es par les ressources disponibles du
		serveur. Si un serveur ne dispose d'aucun processus/thread de
		travail pour les flux PUSH&#233;s, les donn&#233;es du flux consid&#233;r&#233; ne
		seront envoy&#233;es que lorsque les autres flux auront termin&#233;
		l'envoi des leurs.
            </p>
            <p>
                Enfin et surtout, il convient de tenir compte de certaines
		particularit&#233;s de la syntaxe de cette directive :
             </p>
            <ol>
                <li>'*' est la seule expression permettant de remplacer tout
		type de contenu. 'image/*' ne fonctionnera pas.</li>
                <li>La d&#233;pendance par d&#233;faut est 'After'.</li>
                <li>Il existe aussi des poids par d&#233;faut : pour 'After' le poids
		est de 16, alors que pour 'interleaved' il est de 256. 
                </li>
            </ol>
            <div class="example"><h3>Exemples de r&#232;gles</h3><pre class="prettyprint lang-config">H2PushPriority application/json 32         # une r&#232;gle de priorit&#233; 'After'
H2PushPriority image/jpeg before           # poid h&#233;rit&#233;
H2PushPriority text/css   interleaved      # poids de 256 par d&#233;faut</pre>
</div>
         
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2pushresource" id="h2pushresource">Directive</a> <a name="H2PushResource" id="H2PushResource">H2PushResource</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;clare des ressources &#224; proposer ("pusher") au client</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2PushResource [add] path [critical]</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.24 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Lorsqu'il sont activ&#233;s pour un r&#233;pertoire, les PUSHes HTTP/2 seront
		tent&#233;s pour tous les chemins ajout&#233;s via cette directive. Cette
		derni&#232;re peut &#234;tre utilis&#233;e plusieurs fois pour le m&#234;me
		r&#233;pertoire.
            </p>
            <p>
                Cette directive propose des ressources beaucoup plus t&#244;t que les
		en-t&#234;tes <code>Link</code> de <code class="module"><a href="../mod/mod_headers.html">mod_headers</a></code>.
		<code class="module"><a href="../mod/mod_http2.html">mod_http2</a></code> pr&#233;sente ces ressources au client via
		une r&#233;ponse interm&#233;diaire <code>103 Early Hints</code>. Ceci
		implique que les clients qui ne supportent pas PUSH recevront
		quand-m&#234;me rapidement des propositions de pr&#233;chargement.
            </p>
            <p>
                A la diff&#233;rence de la d&#233;finition d'en-t&#234;tes de r&#233;ponse
		<code>Link</code> via <code class="module"><a href="../mod/mod_headers.html">mod_headers</a></code>, cette
		directive n'aura d'effet que pour les connexions HTTP/2. 
            </p>
            <p>
                En ajoutant l'option <code>critical</code> &#224; une telle
		ressource, le serveur la traitera prioritairement, et une fois
		les donn&#233;es disponibles, ces derni&#232;res seront envoy&#233;es avant les
		donn&#233;es de la requ&#234;te principale.
            </p>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2serializeheaders" id="h2serializeheaders">Directive</a> <a name="H2SerializeHeaders" id="H2SerializeHeaders">H2SerializeHeaders</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Active/d&#233;sactive la s&#233;rialisation du traitement des
	requ&#234;tes/r&#233;ponses</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2SerializeHeaders on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2SerializeHeaders off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir si les requ&#234;tes HTTP/2 doivent
		&#234;tre s&#233;rialis&#233;es au format HTTP/1.1 pour &#234;tre trait&#233;es par le
		noyau de <code>httpd</code>, ou si les donn&#233;es binaires re&#231;ues
		doivent &#234;tre pass&#233;es directement aux <code>request_rec</code>s.
            </p>
            <p>
                La s&#233;rialisation d&#233;grade les performances, mais garantit une
		meilleure compatibilit&#233; ascendante lorsque des filtres ou
		programmes accroche personnalis&#233;s en ont besoin.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2SerializeHeaders on</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2streammaxmemsize" id="h2streammaxmemsize">Directive</a> <a name="H2StreamMaxMemSize" id="H2StreamMaxMemSize">H2StreamMaxMemSize</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Quantit&#233; maximale de donn&#233;es en sortie mises en tampon par
	flux.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2StreamMaxMemSize <em>bytes</em></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2StreamMaxMemSize 65536</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir la quantit&#233; maximale de
		donn&#233;es en sortie mises en tampon m&#233;moire pour un flux actif. Ce
		tampon m&#233;moire n'est pas allou&#233; pour chaque flux en tant que
		tel. Les quantit&#233;s de m&#233;moire sont d&#233;finies en fonction de
		cette limite lorsqu'elles sont sur le point d'&#234;tre allou&#233;es. Le
		flux s'arr&#234;te lorsque la limite a &#233;t&#233; atteinte, et ne reprendra
		que lorsque les donn&#233;es du tampon auront &#233;t&#233; transmises au
		client.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2StreamMaxMemSize 128000</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2tlscooldownsecs" id="h2tlscooldownsecs">Directive</a> <a name="H2TLSCoolDownSecs" id="H2TLSCoolDownSecs">H2TLSCoolDownSecs</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td /></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2TLSCoolDownSecs <em>seconds</em></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2TLSCoolDownSecs 1</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.18 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet de sp&#233;cifier le nombre de secondes avant
		lequel une connexion TLS inactive va diminuer
		la taille des paquets de donn&#233;es &#224; une valeur inf&#233;rieure (~1300
		octets). Elle peut &#234;tre d&#233;finie au niveau du serveur principal
		ou pour un <code class="directive"><a href="../mod/core.html#serveur virtuel">&lt;serveur
		virtuel&gt;</a></code> sp&#233;cifique. 
            </p>
            <p>
                Voir la directive <code class="directive"><a href="#h2tlswarmupsize">H2TLSWarmUpSize</a></code> pour une description
		du "pr&#233;chauffage" de TLS. La directive <code class="directive">H2TLSCoolDownSecs</code> met en
		lumi&#232;re le fait que les connexions peuvent se d&#233;t&#233;riorer au bout
		d'un certain temps (et au fur et &#224; mesure des corrections du
		flux TCP), et cela m&#234;me si elle sont inactives. Pour ne pas
		d&#233;t&#233;riorer les performances d'une mani&#232;re g&#233;n&#233;rale, il est par
		cons&#233;quent pr&#233;f&#233;rable de revenir &#224; la phase de pr&#233;chauffage
		lorsqu'aucune donn&#233;e n'a &#233;t&#233; transmise pendant un certain nombre
		de secondes. 
            </p>
            <p>
                Dans les situations o&#249; les connexions peuvent &#234;tre consid&#233;r&#233;es
		comme fiables, ce d&#233;lai peut &#234;tre d&#233;sactiv&#233; en d&#233;finissant cette
		directive &#224; 0. 
            </p>
            <p>
                Dans l'exemple suivant, la directive est d&#233;finie &#224; 0, ce qui
		d&#233;sactive tout retour &#224; une phase de pr&#233;chauffage des connexions
		TLS. Les connexions TLS d&#233;j&#224; pr&#233;chauff&#233;es conservent donc toujours
		leur taille de paquet de donn&#233;es maximale.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2TLSCoolDownSecs 0</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2tlswarmupsize" id="h2tlswarmupsize">Directive</a> <a name="H2TLSWarmUpSize" id="H2TLSWarmUpSize">H2TLSWarmUpSize</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td /></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2TLSWarmUpSize <em>amount</em></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2TLSWarmUpSize 1048576</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible &#224; partir de la version 2.4.18 du serveur HTTP
	Apache.</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir le nombre d'octets &#224; envoyer
		dans les petits enregistrements TLS (~1300 octets) avant
		d'atteindre leur taille maximale de 16 ko pour les connexions
		https: HTTP/2. Elle peut &#234;tre d&#233;finie au niveau du serveur
		principal ou pour des <code class="directive"><a href="../mod/core.html#serveurs virtuels">&lt;Serveurs virtuels&gt;</a></code> sp&#233;cifiques. 
            </p>
            <p>
                Les mesures effectu&#233;es par les <a href="https://www.igvita.com">laboratoires de performances de
		Google</a> montrent que les meilleurs performances sont atteintes
		pour les connexions TLS si la taille initiale des
		enregistrements reste en de&#231;a du niveau du MTU afin de permettre
		&#224; la totatlit&#233; d'un enregistrement d'entrer dans un paquet IP.
            </p>
            <p>
                Comme TCP ajuste son contr&#244;le de flux et sa taille de fen&#234;tre,
		des enregistrements TLS trop longs peuvent rester en file
		d'attente ou m&#234;me &#234;tre perdus et devoir alors &#234;tre r&#233;&#233;mis. Ceci
		est bien entendu vrai pour tous les paquets ; cependant, TLS a
		besoin de la totalit&#233; de l'enregistrement pour pouvoir le
		d&#233;chiffrer. Tout octet manquant rendra impossible l'utilisation
		de ceux qui ont &#233;t&#233; re&#231;us.
            </p>
            <p>
                Lorqu'un nombre suffisant d'octets a &#233;t&#233; transmis avec succ&#232;s,
		la connexion TCP est stable, et la taille maximale (16 ko) des
		enregistrements TLS peut &#234;tre utilis&#233;e pour des performances
		optimales.
            </p>
            <p>
                Dans les architectures o&#249; les serveurs sont atteints par des
		machines locales ou pour les connexions de confiance seulement,
		la valeur de cette directive peut &#234;tre d&#233;finie &#224; 0, ce qui a
		pour effet de d&#233;sactiver la "phase de chauffage".
            </p>
            <p>
                Dans l'exemple suivant, la phase de chauffage est effectivement
		d&#233;sactiv&#233;e en d&#233;finissant la directive &#224; 0.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2TLSWarmUpSize 0</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2upgrade" id="h2upgrade">Directive</a> <a name="H2Upgrade" id="H2Upgrade">H2Upgrade</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Activation/D&#233;sactivation du protocole de mise &#224; jour H2</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2Upgrade on|off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2Upgrade on pour h2c, off pour h2</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet d'activer/d&#233;sactiver l'utilisation de la
		m&#233;thode de mise &#224; jour pour passer de HTTP/1.1 &#224; HTTP/2. Elle
		doit &#234;tre plac&#233;e dans une section <code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code> afin d'activer la mise &#224;
		jour vers HTTP/2 pour le serveur virtuel consid&#233;r&#233;. 
            </p>
            <p>
                Cette m&#233;thode de changement de protocole est d&#233;finie dans
		HTTP/1.1 et utilise l'en-t&#234;te "Upgrade" (d'o&#249; son nom) pour
		indiquer l'intention d'utiliser un autre protocole. Cet en-t&#234;te
		peut &#234;tre pr&#233;sent dans toute requ&#234;te sur une connexion HTTP/1.1.
            </p>
            <p>
                Elle activ&#233;e par d&#233;faut pour les transmissions en clair
		(h2c), et d&#233;sactiv&#233;e avec TLS (h2), comme pr&#233;conis&#233; par la RFC
		7540. 
            </p>
            <p>
                Sachez cependant que les mises &#224; jour ne sont accept&#233;es que pour
		les requ&#234;tes qui ne poss&#232;dent pas de corps. Le requ&#234;tes de type
		POST et PUT avec un contenu ne feront jamais l'objet d'une mise
		&#224; jour vers HTTP/2. Se r&#233;f&#233;rer &#224; la documentation de la
		directive <code class="directive"><a href="#h2direct">H2Direct</a></code> pour
		envisager une alternative &#224; Upgrade.
            </p>
            <p>
                Cette directive n'a d'effet que si h2 ou h2c est activ&#233; via la
		directive <code class="directive"><a href="../mod/core.html#protocols">Protocols</a></code>.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2Upgrade on</pre>
</div>
        
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="h2windowsize" id="h2windowsize">Directive</a> <a name="H2WindowSize" id="H2WindowSize">H2WindowSize</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Taille maximale des paquets de donn&#233;es pour les transmissions client
	vers serveur.</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>H2WindowSize <em>bytes</em></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>H2WindowSize 65535</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_http2</td></tr>
</table>
            <p>
                Cette directive permet de d&#233;finir la taille maximale des paquets
		de donn&#233;es envoy&#233;s par le client au serveur, et
		limite la quantit&#233; de donn&#233;es que le serveur doit mettre en
		tampon. Le client arr&#234;tera d'envoyer des donn&#233;es sur un flux
		lorsque cette limite sera atteinte jusqu'&#224; ce que le serveur
		indique qu'il dispose d'un espace suffisant (car il aura trait&#233;
		une partie des donn&#233;es).
            </p><p>
                Cette limite n'affecte que les corps de requ&#234;tes, non les
		m&#233;tadonn&#233;es comme les en-t&#234;tes. Par contre, elle n'affecte pas
		les corps de r&#233;ponses car la taille maximale de ces derniers est
		g&#233;r&#233;e au niveau des clients.
            </p>
            <div class="example"><h3>Exemple</h3><pre class="prettyprint lang-config">H2WindowSize 128000</pre>
</div>
        
</div>
</div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_http2.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_http2.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="../images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/mod/mod_http2.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2018 The Apache Software Foundation.<br />Autoris&#233; sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>