<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>mod_session - Serveur HTTP Apache Version 2.4</title>
<link href="../style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="../style/css/prettify.css" />
<script src="../style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="../images/favicon.ico" rel="shortcut icon" /></head>
<body>
<div id="page-header">
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p>
<p class="apache">Serveur HTTP Apache Version 2.4</p>
<img alt="" src="../images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="../">Version 2.4</a> &gt; <a href="./">Modules</a></div>
<div id="page-content">
<div id="preamble"><h1>Module Apache mod_session</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_session.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_session.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div>
<table class="module"><tr><th><a href="module-dict.html#Description">Description:</a></th><td>Support des sessions</td></tr>
<tr><th><a href="module-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">Identificateur&#160;de&#160;Module:</a></th><td>session_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">Fichier&#160;Source:</a></th><td>mod_session.c</td></tr>
<tr><th><a href="module-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.3 d'Apache</td></tr></table>
<h3>Sommaire</h3>

    <div class="warning"><h3>Avertissement</h3>
      <p>Le module session fait usage des cookies HTTP, et peut &#224; ce
      titre &#234;tre victime d'attaques de type Cross Site Scripting, ou
      divulguer des informations &#224; caract&#232;re priv&#233; aux clients. Veuillez
      vous assurer que les risques ainsi encourus ont &#233;t&#233; pris en compte
      avant d'activer le support des sessions sur votre serveur.</p>
    </div>

    <p>Ce module fournit le support d'une interface de session pour
    chaque utilisateur au niveau du serveur global. Les sessions
    permettent de transmettre diverses informations  : l'utilisateur
    est-il connect&#233; ou non, ou toute autre information qui doit &#234;tre
    conserv&#233;e d'une requ&#234;te &#224; l'autre.</p>

    <p>Les sessions peuvent &#234;tre stock&#233;es sur le serveur, ou au niveau
    du navigateur. Les sessions peuvent &#233;galement &#234;tre chiffr&#233;es pour une
    s&#233;curit&#233; accrue. Ces fonctionnalit&#233;s sont r&#233;parties entre diff&#233;rents
    modules compl&#233;mentaires de <code class="module"><a href="../mod/mod_session.html">mod_session</a></code> :
    <code class="module"><a href="../mod/mod_session_crypto.html">mod_session_crypto</a></code>,
    <code class="module"><a href="../mod/mod_session_cookie.html">mod_session_cookie</a></code> et
    <code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code>. Chargez les modules appropri&#233;s
    en fonction des besoins du serveur (soit statiquement &#224; la
    compilation, soit dynamiquement via la directive <code class="directive"><a href="../mod/mod_so.html#loadmodule">LoadModule</a></code>).</p>

    <p>Les sessions peuvent &#234;tre manipul&#233;es par d'autres modules qui
    d&#233;pendent de la session, ou la session peut &#234;tre lue et &#233;crite dans
    des variables d'environnement et des en-t&#234;tes HTTP, selon les
    besoins.</p>

</div>
<div id="quickview"><a href="https://www.apache.org/foundation/contributing.html" class="badge"><img src="https://www.apache.org/images/SupportApache-small.png" alt="Support Apache!" /></a><h3>Sujets</h3>
<ul id="topics">
<li><img alt="" src="../images/down.gif" /> <a href="#whatisasession">Qu'est-ce qu'une session ?</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#whocanuseasession">Qui peut utiliser une session
    ?</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#serversession">Stockage des sessions sur le
    serveur</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#browsersession">Stockage des sessions au niveau
    du navigateur</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#basicexamples">Exemples simples</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessionprivacy">Confidentialit&#233; des
    sessions</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#cookieprivacy">Confidentialit&#233; du cookie</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#authentication">Support des sessions pour
    l'authentification</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#integration">Int&#233;gration des sessions avec les
    applications externes</a></li>
</ul><h3 class="directives">Directives</h3>
<ul id="toc">
<li><img alt="" src="../images/down.gif" /> <a href="#session">Session</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessionenv">SessionEnv</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessionexclude">SessionExclude</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessionheader">SessionHeader</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessioninclude">SessionInclude</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessionmaxage">SessionMaxAge</a></li>
</ul>
<h3>Traitement des bugs</h3><ul class="seealso"><li><a href="https://www.apache.org/dist/httpd/CHANGES_2.4">Journal des modifications de httpd</a></li><li><a href="https://bz.apache.org/bugzilla/buglist.cgi?bug_status=__open__&amp;list_id=144532&amp;product=Apache%20httpd-2&amp;query_format=specific&amp;order=changeddate%20DESC%2Cpriority%2Cbug_severity&amp;component=mod_session">Probl&#232;mes connus</a></li><li><a href="https://bz.apache.org/bugzilla/enter_bug.cgi?product=Apache%20httpd-2&amp;component=mod_session">Signaler un bug</a></li></ul><h3>Voir aussi</h3>
<ul class="seealso">
<li><code class="module"><a href="../mod/mod_session_cookie.html">mod_session_cookie</a></code></li>
<li><code class="module"><a href="../mod/mod_session_crypto.html">mod_session_crypto</a></code></li>
<li><code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code></li>
<li><a href="#comments_section">Commentaires</a></li></ul></div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="whatisasession" id="whatisasession">Qu'est-ce qu'une session ?</a></h2>
      <p>Au coeur de l'interface de session se trouve une table de
      paires cl&#233;/valeur qui sont accessibles d'une requ&#234;te du navigateur
      &#224; l'autre. Les valeurs de cl&#233;s peuvent se voir affecter toute cha&#238;ne
      de caract&#232;res valide, en fonction des besoins de l'application qui
      fait usage de la session.</p>

      <p>Une "session" est une cha&#238;ne
      <strong>application/x-www-form-urlencoded</strong> qui contient la
      paire cl&#233;/valeur d&#233;finie par la <a href="http://www.w3.org/TR/html4/">sp&#233;cification HTML</a>.</p>

      <p>Selon les souhaits de l'administrateur, la session peut &#234;tre
      chiffr&#233;e et cod&#233;e en base64 avant d'&#234;tre soumise au dispositif de
      stockage.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="whocanuseasession" id="whocanuseasession">Qui peut utiliser une session
    ?</a></h2>
      <p>L'interface de session a &#233;t&#233; con&#231;ue &#224; l'origine pour &#234;tre
      utilis&#233;e par d'autres modules du serveur comme
      <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code> ; les applications &#224; base de
      programmes CGI peuvent cependant se voir accorder l'acc&#232;s au
      contenu d'une session via la variable d'environnement
      HTTP_SESSION. Il est possible de modifier et/ou de mettre &#224; jour
      une session en ins&#233;rant un en-t&#234;te de r&#233;ponse HTTP contenant les
      nouveaux param&#232;tres de session.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="serversession" id="serversession">Stockage des sessions sur le
    serveur</a></h2>
      <p>Apache peut &#234;tre configur&#233; pour stocker les sessions
      utilisateurs sur un serveur particulier ou un groupe de serveurs.
      Cette fonctionnalit&#233; est similaire aux sessions disponibles sur
      les serveurs d'applications courants.</p>

      <p>Selon la configuration, les sessions sont suivies &#224;
      partir d'un identifiant de session stock&#233; dans un cookie, ou
      extraites de la cha&#238;ne de param&#232;tres de l'URL, comme dans les
      requ&#234;tes GET courantes.</p>

      <p>Comme le contenu de la session est stock&#233; exclusivement sur le
      serveur, il est n&#233;cessaire de pr&#233;server la confidentialit&#233; de ce
      contenu. Ceci a des implications en mati&#232;re de performance et de
      consommation de ressources lorsqu'un grand nombre de sessions est
      stock&#233;, ou lorsqu'un grand nombre de serveurs doivent se partager
      les sessions entre eux.</p>

      <p>Le module <code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code> permet de stocker
      les sessions utilisateurs dans une base de donn&#233;es SQL via le
      module <code class="module"><a href="../mod/mod_dbd.html">mod_dbd</a></code>.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="browsersession" id="browsersession">Stockage des sessions au niveau
    du navigateur</a></h2>
      <p>Dans les environnements &#224; haut trafic o&#249; le stockage d'une
      session sur un serveur consomme trop
      de ressources, il est possible de stocker le contenu de la session
      dans un cookie au niveau du navigateur client.</p>

      <p>Ceci a pour avantage de ne n&#233;cessiter qu'une quantit&#233; minimale de
      ressources sur le serveur pour suivre les sessions, et &#233;vite &#224;
      plusieurs serveurs parmi une for&#234;t de serveurs de devoir partager
      les informations de session.</p>

      <p>Le contenu de la session est cependant pr&#233;sent&#233; au client, avec
      pour cons&#233;quence un risque de perte de confidentialit&#233;. Le module
      <code class="module"><a href="../mod/mod_session_crypto.html">mod_session_crypto</a></code> peut &#234;tre configur&#233; pour
      chiffrer le contenu de la session avant qu'elle soit stock&#233;e au
      niveau du client.</p>

      <p>Le module <code class="module"><a href="../mod/mod_session_cookie.html">mod_session_cookie</a></code> permet de stocker
      les sessions au niveau du navigateur dans un cookie HTTP.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="basicexamples" id="basicexamples">Exemples simples</a></h2>

      <p>La cr&#233;ation d'une session consiste simplement &#224; ouvrir la
      session, et &#224; d&#233;cider de l'endroit o&#249; elle doit &#234;tre stock&#233;e. Dans
      l'exemple suivant, la session sera stock&#233;e au niveau du
      navigateur, dans un cookie nomm&#233; <code>session</code>.</p>

      <div class="example"><h3>Session stock&#233;e au niveau du navigateur</h3><pre class="prettyprint lang-config">Session On
SessionCookieName session path=/</pre>
</div>

      <p>Une session est inutile s'il n'est pas possible d'y lire
      ou d'y &#233;crire. L'exemple suivant montre comment des valeurs
      peuvent &#234;tre inject&#233;es dans une session &#224; l'aide d'un en-t&#234;te de
      r&#233;ponse HTTP pr&#233;d&#233;termin&#233; nomm&#233;
      <code>X-Replace-Session</code>.</p>

      <div class="example"><h3>Ecriture dans une session</h3><pre class="prettyprint lang-config">Session On
SessionCookieName session path=/
SessionHeader X-Replace-Session</pre>
</div>

      <p>L'en-t&#234;te doit contenir des paires cl&#233;/valeur sous le m&#234;me
      format que celui de la cha&#238;ne d'argument d'une URL, comme dans
      l'exemple suivant. Donner pour valeur &#224; une cl&#233; la cha&#238;ne vide a
      pour effet de supprimer la cl&#233; de la session.</p>

      <div class="example"><h3>Script CGI pour &#233;crire dans une session</h3><pre class="prettyprint lang-sh">#!/bin/bash
echo "Content-Type: text/plain"
echo "X-Replace-Session: key1=foo&amp;key2=&amp;key3=bar"
echo
env</pre>
</div>

      <p>Selon la configuration, les informations de la session peuvent
      &#234;tre extraites de la variable d'environnement HTTP_SESSION. Par
      d&#233;faut la session est priv&#233;e, et cette fonctionnalit&#233; doit donc
      &#234;tre explicitement activ&#233;e via la directive <code class="directive"><a href="#sessionenv">SessionEnv</a></code>.</p>

      <div class="example"><h3>Lecture depuis une session</h3><pre class="prettyprint lang-config">Session On
SessionEnv On
SessionCookieName session path=/
SessionHeader X-Replace-Session</pre>
</div>

      <p>Une fois la lecture effectu&#233;e, la variable CGI
      <code>HTTP_SESSION</code> doit contenir la valeur
      <code>cl&#233;1=foo&amp;cl&#233;3=bar</code>.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="sessionprivacy" id="sessionprivacy">Confidentialit&#233; des
    sessions</a></h2>

      <p>En utilisant la fonctionnalit&#233; de votre navigateur "Afficher
      les cookies", vous pouvez voir une r&#233;pr&#233;sentation de la session
      sous forme de texte en clair. Ceci peut poser probl&#232;me si le
      contenu de la session doit &#234;tre dissimul&#233; &#224; l'utilisateur final,
      ou si un tiers acc&#232;de sans autorisation aux informations de
      session.</p>

      <p>&#192; ce titre, le contenu de la session peut &#234;tre chiffr&#233; &#224; l'aide
      du module <code class="module"><a href="../mod/mod_session_crypto.html">mod_session_crypto</a></code> avant d'&#234;tre stock&#233;
      au niveau du navigateur.</p>

      <div class="example"><h3>Session chiffr&#233;e avant stockage au niveau du
      navigateur</h3><pre class="prettyprint lang-config">Session On
SessionCryptoPassphrase secret
SessionCookieName session path=/</pre>
</div>

      <p>La session sera automatiquement d&#233;chiffr&#233;e &#224; la lecture, et
      rechiffr&#233;e par Apache lors de la sauvegarde, si bien que
      l'application sous-jacente qui utilise la session n'a pas &#224; se
      pr&#233;occuper de savoir si un chiffrement a &#233;t&#233; mis en oeuvre ou
      non.</p>

      <p>Les sessions stock&#233;es sur le serveur plut&#244;t qu'au niveau du
      navigateur peuvent aussi &#234;tre chiffr&#233;es, pr&#233;servant par l&#224;-m&#234;me la
      confidentialit&#233; lorsque des informations sensibles sont partag&#233;es
      entre les serveurs web d'une for&#234;t de serveurs &#224; l'aide du module
      <code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code>.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="cookieprivacy" id="cookieprivacy">Confidentialit&#233; du cookie</a></h2>

      <p>Le m&#233;canisme de cookie HTTP offre aussi des fonctionnalit&#233;s
      quant &#224; la confidentialit&#233;, comme la possibilit&#233; de
      restreindre le transport du cookie aux pages prot&#233;g&#233;es par SSL
      seulement, ou l'interdiction pour les scripts java qui
      s'ex&#233;cutent au niveau du navigateur d'obtenir l'acc&#232;s au contenu
      du cookie.</p>

      <div class="warning"><h3>Avertissement</h3>
      <p>Certaines fonctionnalit&#233;s de confidentialit&#233; du cookie HTTP ne
      sont pas standardis&#233;es, ou ne sont pas toujours impl&#233;ment&#233;es au
      niveau du navigateur. Les modules de session vous permettent de
      d&#233;finir les param&#232;tres du cookie, mais il n'est pas garanti que la
      confidentialit&#233; sera respect&#233;e par le navigateur. Si la s&#233;curit&#233;
      est la principale pr&#233;occupation, chiffrez le contenu de la session
      avec le module <code class="module"><a href="../mod/mod_session_crypto.html">mod_session_crypto</a></code>, ou stockez la
      session sur le serveur avec le module
      <code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code>.</p>
      </div>

      <p>Les param&#232;tres standards du cookie peuvent &#234;tre sp&#233;cifi&#233;s apr&#232;s
      le nom du cookie comme dans l'exemple suivant :</p>

      <div class="example"><h3>D&#233;finition des param&#232;tres du cookie</h3><pre class="prettyprint lang-config">Session On
SessionCryptoPassphrase secret
SessionCookieName session path=/private;domain=example.com;httponly;secure;</pre>
</div>

      <p>Dans les cas o&#249; le serveur Apache sert de frontal pour des
      serveurs d'arri&#232;re-plan, il est possible de supprimer les cookies
      de session des en-t&#234;tes HTTP entrants &#224; l'aide de la directive
      <code class="directive"><a href="../mod/mod_session_cookie.html#sessioncookieremove">SessionCookieRemove</a></code>. Ceci
      permet d'emp&#234;cher les serveurs d'arri&#232;re-plan d'acc&#233;der au contenu
      des cookies de session.
      </p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="authentication" id="authentication">Support des sessions pour
    l'authentification</a></h2>

      <p>Comme il est possible de le faire avec de nombreux serveurs
      d'applications, les modules d'authentification peuvent utiliser
      une session pour stocker le nom d'utilisateur et le mot de passe
      apr&#232;s connexion. Le module <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code> par
      exemple, sauvegarde les nom de connexion et mot de passe de
      l'utilisateur dans une session.</p>

      <div class="example"><h3>Authentification &#224; base de formulaire</h3><pre class="prettyprint lang-config">Session On
SessionCryptoPassphrase secret
SessionCookieName session path=/
AuthFormProvider file
AuthUserFile "conf/passwd"
AuthType form
AuthName realm
#...</pre>
</div>

      <p>Pour la documentation et des exemples complets, voir le module
      <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code>.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="integration" id="integration">Int&#233;gration des sessions avec les
    applications externes</a></h2>

      <p>Pour que les sessions soient utiles, leur contenu doit &#234;tre
      accessible aux applications externes, et ces derni&#232;res doivent
      elles-m&#234;mes &#234;tre capables d'&#233;crire une session.</p>

      <p>L'exemple type est une application qui modifie le mot de passe
      d'un utilisateur d&#233;fini par <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code>. Cette
      application doit pouvoir extraire les nom d'utilisateur et mot de
      passe courants de la session, effectuer les modifications
      demand&#233;es, puis &#233;crire le nouveau mot de passe dans la session,
      afin que la transition vers le nouveau mot de passe soit
      transparente.</p>

      <p>Un autre exemple met en jeu une application qui enregistre un
      nouvel utilisateur pour la premi&#232;re fois. Une fois
      l'enregistrement termin&#233;, le nom d'utilisateur et le mot de passe
      sont &#233;crits dans la session, fournissant l&#224; aussi une transition
      transparente.</p>

      <dl>
      <dt>Modules Apache</dt>
      <dd>Selon les besoins, les modules du serveur peuvent utiliser
      l'API <strong>mod_session.h</strong> pour lire et &#233;crire dans les
      sessions. Les modules tels que <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code>
      utilisent ce m&#233;canisme.
      </dd>

      <dt>Programmes CGI et langages de script</dt>
      <dd>Les applications qui s'ex&#233;cutent au sein du serveur web
      peuvent &#233;ventuellement extraire la valeur de la session de la
      variable d'environnement <strong>HTTP_SESSION</strong>. La session
      doit &#234;tre cod&#233;e sous la forme d'une cha&#238;ne
      <strong>application/x-www-form-urlencoded</strong> selon les
      pr&#233;conisations de la <a href="http://www.w3.org/TR/html4/">specification HTML</a>. Cette
      variable d'environnement est d&#233;finie via la directive <code class="directive"><a href="#sessionenv">SessionEnv</a></code>. Un script peut &#233;crire
      dans la session en renvoyant un en-t&#234;te de r&#233;ponse
      <strong>application/x-www-form-urlencoded</strong> dont le nom est
      d&#233;fini via la directive <code class="directive"><a href="#sessionheader">SessionHeader</a></code>. Dans les deux cas,
      tout chiffrement ou d&#233;chiffrement, ainsi que la lecture ou
      l'&#233;criture de ou vers la session &#224; partir du m&#233;canisme de stockage
      choisi sont g&#233;r&#233;s par le module <code class="module"><a href="../mod/mod_session.html">mod_session</a></code> et la
      configuration correspondante.
      </dd>

      <dt>Applications situ&#233;es derri&#232;re <code class="module"><a href="../mod/mod_proxy.html">mod_proxy</a></code></dt>
      <dd>Si la directive <code class="directive"><a href="#sessionheader">SessionHeader</a></code> est utilis&#233;e pour
      d&#233;finir un en-t&#234;te de requ&#234;te HTTP, la session cod&#233;e sous la forme
      d'une cha&#238;ne <strong>application/x-www-form-urlencoded</strong>
      sera accessible pour l'application. Si ce m&#234;me en-t&#234;te est fourni
      dans la r&#233;ponse, sa valeur sera utilis&#233;e pour remplacer la
      session. Comme pr&#233;c&#233;demment, tout chiffrement ou d&#233;chiffrement,
      ainsi que la lecture ou
      l'&#233;criture de ou vers la session &#224; partir du m&#233;canisme de stockage
      choisi sont g&#233;r&#233;s par le module <code class="module"><a href="../mod/mod_session.html">mod_session</a></code> et la
      configuration correspondante.</dd>

      <dt>Applications ind&#233;pendantes</dt>
      <dd>Les applications peuvent choisir de manipuler la session en
      s'affranchissant du contr&#244;le du serveur HTTP Apache. Dans ce cas,
      c'est l'application qui doit prendre en charge la lecture de la
      session depuis le m&#233;canisme de stockage choisi, son d&#233;chiffrement,
      sa mise &#224; jour, son chiffrement et sa r&#233;&#233;criture vers le m&#233;canisme
      de stockage choisi de mani&#232;re appropri&#233;e.</dd>
      </dl>

    </div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="session" id="session">Directive</a> <a name="Session" id="Session">Session</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Ouvre une session pour le contexte courant</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>Session On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>Session Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">Surcharges autoris&#233;es:</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session</td></tr>
</table>
    <p>La directive <code class="directive">Session</code> permet d'ouvrir une
    session pour le contexte ou conteneur courant. Les directives
    suivantes permettent de d&#233;finir o&#249; la session sera stock&#233;e et
    comment sera assur&#233;e la confidentialit&#233;.</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessionenv" id="sessionenv">Directive</a> <a name="SessionEnv" id="SessionEnv">SessionEnv</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;finit si le contenu de la session doit &#234;tre enregistr&#233;
dans la variable d'environnement <var>HTTP_SESSION</var></td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionEnv On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionEnv Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">Surcharges autoris&#233;es:</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session</td></tr>
</table>
    <p>Lorsque la directive <code class="directive">SessionEnv</code> est
    d&#233;finie &#224; <var>On</var>, le contenu de la session est enregistr&#233;
    dans une variable d'environnement CGI nomm&#233;e
    <var>HTTP_SESSION</var>.</p>

    <p>La cha&#238;ne est &#233;crite sous le m&#234;me format que celui de la cha&#238;ne
    d'arguments d'une URL, comme dans l'exemple suivant :</p>

    <div class="example"><p><code>
      <code>cl&#233;1=foo&amp;cl&#233;3=bar</code>
    </code></p></div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessionexclude" id="sessionexclude">Directive</a> <a name="SessionExclude" id="SessionExclude">SessionExclude</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;finit les pr&#233;fixes d'URLs pour lesquels une session sera
ignor&#233;e</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionExclude <var>chemin</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>none</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session</td></tr>
</table>
    <p>La directive <code class="directive">SessionExclude</code> permet de
    d&#233;finir les pr&#233;fixes d'URLs pour lesquels la session sera
    d&#233;sactiv&#233;e. Ceci peut am&#233;liorer l'efficacit&#233; d'un site web, en
    ciblant de mani&#232;re plus pr&#233;cise l'espace d'URL pour lequel une
    session devra &#234;tre maintenue. Par d&#233;faut, toutes les URLs du
    contexte ou du conteneur courant sont incluses dans la session. La
    directive <code class="directive"><a href="#sessionexclude">SessionExclude</a></code>
    l'emporte sur la directive <code class="directive"><a href="#sessioninclude">SessionInclude</a></code>.</p>

    <div class="warning"><h3>Avertissement</h3>
    <p>Cette directive a un comportement similaire &#224; celui de l'attribut
    <var>chemin</var> des cookies HTTP, mais ne doit pas &#234;tre confondue
    avec cet attribut. En effet, cette directive ne d&#233;finit pas
    l'attribut <var>chemin</var>, qui doit &#234;tre configur&#233;
    s&#233;par&#233;ment.</p></div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessionheader" id="sessionheader">Directive</a> <a name="SessionHeader" id="SessionHeader">SessionHeader</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Importation des mises &#224; jour de session depuis l'en-t&#234;te de
r&#233;ponse HTTP sp&#233;cifi&#233;</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionHeader <var>en-t&#234;te</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>none</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">Surcharges autoris&#233;es:</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session</td></tr>
</table>
    <p>La directive <code class="directive">SessionHeader</code> permet de
    d&#233;finir le nom d'un en-t&#234;te de r&#233;ponse HTTP qui, s'il est pr&#233;sent,
    sera lu et son contenu &#233;crit dans la session courante.</p>

    <p>Le contenu de l'en-t&#234;te doit se pr&#233;senter sous le m&#234;me format que
    celui de la cha&#238;ne d'arguments d'une URL, comme dans l'exemple
    suivant :</p>

    <div class="example"><p><code>
      <code>cl&#233;1=foo&amp;cl&#233;2=&amp;cl&#233;3=bar</code>
    </code></p></div>

    <p>Si une cl&#233; a pour valeur la cha&#238;ne vide, elle sera supprim&#233;e de
    la session.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessioninclude" id="sessioninclude">Directive</a> <a name="SessionInclude" id="SessionInclude">SessionInclude</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;finit les pr&#233;fixes d'URL pour lesquels une session est
valide</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionInclude <var>chemin</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>toutes URLs</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">Surcharges autoris&#233;es:</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session</td></tr>
</table>
    <p>La directive <code class="directive">SessionInclude</code> permet de
    d&#233;finir les pr&#233;fixes d'URL sp&#233;cifiques pour lesquels une session
    sera valide. Ceci peut am&#233;liorer l'efficacit&#233; d'un site web, en
    ciblant de mani&#232;re plus pr&#233;cise l'espace d'URL pour lequel une
    session devra &#234;tre maintenue. Par d&#233;faut, toutes les URLs du
    contexte ou du conteneur courant sont incluses dans la session.</p>

    <div class="warning"><h3>Avertissement</h3>
    <p>Cette directive a un comportement similaire &#224; celui de l'attribut
    <var>chemin</var> des cookies HTTP, mais ne doit pas &#234;tre confondue
    avec cet attribut. En effet, cette directive ne d&#233;finit pas
    l'attribut <var>chemin</var>, qui doit &#234;tre configur&#233; s&#233;par&#233;ment.</p></div>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessionmaxage" id="sessionmaxage">Directive</a> <a name="SessionMaxAge" id="SessionMaxAge">SessionMaxAge</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;finit une dur&#233;e de vie maximale pour la session en
secondes</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionMaxAge <var>dur&#233;e de vie maximale</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionMaxAge 0</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">Surcharges autoris&#233;es:</a></th><td>AuthConfig</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session</td></tr>
</table>
    <p>La directive <code class="directive">SessionMaxAge</code> permet de
    d&#233;finir la dur&#233;e maximale pendant laquelle une session restera
    valide. Lorsqu'une session est sauvegard&#233;e, cette dur&#233;e est
    r&#233;initialis&#233;e et la session peut continuer d'exister. Si la dur&#233;e
    d'une session d&#233;passe cette limite sans qu'une requ&#234;te au serveur ne
    vienne la rafra&#238;chir, la session va passer hors d&#233;lai et sera
    supprim&#233;e. Lorsqu'une session est utilis&#233;e pour stocker les
    informations de connexion d'un utilisateur, ceci aura pour effet de
    le d&#233;connecter automatiquement apr&#232;s le d&#233;lai sp&#233;cifi&#233;.</p>

    <p>Donner &#224; cette directive la valeur 0 emp&#234;che l'expiration de la
    session.</p>

</div>
</div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_session.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_session.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="../images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/mod/mod_session.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2018 The Apache Software Foundation.<br />Autoris&#233; sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>