<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>mod_session_dbd - Serveur HTTP Apache Version 2.4</title>
<link href="../style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="../style/css/prettify.css" />
<script src="../style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="../images/favicon.ico" rel="shortcut icon" /></head>
<body>
<div id="page-header">
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p>
<p class="apache">Serveur HTTP Apache Version 2.4</p>
<img alt="" src="../images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="../">Version 2.4</a> &gt; <a href="./">Modules</a></div>
<div id="page-content">
<div id="preamble"><h1>Module Apache mod_session_dbd</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_session_dbd.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_session_dbd.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div>
<table class="module"><tr><th><a href="module-dict.html#Description">Description:</a></th><td>Support des session bas&#233; sur DBD/SQL</td></tr>
<tr><th><a href="module-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">Identificateur&#160;de&#160;Module:</a></th><td>session_dbd_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">Fichier&#160;Source:</a></th><td>mod_session_dbd.c</td></tr>
<tr><th><a href="module-dict.html#Compatibility">Compatibilit&#233;:</a></th><td>Disponible depuis la version 2.3 d'Apache</td></tr></table>
<h3>Sommaire</h3>

    <div class="warning"><h3>Avertissement</h3>
      <p>Les modules de session font usage des cookies HTTP, et peuvent
      &#224; ce titre &#234;tre victimes d'attaques de type Cross Site Scripting,
      ou divulguer des informations &#224; caract&#232;re priv&#233; aux clients.
      Veuillez vous assurer que les risques ainsi encourus ont &#233;t&#233; pris
      en compte avant d'activer le support des sessions sur votre
      serveur.</p>
    </div>

    <p>Ce sous-module du module <code class="module"><a href="../mod/mod_session.html">mod_session</a></code> fournit le
    support du stockage des sessions utilisateur dans une base de
    donn&#233;es SQL en utilisant le module <code class="module"><a href="../mod/mod_dbd.html">mod_dbd</a></code>.</p>

    <p>Les sessions sont soit <strong>anonymes</strong>, et la session
    est alors identifi&#233;e par un UUID unique stock&#233; dans un cookie au
    niveau du navigateur, soit <strong>propres &#224; l'utilisateur</strong>,
    et la session est alors identifi&#233;e par l'identifiant de
    l'utilisateur connect&#233;.</p>

    <p>Les sessions bas&#233;es sur SQL sont dissimul&#233;es au navigateur, et
    permettent ainsi de pr&#233;server la confidentialit&#233; sans avoir recours
    au chiffrement.</p>

    <p>Plusieurs serveurs web d'une for&#234;t de serveurs peuvent choisir de
    partager une base de donn&#233;es, et ainsi partager les sessions entre
    eux.</p>

    <p>Pour plus de d&#233;tails &#224; propos de l'interface des sessions, voir
    la documentation du module <code class="module"><a href="../mod/mod_session.html">mod_session</a></code>.</p>

</div>
<div id="quickview"><a href="https://www.apache.org/foundation/contributing.html" class="badge"><img src="https://www.apache.org/images/SupportApache-small.png" alt="Support Apache!" /></a><h3>Sujets</h3>
<ul id="topics">
<li><img alt="" src="../images/down.gif" /> <a href="#dbdconfig">Configuration de DBD</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#anonymous">Sessions anonymes</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#peruser">Sessions propres &#224; un
    utilisateur</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#housekeeping">Nettoyage de la base de
    donn&#233;es</a></li>
</ul><h3 class="directives">Directives</h3>
<ul id="toc">
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdcookiename">SessionDBDCookieName</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdcookiename2">SessionDBDCookieName2</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdcookieremove">SessionDBDCookieRemove</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbddeletelabel">SessionDBDDeleteLabel</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdinsertlabel">SessionDBDInsertLabel</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdperuser">SessionDBDPerUser</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdselectlabel">SessionDBDSelectLabel</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#sessiondbdupdatelabel">SessionDBDUpdateLabel</a></li>
</ul>
<h3>Traitement des bugs</h3><ul class="seealso"><li><a href="https://www.apache.org/dist/httpd/CHANGES_2.4">Journal des modifications de httpd</a></li><li><a href="https://bz.apache.org/bugzilla/buglist.cgi?bug_status=__open__&amp;list_id=144532&amp;product=Apache%20httpd-2&amp;query_format=specific&amp;order=changeddate%20DESC%2Cpriority%2Cbug_severity&amp;component=mod_session_dbd">Probl&#232;mes connus</a></li><li><a href="https://bz.apache.org/bugzilla/enter_bug.cgi?product=Apache%20httpd-2&amp;component=mod_session_dbd">Signaler un bug</a></li></ul><h3>Voir aussi</h3>
<ul class="seealso">
<li><code class="module"><a href="../mod/mod_session.html">mod_session</a></code></li>
<li><code class="module"><a href="../mod/mod_session_crypto.html">mod_session_crypto</a></code></li>
<li><code class="module"><a href="../mod/mod_session_cookie.html">mod_session_cookie</a></code></li>
<li><code class="module"><a href="../mod/mod_dbd.html">mod_dbd</a></code></li>
<li><a href="#comments_section">Commentaires</a></li></ul></div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="dbdconfig" id="dbdconfig">Configuration de DBD</a></h2>

      <p>Pour que le module <code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code> puisse &#234;tre
      configur&#233; et maintenir une session, il faut tout d'abord
      configurer le module <code class="module"><a href="../mod/mod_dbd.html">mod_dbd</a></code> pour que le serveur
      puisse ex&#233;cuter des requ&#234;tes vers la base de donn&#233;es.</p>

      <p>Quatre types de requ&#234;tes sont n&#233;cessaires pour maintenir une
      session, s&#233;lectionner ou mettre &#224; jour une session existante,
      ins&#233;rer une nouvelle session et supprimer une session vide ou
      arriv&#233;e &#224; expiration. Ces requ&#234;tes sont configur&#233;es comme dans
      l'exemple suivant :</p>

      <div class="example"><h3>Exemple de configuration de DBD</h3><pre class="prettyprint lang-config">DBDriver pgsql
DBDParams "dbname=apachesession user=apache password=xxxxx host=localhost"
DBDPrepareSQL "delete from session where key = %s" deletesession
DBDPrepareSQL "update session set value = %s, expiry = %lld, key = %s where key = %s" updatesession
DBDPrepareSQL "insert into session (value, expiry, key) values (%s, %lld, %s)" insertsession
DBDPrepareSQL "select value from session where key = %s and (expiry = 0 or expiry &gt; %lld)" selectsession
DBDPrepareSQL "delete from session where expiry != 0 and expiry &lt; %lld" cleansession</pre>
</div>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="anonymous" id="anonymous">Sessions anonymes</a></h2>

      <p>Les sessions anonymes sont identifi&#233;es par un UUID unique, et
      stock&#233;es dans un cookie au niveau du navigateur. Cette m&#233;thode est
      similaire &#224; celle utilis&#233;e par la plupart des serveurs
      d'applications pour stocker les informations de session.</p>

      <p>Pour cr&#233;er une session anonyme, la stocker dans une table de
      base de donn&#233;e postgres nomm&#233;e <var>apachesession</var>, et
      sauvegarder l'identifiant de session dans un cookie nomm&#233;
      <var>session</var>, configurez la session comme suit :</p>

      <div class="example"><h3>Session anonyme bas&#233;e sur SQL</h3><pre class="prettyprint lang-config">Session On
SessionDBDCookieName session path=/</pre>
</div>

      <p>Pour plus d'exemples sur la mani&#232;re dont une application CGI
      peut acc&#233;der aux informations de session, voir la section exemples
      de la documentation du module <code class="module"><a href="../mod/mod_session.html">mod_session</a></code>.</p>

      <p>Pour des d&#233;tails sur la mani&#232;re dont une session peut &#234;tre
      utilis&#233;e pour stocker des informations de type nom
      d'utilisateur/mot de passe, voir la documentation du module
      <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code>.</p>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="peruser" id="peruser">Sessions propres &#224; un
    utilisateur</a></h2>

      <p>Les sessions propres &#224; un utilisateur sont identifi&#233;es par le
      nom de l'utilisateur authentifi&#233; avec succ&#232;s. Ceci permet
      d'assurer une confidentialit&#233; optimale, car aucun traitement
      externe &#224; la session n'existe en dehors du contexte
      authentifi&#233;.</p>

      <p>Les sessions propres &#224; un utilisateur ne fonctionnent que dans
      un environnement d'authentification correctement configur&#233;, qu'il
      s'agisse d'une authentification de base, &#224; base de condens&#233;s
      (digest) ou de certificats client SSL. Suite &#224; des limitations
      dues &#224; des d&#233;pendances mutuelles, les sessions propres &#224; un
      utilisateur ne peuvent pas &#234;tre utilis&#233;es pour stocker les donn&#233;es
      d'authentification en provenance d'un module comme
      <code class="module"><a href="../mod/mod_auth_form.html">mod_auth_form</a></code>.</p>

      <p>Pour cr&#233;er une session propre &#224; un utilisateur, la stocker dans
      une table de base de donn&#233;es postgres nomm&#233;e
      <var>apachesession</var>, avec comme cl&#233; de session l'identifiant
      utilisateur, ajoutez les lignes suivantes :</p>

      <div class="example"><h3>Session propre &#224; un utilisateur bas&#233;e sur SQL</h3><pre class="prettyprint lang-config">Session On
SessionDBDPerUser On</pre>
</div>

    </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="housekeeping" id="housekeeping">Nettoyage de la base de
    donn&#233;es</a></h2>
      <p>Avec le temps, la base de donn&#233;es va commencer &#224; accumuler des
      sessions expir&#233;es. Pour le moment, le module
      <code class="module"><a href="../mod/mod_session_dbd.html">mod_session_dbd</a></code> n'est pas en mesure de g&#233;rer
      automatiquement l'expiration des sessions.</p>

      <div class="warning"><h3>Avertissement</h3>
      <p>L'administrateur devra mettre en oeuvre un traitement externe
      via cron pour nettoyer les sessions expir&#233;es.</p>
      </div>

    </div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdcookiename" id="sessiondbdcookiename">Directive</a> <a name="SessionDBDCookieName" id="SessionDBDCookieName">SessionDBDCookieName</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Nom et attributs du cookie RFC2109 qui contient
l'identifiant de session</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDCookieName <var>nom</var> <var>attributs</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>none</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDCookieName</code> permet
    de sp&#233;cifier le nom et les attributs optionnels d'un cookie
    compatible RFC2109 qui contiendra l'identifiant de session. Les
    cookies RFC2109 sont d&#233;finis &#224; l'aide de l'en-t&#234;te HTTP
    <code>Set-Cookie</code>.
    </p>

    <p>Une liste optionnelle d'attributs peut &#234;tre sp&#233;cifi&#233;e pour ce
    cookie, comme dans l'exemple ci-dessous. Ces attributs sont ins&#233;r&#233;s
    dans le cookie tels quels, et ne sont pas interpr&#233;t&#233;s par Apache.
    Assurez-vous que vos attributs sont d&#233;finis correctement selon la
    sp&#233;cification des cookies.
    </p>

    <div class="example"><h3>Cookie avec attributs</h3><pre class="prettyprint lang-config">Session On
SessionDBDCookieName session path=/private;domain=example.com;httponly;secure;version=1;</pre>
</div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdcookiename2" id="sessiondbdcookiename2">Directive</a> <a name="SessionDBDCookieName2" id="SessionDBDCookieName2">SessionDBDCookieName2</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Nom et attributs du cookie RFC2965 qui contient
l'identifiant de session</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDCookieName2 <var>nom</var> <var>attributs</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>none</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDCookieName2</code> permet
    de sp&#233;cifier le nom et les attributs optionnels d'un cookie
    compatible RFC2965 qui contiendra l'identifiant de session. Les
    cookies RFC2965 sont d&#233;finis &#224; l'aide de l'en-t&#234;te HTTP
    <code>Set-Cookie2</code>.
    </p>

    <p>Une liste optionnelle d'attributs peut &#234;tre sp&#233;cifi&#233;e pour ce
    cookie, comme dans l'exemple ci-dessous. Ces attributs sont ins&#233;r&#233;s
    dans le cookie tel quel, et ne sont pas interpr&#233;t&#233;s par Apache.
    Assurez-vous que vos attributs sont d&#233;finis correctement selon la
    sp&#233;cification des cookies.
    </p>

    <div class="example"><h3>Cookie2 avec attributs</h3><pre class="prettyprint lang-config">Session On
SessionDBDCookieName2 session path=/private;domain=example.com;httponly;secure;version=1;</pre>
</div>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdcookieremove" id="sessiondbdcookieremove">Directive</a> <a name="SessionDBDCookieRemove" id="SessionDBDCookieRemove">SessionDBDCookieRemove</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>D&#233;termine si les cookies de session doivent &#234;tre supprim&#233;s
des en-t&#234;tes HTTP entrants</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDCookieRemove On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionDBDCookieRemove On</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDCookieRemove</code> permet
    de d&#233;terminer si les cookies contenant l'identifiant de session
    doivent &#234;tre supprim&#233;s des en-t&#234;tes pendant le traitement de la
    requ&#234;te.</p>

    <p>Dans le cas d'un mandataire inverse o&#249; le serveur Apache sert de
    frontal &#224; un serveur d'arri&#232;re-plan, r&#233;v&#233;ler le contenu du cookie de
    session &#224; ce dernier peut conduire &#224; une violation de la
    confidentialit&#233;. &#192; ce titre, si cette directive est d&#233;finie &#224; "on",
    le cookie de session sera supprim&#233; des en-t&#234;tes HTTP entrants.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbddeletelabel" id="sessiondbddeletelabel">Directive</a> <a name="SessionDBDDeleteLabel" id="SessionDBDDeleteLabel">SessionDBDDeleteLabel</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La requ&#234;te SQL &#224; utiliser pour supprimer des sessions de la
base de donn&#233;es</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDDeleteLabel <var>&#233;tiquette</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionDBDDeleteLabel deletesession</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDDeleteLabel</code> permet
    de d&#233;finir l'&#233;tiquette de la requ&#234;te de suppression &#224; utiliser par
    d&#233;faut pour supprimer une session vide ou expir&#233;e. Cette
    &#233;tiquette doit avoir &#233;t&#233; d&#233;finie au pr&#233;alable via une directive
    <code class="directive"><a href="../mod/mod_dbd.html#dbdpreparesql">DBDPrepareSQL</a></code>.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdinsertlabel" id="sessiondbdinsertlabel">Directive</a> <a name="SessionDBDInsertLabel" id="SessionDBDInsertLabel">SessionDBDInsertLabel</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La requ&#234;te SQL &#224; utiliser pour ins&#233;rer des sessions dans la
base de donn&#233;es</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDInsertLabel <var>&#233;tiquette</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionDBDInsertLabel insertsession</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDInsertLabel</code> permet
    de d&#233;finir l'&#233;tiquette de la requ&#234;te d'insertion par d&#233;faut &#224;
    charger dans une session. Cette
    &#233;tiquette doit avoir &#233;t&#233; d&#233;finie au pr&#233;alable via une directive
    <code class="directive"><a href="../mod/mod_dbd.html#dbdpreparesql">DBDPrepareSQL</a></code>.</p>

    <p>Si une tentative de mise &#224; jour d'une session ne concerne aucun
    enregistrement, c'est cette requ&#234;te qui sera utilis&#233;e pour ins&#233;rer
    la session dans la base de donn&#233;es.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdperuser" id="sessiondbdperuser">Directive</a> <a name="SessionDBDPerUser" id="SessionDBDPerUser">SessionDBDPerUser</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>Active une session propre &#224; un utilisateur</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDPerUser On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionDBDPerUser Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDPerUser</code> permet
    d'activer une session propre &#224; un utilisateur, dont la cl&#233; sera le
    nom de l'utilisateur connect&#233;. Si l'utilisateur n'est pas connect&#233;,
    la directive sera ignor&#233;e.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdselectlabel" id="sessiondbdselectlabel">Directive</a> <a name="SessionDBDSelectLabel" id="SessionDBDSelectLabel">SessionDBDSelectLabel</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La requ&#234;te SQL &#224; utiliser pour s&#233;lectionner des sessions
dans la base de donn&#233;es</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDSelectLabel <var>&#233;tiquette</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionDBDSelectLabel selectsession</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDSelectLabel</code> permet
    de d&#233;finir l'&#233;tiquette de la requ&#234;te de s&#233;lection par d&#233;faut &#224;
    utiliser pour charger une session. Cette &#233;tiquette doit avoir &#233;t&#233;
    d&#233;finie au pr&#233;alable via une directive <code class="directive"><a href="../mod/mod_dbd.html#dbdpreparesql">DBDPrepareSQL</a></code>.</p>


</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="sessiondbdupdatelabel" id="sessiondbdupdatelabel">Directive</a> <a name="SessionDBDUpdateLabel" id="SessionDBDUpdateLabel">SessionDBDUpdateLabel</a></h2>
<table class="directive">
<tr><th><a href="directive-dict.html#Description">Description:</a></th><td>La requ&#234;te SQL &#224; utiliser pour mettre &#224; jour des sessions
pr&#233;existantes dans la base de donn&#233;es</td></tr>
<tr><th><a href="directive-dict.html#Syntax">Syntaxe:</a></th><td><code>SessionDBDUpdateLabel <var>&#233;tiquette</var></code></td></tr>
<tr><th><a href="directive-dict.html#Default">D&#233;faut:</a></th><td><code>SessionDBDUpdateLabel updatesession</code></td></tr>
<tr><th><a href="directive-dict.html#Context">Contexte:</a></th><td>configuration globale, serveur virtuel, r&#233;pertoire, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Status">Statut:</a></th><td>Extension</td></tr>
<tr><th><a href="directive-dict.html#Module">Module:</a></th><td>mod_session_dbd</td></tr>
</table>
    <p>La directive <code class="directive">SessionDBDUpdateLabel</code> permet
    de d&#233;finir l'&#233;tiquette de la requ&#234;te de mise &#224; jour par d&#233;faut &#224;
    charger dans une session. Cette
    &#233;tiquette doit avoir &#233;t&#233; d&#233;finie au pr&#233;alable via une directive
    <code class="directive"><a href="../mod/mod_dbd.html#dbdpreparesql">DBDPrepareSQL</a></code>.</p>

    <p>Si une tentative de mise &#224; jour d'une session ne concerne aucun
    enregistrement, c'est la requ&#234;te d'insertion qui sera appel&#233;e pour
    ins&#233;rer la session dans la base de donn&#233;es. Si la base de donn&#233;es
    supporte InsertOrUpdate, modifiez cette requ&#234;te pour effectuer la
    mise &#224; jour en une seule requ&#234;te au lieu de deux.</p>


</div>
</div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="../en/mod/mod_session_dbd.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/mod/mod_session_dbd.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="../images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/mod/mod_session_dbd.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2018 The Apache Software Foundation.<br />Autoris&#233; sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>