<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>Chiffrement SSL/TLS fort :  Introduction - Serveur HTTP Apache Version 2.4</title>
<link href="../style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="../style/css/prettify.css" />
<script src="../style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="../images/favicon.ico" rel="shortcut icon" /></head>
<body id="manual-page"><div id="page-header">
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p>
<p class="apache">Serveur HTTP Apache Version 2.4</p>
<img alt="" src="../images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="../">Version 2.4</a> &gt; <a href="./">SSL/TLS</a></div><div id="page-content"><div id="preamble"><h1>Chiffrement SSL/TLS fort :  Introduction</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="../en/ssl/ssl_intro.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/ssl/ssl_intro.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a> |
<a href="../ja/ssl/ssl_intro.html" hreflang="ja" rel="alternate" title="Japanese">&nbsp;ja&nbsp;</a></p>
</div>


<p>Ce chapitre en guise d'introduction est destin&#233; aux lecteurs pour lesquels
le Web, HTTP et Apache sont familiers, mais ne sont pas des experts en mati&#232;re
de s&#233;curit&#233;. Il n'a pas la pr&#233;tention d'&#234;tre un guide d&#233;taill&#233; sur le
protocole SSL, il ne traitera pas non plus des techniques sp&#233;cifiques de gestion
des certificats dans une organisation, ni des importants probl&#232;mes l&#233;gaux de
brevets ou des restrictions d'importation ou d'exportation. Il se veut plut&#244;t
une base de travail pour les utilisateurs de <code class="module"><a href="../mod/mod_ssl.html">mod_ssl</a></code> en
rassemblant diff&#233;rents concepts, d&#233;finitions et exemples comme point de d&#233;part
pour une exploration plus d&#233;taill&#233;e.</p>

</div>
<div id="quickview"><a href="https://www.apache.org/foundation/contributing.html" class="badge"><img src="https://www.apache.org/images/SupportApache-small.png" alt="Support Apache!" /></a><ul id="toc"><li><img alt="" src="../images/down.gif" /> <a href="#cryptographictech">Techniques de chiffrement</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#certificates">Certificats</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#ssl">Couche Points d'Acc&#232;s S&#233;curis&#233;s - Secure Sockets Layer (SSL)</a></li>
<li><img alt="" src="../images/down.gif" /> <a href="#references">R&#233;f&#233;rences</a></li>
</ul><h3>Voir aussi</h3><ul class="seealso"><li><a href="#comments_section">Commentaires</a></li></ul></div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="cryptographictech" id="cryptographictech">Techniques de chiffrement</a></h2>

<p>La ma&#238;trise de SSL n&#233;cessite la compr&#233;hension des algorithmes de
chiffrement, des fonctions relatives aux empreintes de messages (comme les
fonctions de type hash ou non r&#233;versibles), et des signatures num&#233;riques. Ces
techniques pourraient faire l'objet d'un ouvrage &#224; elles seules (voir par
exemple [<a href="#AC96">AC96</a>]) et constituent les bases de la
confidentialit&#233;, de l'int&#233;grit&#233; et de l'authentification.</p>

<h3><a name="cryptographicalgo" id="cryptographicalgo">Algorithmes de chiffrement</a></h3>

    <p>Supposons qu'Alice veuille envoyer un message &#224; sa banque pour
    transf&#233;rer une certaine somme. Alice souhaiterait que le message soit
    priv&#233;, car il contient des informations comme son num&#233;ro de compte et le
    montant du transfert. Une solution consisterait &#224; utiliser un algorithme de
    chiffrement, technique qui permet de remplacer un message par sa version
    chiffr&#233;e, illisible jusqu'&#224; ce qu'elle soit d&#233;chiffr&#233;e.
    Sous sa forme chiffr&#233;e,
    le message ne peut &#234;tre d&#233;chiffr&#233; qu'en utilisant une cl&#233; secr&#232;te. Sans la
    cl&#233;, le message est inutilisable : les bons algorithmes de chiffrement
    rendent si difficile la restitution du texte original par des intrus que
    ceux-ci y gaspilleraient leurs efforts.</p>

    <p>Il existe deux cat&#233;gories d'algorithmes de chiffrement : conventionnel
    ou &#224; cl&#233; publique.</p>

    <dl>
    <dt>Chiffrement conventionnel</dt>
    <dd>aussi connu sous le nom de chiffrement sym&#233;trique, il n&#233;cessite le
    partage d'une cl&#233; entre l'exp&#233;diteur et le destinataire : une portion
    d'information secr&#232;te permettant de chiffrer et d&#233;chiffrer un message.
    Tant que cette cl&#233; reste secr&#232;te, personne &#224; part l'exp&#233;diteur et le
    destinataire ne peut lire le message. Si Alice et sa banque partagent une
    cl&#233; secr&#232;te, ils peuvent donc s'envoyer l'un &#224; l'autre des messages priv&#233;s.
    Le fait de partager une cl&#233; entre l'exp&#233;diteur et le destinataire avant
    de communiquer, tout en la maintenant secr&#232;te vis &#224; vis des autres, peut
    toutefois poser des probl&#232;mes.</dd>

    <dt>Chiffrement &#224; cl&#233; publique</dt>
    <dd>aussi connu sous le nom de chiffrement asym&#233;trique, il r&#233;soud le
    probl&#232;me d'&#233;change de cl&#233; en d&#233;finissant un algorithme qui utilise deux
    cl&#233;s, chacune d'entre elles pouvant &#234;tre utilis&#233;e pour chiffrer un message.
    Si une des cl&#233;s a &#233;t&#233; utilis&#233;e pour chiffrer le message, on doit utiliser
    l'autre cl&#233; pour le d&#233;chiffrer. Il est ainsi possible de recevoir des
    messages s&#233;curis&#233;s simplement en rendant publique une des cl&#233;s (la cl&#233;
    publique), et en gardant l'autre cl&#233; secr&#232;te (la cl&#233; priv&#233;e).</dd>
    </dl>

    <p>Tout le monde peut chiffrer un message en utilisant la cl&#233; publique,
    mais seul le propri&#233;taire de la cl&#233; priv&#233;e sera en mesure de le lire. De
    cette fa&#231;on, Alice peut envoyer des messages priv&#233;s au propri&#233;taire d'une
    paire de cl&#233;s (sa banque), en les chiffrant &#224; l'aide de la cl&#233; publique.
    Seule la banque sera en mesure de les d&#233;chiffrer.</p>


<h3><a name="messagedigests" id="messagedigests">Empreinte d'un message</a></h3>

    <p>Bien qu'Alice puisse chiffrer son message pour le rendre priv&#233;, il
    subsiste toujours le risque que quelqu'un puisse modifier le message
    original ou le remplacer par un autre, afin d'effectuer le transfert de
    fonds &#224; son profit, par exemple. Une solution pour garantir l'int&#233;grit&#233; du
    message consisterait pour Alice &#224; cr&#233;er un r&#233;sum&#233; concentr&#233; de son message
    qu'elle enverrait &#224; sa banque avec ce dernier. A la r&#233;ception du message,
    la banque cr&#233;e son propre r&#233;sum&#233; et le compare avec celui qu'Alice a
    envoy&#233;. Si les deux r&#233;sum&#233;s sont identiques, le message re&#231;u n'a pas
    &#233;t&#233; modifi&#233;.</p>

    <p>Un r&#233;sum&#233; tel que celui-ci est appel&#233;
    <dfn>empreinte num&#233;rique de message</dfn> (message digest),
    <em>fonction irr&#233;versible</em> (one-way function) ou
    <em>fonction de hashage</em> (hash function). Une empreinte de message
    constitue une repr&#233;sentation courte et de longueur fixe, d'un message plus
    long et de longueur variable. Les algorithmes de cr&#233;ation d'empreintes sont
    con&#231;us pour produire une empreinte unique pour chaque message. Les
    empreintes de messages sont con&#231;ues pour que la restitution du message
    &#224; partir de l'empreinte soit d'une difficult&#233; insurmontable, et qu'il soit
    (en th&#233;orie) impossible de trouver deux messages diff&#233;rents qui produisent
    la m&#234;me empreinte -- ce qui &#233;limine la possibilit&#233; de remplacer un message
    par un autre en conservant la m&#234;me empreinte.</p>

    <p>Trouver le moyen d'envoyer l'empreinte de mani&#232;re s&#233;curis&#233;e &#224; la banque
    constitue un autre d&#233;fit auquel Alice doit faire face ; si l'empreinte
    n'est pas envoy&#233;e de mani&#232;re s&#233;curis&#233;e, son int&#233;grit&#233; peut &#234;tre compromise,
    et avec elle, la possibilit&#233; pour la banque de v&#233;rifier l'int&#233;grit&#233; du
    message original. L'int&#233;grit&#233; du message ne peut &#234;tre v&#233;rifi&#233;e que si
    l'empreinte qui lui est associ&#233;e est envoy&#233;e de mani&#232;re s&#233;curis&#233;e.</p>

    <p>Une solution pour envoyer l'empreinte de mani&#232;re s&#233;curis&#233;e consiste &#224;
    l'inclure dans une signature num&#233;rique.</p>


<h3><a name="digitalsignatures" id="digitalsignatures">Signatures num&#233;riques</a></h3>
<p>Quand Alice envoie un message &#224; sa banque, cette derni&#232;re doit s'assurer
que le message a bien &#233;t&#233; envoy&#233; par elle, pour &#233;viter qu'un intrus puisse
effectuer une transaction sur son compte. Une <em>signature num&#233;rique</em>,
cr&#233;&#233;e par Alice et incluse dans le message, permet d'atteindre cet
objectif.</p>

<p>Les signatures num&#233;riques peuvent &#234;tre cr&#233;&#233;es en chiffrant une empreinte de
message, ainsi que d'autres informations (comme un num&#233;ro d'ordre) avec la cl&#233;
priv&#233;e de l'exp&#233;diteur. Bien que tout le monde puisse <em>d&#233;chiffrer</em> la
signature &#224; l'aide de la cl&#233; publique, seul l'exp&#233;diteur connait la cl&#233; priv&#233;e.
Ce qui implique que seul l'exp&#233;diteur peut avoir sign&#233; le message. Inclure
l'empreinte dans la signature entra&#238;ne que cette derni&#232;re n'est valable que
pour ce message ; ceci assure aussi l'int&#233;grit&#233; du message car personne ne
peut modifier l'empreinte et ensuite signer le message.</p>
<p>Afin de se pr&#233;munir contre l'interception et la r&#233;utilisation de la
signature par un intrus quelques jours plus tard, la signature contient un
num&#233;ro d'ordre unique. Ceci prot&#232;ge la banque contre une plainte frauduleuse
de la part d'Alice all&#233;guant qu'elle n'a pas envoy&#233; le message --
elle seule peut l'avoir sign&#233; (non-r&#233;pudiation).</p>


</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="certificates" id="certificates">Certificats</a></h2>

<p>Bien qu'Alice soit parvenue &#224; envoyer un message priv&#233; &#224; sa banque, apr&#232;s
l'avoir sign&#233; et avoir ainsi assur&#233; l'int&#233;grit&#233; du message, elle doit encore v&#233;rifier
qu'elle communique r&#233;ellement avec la banque. C'est &#224; dire qu'elle doit
s'assurer que la cl&#233; publique qu'elle utilise appartient bien &#224; la paire de
cl&#233;s de la banque, et non &#224; celle d'un intrus.
De m&#234;me, la banque doit v&#233;rifier que la
signature du message a bien &#233;t&#233; construite avec la cl&#233; priv&#233;e d'Alice.</p>

<p>Si chaque partie poss&#232;de un certificat qui valide l'identit&#233; de l'autre,
confirme la cl&#233; publique, et est sign&#233; par un organisme de confiance, alors
les deux protagonistes peuvent &#234;tre s&#251;rs que la personne avec laquelle ils
communiquent est bien celle avec laquelle ils d&#233;sirent le faire. Un tel
organisme de confiance s'appelle une <em>Autorit&#233; de Certification</em>, et
on utilise les certificats &#224; des fins d'authentification.</p>

<h3><a name="certificatecontents" id="certificatecontents">Contenu d'un certificat</a></h3>

    <p>Un certificat associe une cl&#233; publique avec l'identit&#233; r&#233;elle d'un
    individu, d'un serveur, ou d'une autre entit&#233; plus connue sous le nom de
    sujet. Comme on le voit dans le <a href="#table1">Tableau 1</a>, les
    information concernant le sujet comprennent des informations
    d'identification (le nom distinctif ou distinguished name - dn), ainsi que
    la cl&#233; publique. Il comporte aussi l'identification et la signature de
    l'autorit&#233; de certification qui a d&#233;livr&#233; le certificat, ainsi que la
    p&#233;riode de validit&#233; de ce dernier. Il peut aussi contenir des informations
    suppl&#233;mentaires (ou extensions) telles que des informations de gestion
    destin&#233;es &#224; l'autorit&#233; de certification, comme un num&#233;ro de s&#233;rie.</p>

    <h4><a name="table1" id="table1">Tableau 1: Information contenues dans un certificat</a></h4>
    
    <table>
    
    <tr><th>Sujet</th>
        <td>Nom distinctif, Cl&#233; publique</td></tr>
    <tr><th>Fournisseur</th>
        <td>Nom distinctif, Signature</td></tr>
    <tr><th>P&#233;riode de validit&#233;</th>
        <td>Pas avant, Pas apr&#232;s</td></tr>
    <tr><th>Informations de gestion</th>
        <td>Version, Num&#233;ro de s&#233;rie</td></tr>
    <tr><th>Extensions</th>
        <td>Contraintes de base, Drapeaux Netscape, etc.</td></tr>
    </table>
    

    <p>Un nom distinctif sert &#224; fournir une identit&#233; dans un contexte
    sp&#233;cifique -- par exemple, un individu peut poss&#233;der un certificat
    personnel, et aussi un certificat en tant qu'employ&#233;. Les noms distinctifs
    doivent respecter le standard X509 [<a href="#X509">X509</a>], qui d&#233;finit
    les champs, les noms de champs, et les abr&#233;viations utilis&#233;es pour faire
    r&#233;f&#233;rence aux champs (voir <a href="#table2">Tableau 2</a>).</p>

    <h4><a name="table2" id="table2">Tableau 2: Informations contenues dans le nom distinctif</a></h4>
    
    <table class="bordered">
    
    <tr><th>Champ du DN</th>
        <th>Abr&#233;v.</th>
        <th>Description</th>
        <th>Exemple</th></tr>
    <tr><td>Nom complet (Common Name)</td>
        <td>CN</td>
        <td>Nom certifi&#233;</td>
        <td>CN=Joe Average</td></tr>
    <tr><td>Organisation or Entreprise</td>
        <td>O</td>
        <td>Nom est associ&#233; &#224; cette<br />organisation</td>
        <td>O=Snake Oil, Ltd.</td></tr>
    <tr><td>Unit&#233; organisationnelle (Organizational Unit)</td>
        <td>OU</td>
        <td>Nom est associ&#233; avec cette <br />unit&#233; organisationnelle,
	par exemple un d&#233;partement</td>
        <td>OU=Research Institute</td></tr>
    <tr><td>Ville/Localisation</td>
        <td>L</td>
        <td>Nom est localis&#233; dans cette ville</td>
        <td>L=Snake City</td></tr>
    <tr><td>Etat/Province</td>
        <td>ST</td>
        <td>Nom est localis&#233; dans cet &#233;tat/province</td>
        <td>ST=Desert</td></tr>
    <tr><td>Pays</td>
        <td>C</td>
        <td>Nom est localis&#233; dans ce pays (code ISO)</td>
        <td>C=XZ</td></tr>
    </table>
    

    <p>Une autorit&#233; de certification peut d&#233;finir une contrainte sp&#233;cifiant
    quels champs du nom distinctif sont optionnels et lesquels sont
    obligatoires. Elle peut aussi imposer des contraintes sur le contenu des
    champs, ce que peuvent aussi faire les utilisateurs de certificats. Par
    exemple, un navigateur Netscape peut exiger, dans le cas d'un certificat
    de serveur, que le nom complet (Common Name) corresponde &#224; un nom g&#233;n&#233;rique
    contenant le nom de domaine du serveur, comme
    <code>*.snakeoil.com</code>.</p>

    <p>Le format binaire d'un certificat est d&#233;fini en utilisant la
    notation ASN.1 [<a href="#ASN1">ASN1</a>] [<a href="#PKCS">PKCS</a>].
    Cette notation definit la mani&#232;re de sp&#233;cifier les contenus, et les r&#232;gles
    d'encodage d&#233;finissent la mani&#232;re dont ces information sont converties au
    format binaire. L'encodage binaire du certificat est d&#233;fini par les R&#232;gles
    d'Encodage Distinctives (Distinguished Encoding Rules - DER), qui se basent
    d'une mani&#232;re plus g&#233;n&#233;rale sur les R&#232;gles d'Encodage de Base (Basic
    Encoding Rules - BER). Pour les transmissions qui ne supportent pas le
    format binaire, ce dernier peut &#234;tre converti au format ASCII en utilisant
    le codage Base64 [<a href="#MIME">MIME</a>]. Lorsqu'il est plac&#233; entre des
    d&#233;limiteurs de d&#233;but et de fin (comme ci-dessous), on dit que le certificat
    est encod&#233; au format PEM ("Privacy Enhanced Mail").</p>

    <div class="example"><h3>Exemple de certificat encod&#233; au format PEM (snakeoil.crt)</h3><pre>-----BEGIN CERTIFICATE-----
MIIC7jCCAlegAwIBAgIBATANBgkqhkiG9w0BAQQFADCBqTELMAkGA1UEBhMCWFkx
FTATBgNVBAgTDFNuYWtlIERlc2VydDETMBEGA1UEBxMKU25ha2UgVG93bjEXMBUG
A1UEChMOU25ha2UgT2lsLCBMdGQxHjAcBgNVBAsTFUNlcnRpZmljYXRlIEF1dGhv
cml0eTEVMBMGA1UEAxMMU25ha2UgT2lsIENBMR4wHAYJKoZIhvcNAQkBFg9jYUBz
bmFrZW9pbC5kb20wHhcNOTgxMDIxMDg1ODM2WhcNOTkxMDIxMDg1ODM2WjCBpzEL
MAkGA1UEBhMCWFkxFTATBgNVBAgTDFNuYWtlIERlc2VydDETMBEGA1UEBxMKU25h
a2UgVG93bjEXMBUGA1UEChMOU25ha2UgT2lsLCBMdGQxFzAVBgNVBAsTDldlYnNl
cnZlciBUZWFtMRkwFwYDVQQDExB3d3cuc25ha2VvaWwuZG9tMR8wHQYJKoZIhvcN
AQkBFhB3d3dAc25ha2VvaWwuZG9tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKB
gQDH9Ge/s2zcH+da+rPTx/DPRp3xGjHZ4GG6pCmvADIEtBtKBFAcZ64n+Dy7Np8b
vKR+yy5DGQiijsH1D/j8HlGE+q4TZ8OFk7BNBFazHxFbYI4OKMiCxdKzdif1yfaa
lWoANFlAzlSdbxeGVHoT0K+gT5w3UxwZKv2DLbCTzLZyPwIDAQABoyYwJDAPBgNV
HRMECDAGAQH/AgEAMBEGCWCGSAGG+EIBAQQEAwIAQDANBgkqhkiG9w0BAQQFAAOB
gQAZUIHAL4D09oE6Lv2k56Gp38OBDuILvwLg1v1KL8mQR+KFjghCrtpqaztZqcDt
2q2QoyulCgSzHbEGmi0EsdkPfg6mp0penssIFePYNI+/8u9HT4LuKMJX15hxBam7
dUHzICxBVC1lnHyYGjDuAMhe396lYAn8bCld1/L4NMGBCQ==
-----END CERTIFICATE-----</pre></div>


<h3><a name="certificateauthorities" id="certificateauthorities">Autorit&#233;s de certification</a></h3>

    <p>En v&#233;rifiant les informations contenues dans une demande de certificat
    avant de l'accorder, l'autorit&#233; de certification s'assure de l'identit&#233; du
    propri&#233;taire de la cl&#233; priv&#233;e issue de sa paire de cl&#233;s. Par exemple, Si
    Alice demande un certificat personnel, l'autorit&#233; de certification doit
    d'abord s'assurer qu'elle correspond vraiment &#224; la personne &#224; laquelle
    la demande de certificat fait r&#233;f&#233;rence.</p>

    <h4><a name="certificatechains" id="certificatechains">Cha&#238;nes de certification</a></h4>
    
        <p>Une autorit&#233; de certification peut aussi &#233;mettre un certificat &#224;
	destination d'une
	autre autorit&#233; de certification. Pour v&#233;rifier un certificat, Alice
	peut &#234;tre amen&#233;e &#224; v&#233;rifier le certificat de l'&#233;metteur pour chaque
	autorit&#233; de certification parente, jusqu'&#224; ce qu'elle en atteigne une
	en qui elle a confiance. Elle peut aussi ne faire confiance qu'aux
	certificats faisant l'objet d'une cha&#238;ne limit&#233;e d'&#233;metteurs, afin
	de r&#233;duire le risque de rencontrer un "mauvais" certificat dans la
	cha&#238;ne.</p>
    

    <h4><a name="rootlevelca" id="rootlevelca">Cr&#233;ation d'une autorit&#233; de certification racine</a></h4>
    
        <p>Comme indiqu&#233; plus haut, chaque certificat n&#233;cessite la validation
	de l'identit&#233; du sujet par un &#233;metteur de certificats
	de niveau sup&#233;rieur, et ceci en
	remontant jusqu'&#224; l'Autorit&#233; de Certification (CA) racine. Ceci pose un
	probl&#232;me : qui va se porter garant du certificat de l'autorit&#233; racine
	qui ne poss&#232;de pas d'&#233;metteur de certificat ? C'est uniquement dans ce
	cas que le certificat est auto-sign&#233;, l'&#233;metteur du certificat et son
	sujet &#233;tant confondus. Les navigateurs sont pr&#233;configur&#233;s avec une
	liste d'autorit&#233;s de certification de confiance, mais il est important
	d'&#234;tre extr&#232;mement prudent avant de faire confiance &#224; un certificat
	auto-sign&#233;. La large publication d'une cl&#233; publique par l'autorit&#233;
	racine r&#233;duit cependant les risques encourus
	en faisant confiance &#224; cette cl&#233; --
	si quelqu'un publiait une cl&#233; en se faisant passer pour l'autorit&#233;, il
	serait vite d&#233;masqu&#233;.</p>

        <p>Quelques compagnies, comme <a href="http://www.thawte.com/">Thawte</a> et <a href="http://www.verisign.com/">VeriSign</a>,
	se sont proclam&#233;es elles-m&#234;mes Autorit&#233;s de Certification. Ces
	compagnies proposent les services suivant :</p>

        <ul>
        <li>V&#233;rification des demandes de certificats</li>
        <li>Traitement des demandes de certificats</li>
        <li>Emission et gestion des certificats</li>
        </ul>

        <p>Vous pouvez aussi cr&#233;er votre propre autorit&#233; de certification. Bien
	que risqu&#233; dans l'environnement de l'Internet, ceci peut s'av&#233;rer utile
	dans un Intranet, o&#249; l'organisme peut v&#233;rifier facilement les identit&#233;s
	des individus et des serveurs.</p>
    

    <h4><a name="certificatemanagement" id="certificatemanagement">Gestion des certificats</a></h4>
    
        <p>Constituer une autorit&#233; de certification repr&#233;sente une
	responsabilit&#233; qui n&#233;cessite une solide infrastructure administrative,
	technique et gestionnaire. Les autorit&#233;s de certification ne se
	contentent pas d'&#233;mettre des certificats, elles doivent aussi les g&#233;rer
	-- &#224; savoir elles d&#233;terminent leur dur&#233;e de validit&#233;, elles les
	renouvellent, et elles maintiennent des listes de certificats qui ont
	&#233;t&#233; &#233;mis dans le pass&#233; mais ne sont plus valides (Listes de r&#233;vocations
	de certificats, ou CRLs).</p>

        <p>Par exemple, si Alice est titulaire d'un certificat en tant
	qu'employ&#233;e d'une compagnie, mais vient de quitter cette compagnie,
	son certificat doit &#234;tre r&#233;voqu&#233;. Comme les certificats ne sont &#233;mis
	qu'apr&#232;s v&#233;rification de l'identit&#233; du sujet, et peuvent &#234;tre envoy&#233;s
	&#224; tous ceux avec lesquels le sujet peut communiquer, il est impossible
	de discerner &#224; partir du seul certificat s'il a &#233;t&#233; r&#233;voqu&#233;. Pour
	v&#233;rifier la validit&#233; d'un certificat, il est donc n&#233;cessaire de
	contacter l'autorit&#233; de certification qui l'a &#233;mis afin de pouvoir
	consulter ses listes de r&#233;vocations de certificats -- ce qui n'est
	en g&#233;n&#233;ral pas une partie automatique du processus.</p>

        <div class="note"><h3>Note</h3>
        <p>Si votre autorit&#233; de certification ne fait pas partie de la liste
	des autorit&#233;s de confiance de votre navigateur, il faut enregistrer le
	certificat de l'autorit&#233; de certification dans ce dernier, ce qui lui
	permettra de valider les certificats de serveurs sign&#233;s par cette
	autorit&#233; de certification. Ceci peut &#234;tre dangereux, car une fois le
	certificat enregistr&#233;, le navigateur acceptera tous les certificats
	sign&#233;s par cette autorit&#233; de certification.</p>
        </div>
    


</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="ssl" id="ssl">Couche Points d'Acc&#232;s S&#233;curis&#233;s - Secure Sockets Layer (SSL)</a></h2>

<p>Le protocole Couche Points d'Acc&#232;s S&#233;curis&#233;s est une couche protocolaire
qui pourrait s'intercaler entre un protocole d'une couche r&#233;seau orient&#233;e
connexion (comme TCP/IP) et une couche protocolaire d'application (comme HTTP).
SSL fournit une communication s&#233;curis&#233;e entre client et serveur en permettant
l'authentification mutuelle, l'utilisation des signatures num&#233;riques pour la
v&#233;rification de l'int&#233;grit&#233; des donn&#233;es, et le chiffrement pour la
confidentialit&#233;.</p>

<p>Ce protocole est con&#231;u pour supporter un grand choix d'algorithmes
sp&#233;cifiques utilis&#233;s pour la cryptographie, les empreintes et les signatures.
Ceci permet la s&#233;lection d'un algorithme pour des serveurs sp&#233;cifiques en
respectant la l&#233;galit&#233;, les r&#232;gles d'exportation ou autres contraintes, et
permet aussi au protocole de tirer parti des nouveaux algorithmes. Ces choix
font l'objet d'une n&#233;gociation entre client et serveur lors de
l'&#233;tablissement de la session protocolaire.</p>

<h3><a name="table4" id="table4">Tableau 4: Versions du protocole SSL</a></h3>

    <table class="bordered">
    
    <tr><th>Version</th>
        <th>Source</th>
        <th>Description</th>
    </tr>
    <tr><td>SSL v2.0</td>
        <td>Standard du fournisseur (de Netscape Corp.)</td>
        <td>Premier protocole SSL pour lequel il existe des impl&#233;mentations</td>
    </tr>
    <tr><td>SSL v3.0</td>
        <td>Projet Internet arriv&#233; &#224; expiration (de Netscape Corp.) [<a href="#SSL3">SSL3</a>]</td>
        <td>Comporte des r&#233;visions permettant de pr&#233;venir certaines attaques de
	s&#233;curit&#233; sp&#233;cifiques, ajout de chiffrements non RSA, et support des
	cha&#238;nes de certification</td>
    </tr>
    <tr><td>TLS v1.0</td>
        <td>Standard propos&#233; pour l'Internet (de l'IETF) [<a href="#TLS1">TLS1</a>]</td>
        <td>R&#233;vision de SSL 3.0 pour mettre &#224; jour la couche MAC vers HMAC,
	ajout du bourrage de bloc pour le chiffrement de bloc, standardisation
	de l'ordonnancement des messages et plus de messages d'alerte.</td>
    </tr>
	<tr><td>TLS v1.1</td>
        <td>Standard propos&#233; pour l'Internet (de l'IETF) [<a href="#TLS11">TLS11</a>]</td>
        <td>Mise &#224; jour de TLS 1.0 pour la protection contre les
	attaques de type Cipher block chaining (CBC).</td>
    </tr>
    <tr><td>TLS v1.2</td>
        <td>Standard propos&#233; pour l'Internet (de l'IETF) [<a href="#TLS12">TLS12</a>]</td>
        <td>Mise &#224; jour de TLS 1.1 rendant les condens&#233;s MD5 obsol&#232;tes,
	et introduisant une incompatibilit&#233; avec SSL ce qui interdit toute
	n&#233;gociation en vue d'une utilisation de SSLv2.</td>
    </tr>
    </table>


<p>Il existe plusieurs versions du protocole SSL, comme le montre le
<a href="#table4">Tableau 4</a>. Comme indiqu&#233; dans ce dernier, un des apports
de SSL 3.0 est le support du chargement des cha&#238;nes de certification. Cette
fonctionnalit&#233; permet &#224; un serveur de passer au navigateur un certificat de
serveur accompagn&#233; du certificat de l'&#233;metteur. Le chargement de la
cha&#238;ne permet aussi au navigateur de valider le certificat du serveur, m&#234;me si
les certificats de l'autorit&#233; de certification ne sont pas install&#233;s pour les
&#233;metteurs interm&#233;diaires, car ils sont inclus dans la cha&#238;ne de certification.
SSL 3.0 sert de base au standard du protocole S&#233;curit&#233; de la Couche Transport
ou Transport Layer Security
[<a href="#TLS1">TLS</a>], actuellement en d&#233;veloppement au sein de
l'Internet Engineering Task Force (IETF).</p>

<h3><a name="session" id="session">Etablissement d'une session</a></h3>

    <p>La session SSL est &#233;tablie en suivant une s&#233;quence d'&#233;changes
    d'informations entre client et serveur, comme le montre la
    <a href="#figure1">Figure 1</a>. Cette s&#233;quence peut varier, selon que
    le serveur est configur&#233; pour fournir un certificat de serveur ou
    r&#233;clame un certificat client. Bien que dans certains cas, des &#233;tapes
    d'&#233;changes d'informations suppl&#233;mentaires soient n&#233;cessaires pour la
    gestion des informations de chiffrement, cet article r&#233;sume un sc&#233;nario
    courant. Se reporter aux sp&#233;cifications SSL pour avoir la liste de
    toutes les possibilit&#233;s.</p>

    <div class="note"><h3>Note</h3>
    <p>Une fois la session SSL &#233;tablie, elle peut &#234;tre r&#233;utilis&#233;e. Ceci
    permet d'&#233;viter la perte de performances due &#224; la r&#233;p&#233;tition des nombreuses
    &#233;tapes n&#233;cessaires &#224; l'&#233;tablissement d'une session. Pour parvenir &#224; ceci,
    le serveur assigne un identifiant de session unique &#224; chaque session SSL ;
    cet identifiant est mis en cache dans le serveur et le client peut
    l'utiliser pour des connexions ult&#233;rieures afin de r&#233;duire la dur&#233;e des
    &#233;changes d'informations (et ceci jusqu'&#224; ce que l'identifiant de session
    arrive &#224; expiration dans le cache du serveur).</p>
    </div>

    <p class="figure">
    <img src="../images/ssl_intro_fig1.gif" alt="" width="423" height="327" /><br />
    <a id="figure1" name="figure1"><dfn>Figure 1</dfn></a> : S&#233;quence
    simplifi&#233;e d'&#233;changes d'informations SSL</p>

    <p>Les &#233;l&#233;ments de la s&#233;quence d'&#233;changes d'informations, tels qu'ils
    sont utilis&#233;s par le client et le serveur, sont &#233;num&#233;r&#233;s ci-apr&#232;s :</p>

    <ol>
    <li>N&#233;gociation de la suite de chiffrement &#224; utiliser durant le transfert des donn&#233;es</li>
    <li>Elaboration et &#233;change d'une cl&#233; de session entre le client et le serveur</li>
    <li>Authentification &#233;ventuelle du serveur par le client</li>
    <li>Authentification &#233;ventuelle du client par le serveur</li>
    </ol>

    <p>La premi&#232;re &#233;tape, la n&#233;gociation de la suite de chiffrement, permet au
    client et au serveur de choisir une suite de chiffrement qu'ils supportent
    tous les deux. La sp&#233;cification du protocole SSL 3.0 d&#233;finit 31 suites de
    chiffrement. Une suite de chiffrement se compose des &#233;l&#233;ments
    suivants :</p>

    <ul>
    <li>M&#233;thode d'&#233;change de la cl&#233;</li>
    <li>Chiffrement du transfert des donn&#233;es</li>
    <li>Empreinte du message servant &#224; cr&#233;er le code d'authentification du
    message (MAC)</li>
    </ul>

    <p>Ces trois &#233;l&#233;ments sont d&#233;crits dans les sections suivantes.</p>


<h3><a name="keyexchange" id="keyexchange">M&#233;thode d'&#233;change de la cl&#233;</a></h3>

    <p>La m&#233;thode d'&#233;change de la cl&#233; d&#233;finit la mani&#232;re
    dont la cl&#233; de chiffrement
    sym&#233;trique secr&#232;te et partag&#233;e utilis&#233;e pour le transfert des donn&#233;es de
    l'application sera accept&#233;e par le client et le serveur. SSL 2.0 utilise
    l'&#233;change de cl&#233; RSA seulement, tandis que SSL 3.0 supporte tout un choix
    d'algorithmes d'&#233;change de cl&#233; incluant l'&#233;change de cl&#233; RSA (quand les
    certificats sont utilis&#233;s), et l'&#233;change de cl&#233;s Diffie-Hellman (pour
    &#233;changer des cl&#233;s sans certificat, ou en l'absence de communication
    pr&#233;alable entre le client et le serveur).</p>

    <p>Les signatures num&#233;riques constituent une variante dans le choix des
    m&#233;thodes d'&#233;change de cl&#233; -- utiliser les signatures ou pas, et dans
    l'affirmative, quel genre de signatures utiliser. La signature &#224; l'aide
    d'une cl&#233; priv&#233;e fournit une protection contre une attaque
    "man-in-the-middle" au cours de laquelle
    l'&#233;change d'informations destin&#233; &#224; g&#233;n&#233;rer la
    cl&#233; partag&#233;e peut &#234;tre intercept&#233; [<a href="#AC96">AC96</a>, p516].</p>


<h3><a name="ciphertransfer" id="ciphertransfer">Chiffrement du transfert de donn&#233;es</a></h3>

    <p>Comme d&#233;crit plus haut, SSL utilise le chiffrement sym&#233;trique
    conventionnel pour chiffrer les messages au cours d'une session. Il existe
    neuf choix possibles pour le chiffrement, y compris l'option du transfert
    non chiffr&#233; :</p>

    <ul>
    <li>Pas de chiffrement</li>
    <li>Chiffrement en continu (Stream Ciphers)
        <ul>
        <li>RC4 avec cl&#233;s de 40 bits</li>
        <li>RC4 avec cl&#233;s de 128 bits</li>
        </ul></li>
    <li>Chiffrement par blocs CBC (CBC Block Ciphers)
        <ul><li>RC2 avec cl&#233; de 40 bits</li>
        <li>DES avec cl&#233; de 40 bits</li>
        <li>DES avec cl&#233; de 56 bits</li>
        <li>Triple-DES avec cl&#233; de 168 bits</li>
        <li>Idea (cl&#233; de 128 bits)</li>
        <li>Fortezza (cl&#233; de 96 bits)</li>
        </ul></li>
    </ul>

    <p>"CBC" signifie Cipher Block Chaining (Cha&#238;nage de blocs chiffr&#233;s),
    c'est &#224; dire qu'une portion du bloc de texte chiffr&#233; pr&#233;c&#233;dent est utilis&#233;e
    pour le chiffrement du bloc courant. "DES" signifie Data Encryption
    Standard (Standard de Chiffrement des Donn&#233;es)
    [<a href="#AC96">AC96</a>, ch12], et poss&#232;de de nombreuses variantes
    (telles que DES40 et 3DES_EDE). Parmi les algorithmes disponibles, "Idea"
    est actuellement un des meilleurs et des plus puissants sur le plan
    cryptographique, et "RC2" est un algorithme propri&#233;taire de RSA DSI
    [<a href="#AC96">AC96</a>, ch13].</p>


<h3><a name="digestfunction" id="digestfunction">Fonction de cr&#233;ation d'empreinte</a></h3>

    <p>Le choix d'une fonction de cr&#233;ation d'empreinte d&#233;termine la mani&#232;re
    dont une empreinte est cr&#233;&#233;e &#224; partir d'une unit&#233; de donn&#233;es. SSL supporte
    les fonctions suivantes :</p>

    <ul>
    <li>Pas d'empreinte (choix Null)</li>
    <li>MD5, une empreinte de 128 bits</li>
    <li>Algorithme d'Empreinte S&#233;curis&#233;e (Secure Hash Algorithm - SHA-1), une
    empreinte de 160 bits</li>
    </ul>

    <p>On utilise l'empreinte de message pour cr&#233;er un Code d'Authentification
    de Message (Message Authentication Code - MAC) qui est chiffr&#233; avec le
    message afin de v&#233;rifier son int&#233;grit&#233; et de se prot&#233;ger contre les
    attaques de type "rejeu".</p>


<h3><a name="handshake" id="handshake">Protocole de la s&#233;quence d'&#233;changes d'informations</a></h3>

    <p>La s&#233;quence d'&#233;changes d'informations utilise trois protocoles :</p>

    <ul>
    <li>Le <dfn>Protocole d'&#233;changes d'informations SSL</dfn> pour &#233;tablir
    la session SSl entre le client et le serveur.</li>
    <li>Le <dfn>Protocole de sp&#233;cification du chiffrement SSL</dfn> pour
    l'agr&#233;ment effectif de la suite de chiffrement &#224; utiliser
    pour la session.</li>
    <li>Le <dfn>Protocole d'alertes SSL</dfn> pour la transmission de
    messages d'erreur SSL entre le client et le serveur.</li>
    </ul>

    <p>Ces protocoles, ainsi que les donn&#233;es du protocole de l'application,
    sont encapsul&#233;s dans le <dfn>Protocole d'enregistrement SSL
    (SSL Record Protocol)</dfn>, comme
    le montre la <a href="#figure2">Figure 2</a>. Un protocole encapsul&#233; est
    tranf&#233;r&#233; en tant que donn&#233;es par le protocole de la couche de niveau
    inf&#233;rieur, qui ne se pr&#233;occupe pas du contenu des donn&#233;es. Le protocole
    encapsul&#233; n'a aucune connaissance du protocole sous-jacent.</p>

    <p class="figure">
    <img src="../images/ssl_intro_fig2.gif" alt="" width="428" height="217" /><br />
    <a id="figure2" name="figure2"><dfn>Figure 2</dfn></a>:
    Pile du protocole SSL</p>

    <p>L'encapsulation des protocoles de contr&#244;le SSL dans le protocole
    d'enregistrement signifie que si une session active est ren&#233;goci&#233;e, les
    protocoles de contr&#244;le seront transmis de mani&#232;re s&#233;curis&#233;e. S'il n'y
    avait pas de session pr&#233;alable, la suite de chiffrement Null est utilis&#233;e,
    ce qui signifie que les messages ne seront pas chiffr&#233;s et ne poss&#232;deront
    pas d'empreinte d'int&#233;grit&#233;, jusqu'&#224; ce que la session ait &#233;t&#233; &#233;tablie.</p>


<h3><a name="datatransfer" id="datatransfer">Transmission des donn&#233;es</a></h3>

    <p>Le protocole d'enregistrement SSL, comme le montre la
    <a href="#figure3">Figure 3</a>, est utilis&#233; pour transmettre les donn&#233;es
    de l'application et les donn&#233;es de contr&#244;le SSL entre le client et le
    serveur, les donn&#233;es &#233;tant n&#233;cessairement fragment&#233;es en &#233;l&#233;ments plus
    petits, ou plusieurs messages de donn&#233;es avec protocole de niveau
    sup&#233;rieur pouvant &#234;tre combin&#233;s en un seul &#233;l&#233;ment. Ce protocole peut
    joindre des signatures d'empreintes, compresser et chiffrer ces &#233;l&#233;ments
    avant de les transmettre en utilisant le protocole fiable de transport
    sous-jacent (Note : actuellement, aucune impl&#233;mentation majeure de SSL
    n'inclut le support de la compression).</p>

    <p class="figure">
    <img src="../images/ssl_intro_fig3.gif" alt="" width="423" height="323" /><br />
    <a id="figure3" name="figure3"><dfn>Figure 3</dfn></a>:
    Protocole d'enregistrement SSL</p>


<h3><a name="securehttp" id="securehttp">S&#233;curisation des communications HTTP</a></h3>

    <p>Une des utilisations courantes de SSL est la s&#233;curisation des
    communication HTTP sur le Web entre un navigateur et un serveur web. Ceci
    n'exclut pas l'utilisation de HTTP non s&#233;curis&#233; - la version s&#233;curis&#233;e
    (appel&#233;e HTTPS) est identique &#224; du vrai HTTP sur SSL,
    mais utilise le pr&#233;fixe
    d'URL <code>https</code> au lieu de <code>http</code>, et un port
    de serveur diff&#233;rent (par d&#233;faut le port 443).
    Ceci constitue pour une large part
    ce qu'apporte <code class="module"><a href="../mod/mod_ssl.html">mod_ssl</a></code> au serveur web Apache.</p>

</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="references" id="references">R&#233;f&#233;rences</a></h2>

<dl>
<dt><a id="AC96" name="AC96">[AC96]</a></dt>
<dd>Bruce Schneier, <q>Applied Cryptography</q>, 2nd Edition, Wiley,
1996. Voir <a href="http://www.counterpane.com/">http://www.counterpane.com/</a> pour diverses autres productions de Bruce
Schneier.</dd>

<dt><a id="ASN1" name="ASN1">[ASN1]</a></dt>
<dd>ITU-T Recommendation X.208, <q>Specification of Abstract Syntax Notation
One (ASN.1)</q>, derni&#232;re mise &#224; jour en 2008. Voir <a href="http://www.itu.int/ITU-T/asn1/">http://www.itu.int/ITU-T/asn1/</a>.
</dd>

<dt><a id="X509" name="X509">[X509]</a></dt>
<dd>ITU-T Recommendation X.509, <q>The Directory - Authentication
Framework</q>. A titre de r&#233;f&#233;rence, voir <a href="http://en.wikipedia.org/wiki/X.509">http://en.wikipedia.org/wiki/X.509</a>.
</dd>

<dt><a id="PKCS" name="PKCS">[PKCS]</a></dt>
<dd><q>Public Key Cryptography Standards (PKCS)</q>,
RSA Laboratories Technical Notes, Voir <a href="http://www.rsasecurity.com/rsalabs/pkcs/">http://www.rsasecurity.com/rsalabs/pkcs/</a>.</dd>

<dt><a id="MIME" name="MIME">[MIME]</a></dt>
<dd>N. Freed, N. Borenstein, <q>Multipurpose Internet Mail Extensions
(MIME) Part One: Format of Internet Message Bodies</q>, RFC2045.
Voir par exemple <a href="http://tools.ietf.org/html/rfc2045">http://tools.ietf.org/html/rfc2045</a>.</dd>

<dt><a id="SSL3" name="SSL3">[SSL3]</a></dt>
<dd>Alan O. Freier, Philip Karlton, Paul C. Kocher, <q>The SSL Protocol
Version 3.0</q>, 1996. Voir <a href="http://www.netscape.com/eng/ssl3/draft302.txt">http://www.netscape.com/eng/ssl3/draft302.txt</a>.</dd>

<dt><a id="TLS1" name="TLS1">[TLS1]</a></dt>
<dd>Tim Dierks, Christopher Allen, <q>The TLS Protocol Version 1.0</q>,
1999. Voir <a href="http://ietf.org/rfc/rfc2246.txt">http://ietf.org/rfc/rfc2246.txt</a>.</dd>

<dt><a id="TLS11" name="TLS11">[TLS11]</a></dt>
<dd><q>Le protocole TLS Version 1.1</q>,
2006. Voir <a href="http://tools.ietf.org/html/rfc4346">http://tools.ietf.org/html/rfc4346</a>.</dd>

<dt><a id="TLS12" name="TLS12">[TLS12]</a></dt>
<dd><q>Le protocole TLS Version 1.2</q>,
2008. Voir <a href="http://tools.ietf.org/html/rfc5246">http://tools.ietf.org/html/rfc5246</a>.</dd>
</dl>
</div></div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="../en/ssl/ssl_intro.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/ssl/ssl_intro.html" title="Fran&#231;ais">&nbsp;fr&nbsp;</a> |
<a href="../ja/ssl/ssl_intro.html" hreflang="ja" rel="alternate" title="Japanese">&nbsp;ja&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="../images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/ssl/ssl_intro.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2018 The Apache Software Foundation.<br />Autoris&#233; sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>